Scriptname TweakDragonBornScript extends Quest Conditional
{renn's Tweak ;TweakDragonBorn}

Bool 			Property Installed 					Auto Conditional
Bool 			Property InSolstiem 				Auto Conditional
Bool 			Property PlayerIsBear 				Auto Conditional

; Actors and Quests
Actor 			Property Frea 						Auto
ActorBase		Property FreaBase 					Auto
ReferenceAlias 	Property FreaRef 					Auto
Quest			Property DLC2MQ02Frea				Auto

Spell[] 		Property SpellMap					Auto 
String[]		Property SpellNames					Auto
Int[]			Property SpellCosts					Auto
Int[]			Property SpellSchools				Auto

; WereBear Abilities
Spell 			Property AbWerebear 				Auto

; WereBear Transform Support
Spell			Property WerebearChange				Auto
Race			Property WerebearRace				Auto

; Bug Fixes
Ammo			Property NordicArrow				Auto
Ammo			Property ElvenArrow					Auto

; Outfits and clothes
Outfit			Property FreaOutfit					Auto

; locations
Location		Property Solstiem					Auto
Location		Property RavenRock					Auto
Location		Property SkallVillage				Auto

; Globals
GlobalVariable	Property FreaWillFollow 			Auto

; AFT (Doesnt need to be reset)
Float 			Property version 					Auto
GlobalVariable	Property pGameDaysPassed 			Auto

Faction			Property TweakHasWBGift				Auto
Faction			Property TweakIgnoreFaction			Auto
Faction			Property TweakPosedFaction			Auto
Faction			Property TweakHangOutFaction		Auto
Faction			Property pDismissedFollowerFaction	Auto

TweakDFScript 		Property pTweakDFScript			Auto
TweakFollowerScript Property pTweakFollowerScript	Auto

Event OnInit()

	Installed			= false
	version				= 1.1
	AllToNone()

endEvent

Bool Function initializeSpellMap()

	if (!installed)
		SpellMap		= new Spell[9] 
		SpellNames		= new String[9]
		SpellCosts		= new Int[9]
		SpellSchools	= new Int[9]
	endif
	
	if (1.0 == version)
		version = 1.1
		SpellSchools	= new Int[9]		
	endif
	
	; Schools
	; -1 = None
	; 0 = Alteration 
	; 1 = Conjuration 
	; 2 = Destruction 
	; 3 = Illusion 
	; 4 = Restoration

	SpellNames[0]	= (Game.GetFormFromFile(0x020177AF,"Dragonborn.esm") As Spell).GetName() ;"Ash Rune"
	SpellMap[0]		= Game.GetFormFromFile(0x020177AF,"Dragonborn.esm") As Spell
	SpellCosts[0]	= 418
	SpellSchools[0]	= 0
	SpellNames[1]	= (Game.GetFormFromFile(0x02017731,"Dragonborn.esm") As Spell).GetName() ;"Ash Shell"
	SpellMap[1]		= Game.GetFormFromFile(0x02017731,"Dragonborn.esm") As Spell
	SpellCosts[1]	= 251
	SpellSchools[1]	= 0
	SpellNames[2]	= (Game.GetFormFromFile(0x0201CE06,"Dragonborn.esm") As Spell).GetName() ;"Bound Dagger"
	SpellMap[2]		= Game.GetFormFromFile(0x0201CE06,"Dragonborn.esm") As Spell
	SpellCosts[2]	= 52
	SpellSchools[2]	= 1
	SpellNames[3]	= (Game.GetFormFromFile(0x02017782,"Dragonborn.esm") As Spell).GetName() ;"Conjure Ash Guardian"
	SpellMap[3]		= Game.GetFormFromFile(0x02017782,"Dragonborn.esm") As Spell
	SpellCosts[3]	= 340
	SpellSchools[3]	= 1
	SpellNames[4]	= (Game.GetFormFromFile(0x0201CDF6,"Dragonborn.esm") As Spell).GetName() ;"Conjure Ash Spawn"
	SpellMap[4]		= Game.GetFormFromFile(0x0201CDF6,"Dragonborn.esm") As Spell
	SpellCosts[4]	= 186
	SpellSchools[4]	= 1
	SpellNames[5]	= (Game.GetFormFromFile(0x02033C66,"Dragonborn.esm") As Spell).GetName() ;"Conjure Seeker"
	SpellMap[5]		= Game.GetFormFromFile(0x02033C66,"Dragonborn.esm") As Spell
	SpellCosts[5]	= 157
	SpellSchools[5]	= 1
	SpellNames[6]	= (Game.GetFormFromFile(0x020177B7,"Dragonborn.esm") As Spell).GetName() ;"Frenzy Rune"
	SpellMap[6]		= Game.GetFormFromFile(0x020177B7,"Dragonborn.esm") As Spell
	SpellCosts[6]	= 278
	SpellSchools[6]	= 3
	SpellNames[7]	= (Game.GetFormFromFile(0x0201D74B,"Dragonborn.esm") As Spell).GetName() ;"Poison Rune"
	SpellMap[7]		= Game.GetFormFromFile(0x0201D74B,"Dragonborn.esm") As Spell
	SpellCosts[7]	= 246
	SpellSchools[7]	= 4
	SpellNames[8]	= (Game.GetFormFromFile(0x0201772D,"Dragonborn.esm") As Spell).GetName() ;"Whirlwind Cloak"
	SpellMap[8]		= Game.GetFormFromFile(0x0201772D,"Dragonborn.esm") As Spell
	SpellCosts[8]	= 338
	SpellSchools[8]	= 2

	int i = 0
	while i < SpellMap.length
		if (!SpellMap[i])
			return false
		endif
		i += 1
	EndWhile
	return true

EndFunction

Function OnGameLoaded()

	DLC2MQ02Frea = Game.GetFormFromFile(0x020327AD,"Dragonborn.esm") As Quest
	
	if (DLC2MQ02Frea)
		; DragonBorn Detected		

		bool 	issue = false

		; Werebear Transform
		WerebearChange 	= Game.GetFormFromFile(0x0201E178,"Dragonborn.esm") As Spell
		WerebearRace	= Game.GetFormFromFile(0x0201E17B,"Dragonborn.esm") As Race

		; Bug Fixes
		NordicArrow			= Game.GetFormFromFile(0x0202623B,"Dragonborn.esm") As Ammo
		
		if (!WerebearChange || !WerebearRace || !NordicArrow)
			issue = true
		endif

		; Load Werebear Abilities
		AbWerebear				= Game.GetFormFromFile(0x0203D471,"Dragonborn.esm") As Spell

		if (!AbWerebear)
			issue = True
		endif

		; Load Frea
		FreaBase = Game.GetFormFromFile(0x02017934,"Dragonborn.esm") As ActorBase
		FreaRef  = DLC2MQ02Frea.GetAlias(0) As ReferenceAlias
		Frea     = FreaRef.GetActorRef()
		if !Frea
			Frea = (Game.GetFormFromFile(0x02017A0D,"Dragonborn.esm") As ObjectReference) As Actor
		endif

		if (FreaBase && FreaRef && Frea)
			if (!installed)
				if (0 != Frea.GetActorValue("FavorActive") As Int)
					FreaFollow()
				endif
			endif
		else
			issue = true
		endif
		
		; Outfits and Clothes
		FreaOutfit					= Game.GetFormFromFile(0x0201FFF4,"Dragonborn.esm") As Outfit
		if (!FreaOutfit)
			issue = True
		endif

		; Locations
		RavenRock					= Game.GetFormFromFile(0x020143B9,"Dragonborn.esm") As Location
		SkallVillage				= Game.GetFormFromFile(0x020143BB,"Dragonborn.esm") As Location
		Solstiem					= Game.GetFormFromFile(0x02016E2A,"Dragonborn.esm") As Location

		if (!RavenRock || !SkallVillage || !Solstiem)
			issue = True
		endif
				
		; Globals
		FreaWillFollow		= Game.GetFormFromFile(0x0202BAF9,"Dragonborn.esm") As GlobalVariable
		
		if (!FreaWillFollow)
			issue = True
		endif
		
		if (!initializeSpellMap())
			issue = True
		endif
				
		if (issue)
			Debug.MessageBox("AFT Message : DragonBorn Resources Failed to Import. Compatibility issues likely.")
		elseif (!Installed)
			if (pGameDaysPassed.GetValue() > 1)
				Debug.Notification("AFT : DragonBorn Resources Imported Successfully")
			endif
			Installed = true
		endif
		
	elseIf (Installed)

		Debug.MessageBox("AFT Unloading DragonBorn resources...")
		; Unload Resources
		AllToNone()
		Installed = false
	endIf
	
endFunction

Function AllToNone()

		; Actors and Quests
		FreaBase              	= None
		FreaRef               	= None
		Frea					= None
		DLC2MQ02Frea			= None

		; Werebear Abilities
		AbWerebear				= None
		
		; Werebear Transform Support
		WerebearChange	 		= None
		WerebearRace			= None

		; Bug Fixes
		NordicArrow				= None

		; Outfits and clothes
		FreaOutfit				= None

		; Locations
		RavenRock				= None
		SkallVillage			= None
		Solstiem				= None

		; Globals
		FreaWillFollow			= None
		
		int i = 0
		while i < SpellMap.length
			SpellMap[i] = None
			i += 1
		EndWhile

endFunction

Function TransformWB(Actor Target)

	if (Target.GetActorBase().GetRace() != WerebearRace)
		TransformNow(Target)
	endif
	
EndFunction

Function TransformNow(Actor Target)

	if (Target == None)
		return
	endif

	Actor pc = Game.GetPlayer()
	if (Target == pc)
		return
	endif

	Race currRace = Target.GetRace()

	if (currRace != WerebearRace)
		Target.SetRace(WerebearRace)
	endif

endFunction

Function FreaFollow()
	if (!Frea)
		Return
	endif
	if (WerebearChange && !Frea.HasSpell(WerebearChange))
		Frea.AddSpell(WerebearChange)
		Frea.AddToFaction(TweakHasWBGift)
	endif
	int numArrows = Frea.GetItemCount(NordicArrow)
	if (0 != numArrows)
		Frea.RemoveItem(NordicArrow, numArrows, true)
		Frea.AddItem(ElvenArrow, numArrows, true)
	endif
	if (Frea.IsInFaction(TweakIgnoreFaction))
		Frea.RemoveFromFaction(TweakIgnoreFaction)
	endif
EndFunction

Function OnChangeLocation(Location akNewLocation)
	
	if (!Installed)
		return
	endIf

	Actor pc = Game.GetPlayer()

	if (pc.HasSpell(WerebearChange))
		PlayerIsBear = True
	else
		PlayerIsBear = False
	endif

	if Solstiem == pc.GetCurrentLocation()
		InSolstiem = true
	Else
		InSolstiem = False
	endif
	
	
	if (!akNewLocation)
		return
	endif
	
	if (!Frea)
		Return
	endif
	
	if (Frea.IsPlayerTeammate() && Frea.IsInFaction(TweakIgnoreFaction))
		Frea.RemoveFromFaction(TweakIgnoreFaction)
	endif

	if (0 == Frea.GetAV("FavorActive"))
		return
	endif

	; if (akNewLocation.GetFormID() < 0x01000000)
	;	return
	; endif
	
EndFunction

Function FreaRelease()

	if !Frea
		Return
	EndIf
	
	Actor pc = Game.GetPlayer()

	; Just in case...
	if (Frea.isUnconscious())
		Frea.SetUnconscious(FALSE)
	endif
	Frea.EnableAI(true)

	if Frea.IsInFaction(TweakPosedFaction)			; Stop Hangout if in effect
		pTweakFollowerScript.PreparePose(Frea)		; Stop pose if running
	endif
	if Frea.IsInFaction(TweakHangoutFaction)			; Stop Hangout if in effect
		Frea.RemoveFromFaction(TweakHangoutFaction)
	endif
	if (57339 == (Frea.GetAv("Infamy") as Int))		; Disable ForceSleep
		Frea.SetAv("infamy",0)
	endif
	Frea.SetAV("WaitingForPlayer", 0) 				; Disable Wait

	; Move her to player and make sure her model is loaded or
	; dismiss may cause her to become naked.

	Frea.MoveToIfUnloaded(pc)
	Float[] behindMe=pTweakFollowerScript.TraceCircle(pc, 175, -150)
	Frea.SetPosition(behindMe[0],behindMe[1], behindMe[2])
	Frea.SetAngle(0.0,0.0, (pc.GetAngleZ()))

EndFunction

Function AftReset()
	if (installed)
		Debug.MessageBox("AFT Unloading DragonBorn resources...")
		if Frea
			pTweakDFScript.DialogueRef = Frea
			pTweakDFScript.DismissFollower(-1,0)
			Frea.RemoveFromFaction(pDismissedFollowerFaction)	
			Frea.RemoveFromFaction(TweakIgnoreFaction)
		endif
		Installed = false
		PlayerIsBear = false
		AllToNone()
	endif
EndFunction

int Function GetSpellIndex(Spell theSpell)
	Form formRef = theSpell As Form
	Form spellRef

	int i = 0
	while(i < 9)
		spellRef = SpellMap[i]
		if (spellRef == formRef)
			return i
		endif
		i = i + 1
	endWhile
	return -1

EndFunction

String Function GetSpellName(int index)
	return SpellNames[index]
endFunction 

Int Function GetSpellCost(int index)
	return SpellCosts[index]
endFunction 
  
Int Function GetSpellSchool(int index)
	return SpellSchools[index]
endFunction 
