Scriptname TweakSettings extends ReferenceAlias  
{renn's Tweak ;TweakFollower}

Bool property originalEssential auto
Bool property originalProtected auto
Bool property originalIgnoreHits auto
Int property originalMorality auto
Int property originalMood auto
Int property originalConfidence auto
Int property originalAggression auto
String property originalName auto
Race property originalRace auto
Race Property pInvisibleRace  Auto  
Spell property WerewolfChange auto
SPELL Property TweakStealth Auto  
Bool  Property InBleedOut Auto

Light Property Torch01  Auto

Faction			Property TweakHDVampireFaction			Auto ; New 1.65
Faction			Property TweakHDWerebearFaction			Auto ; New 1.65
Faction			Property TweakHDWerewolfFaction			Auto ; New 1.65
Faction			Property TweakDownFaction				Auto ; New 1.65
Keyword			Property ActorTypeCreature				Auto ; New 1.65

Faction 		Property PotentialMarriageFaction 		Auto
Faction			Property TweakManagedInventoryFaction	Auto
Faction			Property pTweakInStealth				Auto ; 1.6
Faction			Property pTweakRechargeFaction			Auto ; 1.6
Faction			Property pTweakEssentialFaction			Auto ; 1.6
ReferenceAlias	Property pBackpack						Auto ; 1.6
GlobalVariable	Property pTweakRechargeThreshold 		Auto ; 1.6 
GlobalVariable	Property pTweakLongRecovery 			Auto ; 1.6 

Weapon Property HuntingBow  Auto  
Package Property TweakFollowerPackageHorse  Auto  
Package Property TweakFollowerPackage  Auto  
Package Property TweakDualPackage  Auto  
Race property KhajiitRace Auto

Faction property TweakHangoutFaction auto

TweakFollowerScript property pTweakFollowerScript auto
Faction property CurrentFollowerFaction auto
Faction property originalCrimeFaction auto
Faction property WerewolfFaction auto
Quest   property TweakDawnGuard Auto
Quest   property TweakDragonBorn Auto
Keyword property ActorTypeNPC Auto

Bool property combatInProgress auto
int property command auto

; Weapon auto recharge
SoulGem[] Property gems Auto
Int[] Property gemWeight Auto

SoulGem property SoulGemPettyFilled auto
SoulGem property SoulGemLesserFilled auto
SoulGem property SoulGemCommonFilled auto
SoulGem property SoulGemGreaterFilled auto
SoulGem property SoulGemGrandFilled auto
SoulGem property SoulGemBlackFilled auto

SoulGem property DA01SoulGemAzurasStar auto
SoulGem property DA01SoulGemBlackStar auto

int Property synergyCount Auto
int Property skillrotate Auto
Bool property stealthFlag auto

;Event OnPackageStart(Package akNewPackage)
	
;endEvent

Function stealth()
	Actor npc = self.GetActorRef()

	Int torchCount = npc.GetItemCount(Torch01)
	if (0 != torchCount)
		npc.RemoveItem(Torch01, torchCount, true, Game.GetPlayer())
	endif
	if (npc.HasSpell(TweakStealth))
		npc.DispelSpell(TweakStealth)
	else
		npc.AddSpell(TweakStealth)
		TweakStealth.Cast(npc,npc)
	endif
	if (!pTweakFollowerScript.followerCatchup)
		Bool succ = (self as ReferenceAlias).RegisterForAnimationEvent(Game.GetPlayer(), "weaponDraw")
		if !succ
			int i = 8
			while (i > 0 && !succ)
				Utility.wait(0.25)
				succ = (self as ReferenceAlias).RegisterForAnimationEvent(Game.GetPlayer(), "weaponDraw")
				i -= 1
			EndWhile
		EndIf
	endif
endFunction

;akAggressor deprecated
Function OnStealthDetected(ObjectReference akAggressor=None)
	Actor npc = self.GetActorRef()
	if (npc.IsInFaction(pTweakInStealth))
		npc.DispelSpell(TweakStealth)
	endif
	if (!pTweakFollowerScript.followerCatchup)
		(self as ReferenceAlias).UnregisterForAnimationEvent(Game.GetPlayer(), "weaponDraw")
	endif
EndFunction

; type:
; 1 = Enemies\Hostile
; 2 = Non-Allies\Neutral
; 3 = Non-Teammates\Non-Followers

Function attackVisible(int type = 1)

	Actor npc = self.GetActorRef()
	int currAggression = npc.GetBaseAV("Aggression") As Int
	if currAggression > 1
		currAggression = 1
	endif
	npc.SetAV("Aggression", type)

	; Have NPC "Peek" at surroundings
	Utility.wait(0.25);
	npc.SetPlayerTeammate(false)
	npc.RemoveFromFaction(CurrentFollowerFaction)
	Utility.wait(2.5)
	npc.SetPlayerTeammate(true)
	npc.AddToFaction(CurrentFollowerFaction)
	npc.SetAV("Aggression", currAggression)

endFunction

Function AftReset()

	if (hangoutScene.IsPlaying())
		hangoutScene.Stop()
	endif

	Actor npc = self.GetActorRef()
	if (npc.IsInFaction(TweakHangoutFaction))
		npc.RemoveFromFaction(TweakHangoutFaction)
	endif

	npc.SetNotShowOnStealthMeter(false)
	npc.GetActorBase().SetInvulnerable(false)
	npc.GetActorBase().SetEssential(false)
	if (originalEssential)
		npc.GetActorBase().SetEssential(true)
	elseif (originalProtected)
		npc.GetActorBase().SetProtected(true)
	endif
	npc.IgnoreFriendlyHits(originalIgnoreHits)
	npc.SetAV("Aggression", originalAggression)
	if (originalCrimeFaction)
		npc.AddToFaction(originalCrimeFaction)
		originalCrimeFaction = None
		npc.MakePlayerFriend() ; In case PC attacked their faction
	endif
	npc.SetAV("Morality", originalMorality)
	npc.SetAV("Mood", originalMood)
	npc.SetAV("Confidence", originalConfidence)
	npc.SetAV("FavorsPerDay", 0)
	npc.SetAV("CarryWeight", 300)
	if (300 != (npc.GetBaseAV("CarryWeight") as Int))
		npc.ForceAV("CarryWeight", 300)
	endif
	(self as ReferenceAlias).UnregisterForAnimationEvent(Game.GetPlayer(), "weaponDraw")
	originalEssential=false
	originalProtected=false
	originalIgnoreHits=false
	originalMorality=0
	originalMood=0
	originalConfidence=0
	originalAggression=0
	originalName=""
	originalRace=None
	command=0
	
	ApplyTemplateDismiss(true) ;renn

	if (npc.IsInFaction(pTweakInStealth) || npc.HasSpell(TweakStealth))
		npc.DispelSpell(TweakStealth)
		Utility.wait(0.25)
		if (npc.HasSpell(TweakStealth))
			npc.RemoveSpell(TweakStealth)
		endif
	endif

EndFunction

; One time operations (typically time consuming)
Function initialize()
	
	Actor npc = self.GetActorRef()
	npc.RemoveFromFaction(TweakHangoutFaction)
	originalEssential=false
	originalProtected=false
	originalIgnoreHits=false
	originalMorality=0
	originalMood=0
	originalConfidence=0
	originalAggression=0
	originalCrimeFaction = None
	originalName=""
	originalRace=None
	command=0
	synergyCount = 0
	skillrotate = 0
	stealthFlag = false
	
	; Figure out name
	int formid = npc.GetActorBase().GetFormID()
	if formid == Mjoll.GetFormID()
		s_Mjoll = Mjoll.GetName()
		originalName = s_Mjoll ;"Mjoll"
	elseif formid == AelaTheHuntress.GetFormID()
		s_Aela = AelaTheHuntress.GetName()
		originalName = s_Aela ;"Aela"
		npc.AddSpell(WerewolfChange)
		TweakWerewolf pTweakWerewolf = ((self as ReferenceAlias) As TweakWerewolf)
		if pTweakWerewolf
			npc.AddToFaction(pTweakWerewolf.TweakUseWerewolfFaction)
			npc.AddToFaction(pTweakWerewolf.TweakHDWerewolfFaction)
		endif
	elseif formid == Borgakh.GetFormID()
		s_Borgakh = Borgakh.GetName()
		originalName=s_Borgakh ;"Borgakh"
	elseif formid == HousecarlRiften.GetFormID()
		s_Iona = HousecarlRiften.GetName()
		originalName=s_Iona ;"Iona"
	elseif formid == HirelingJenassa.GetFormID()
		s_Jenassa = HirelingJenassa.GetName()
		originalName=s_Jenassa ;"Jenassa"
	elseif formid == HousecarlSolitude.GetFormID()
		s_Jordis = HousecarlSolitude.GetName()
		originalName=s_Jordis ;"Jordis"
	elseif formid == HousecarlWhiterun.GetFormID()
		s_Lydia = HousecarlWhiterun.GetName()
		originalName=s_Lydia ;"Lydia"
		npc.AddToFaction(PotentialMarriageFaction)
	elseif formid == NjadaStonearm.GetFormID()
		s_Njada = NjadaStonearm.GetName()
		originalName=s_Njada ;"Njada"
	elseif formid == Ria.GetFormID()
		s_Ria = Ria.GetName()
		originalName=s_Ria ;"Ria"
	elseif formid == Ugor.GetFormID()
		s_Ugor = Ugor.GetName()
		originalName=s_Ugor ;"Ugor"
		npc.AddToFaction(PotentialMarriageFaction)
	elseif formid == Uthgerd.GetFormID()
		s_Uthgerd = Uthgerd.GetName()
		originalName=s_Uthgerd ;"Uthgerd"
	elseif formid == Annekke.GetFormID()
		s_Annekke = Annekke.GetName()
		originalName=s_Annekke ;"Annekke"
	elseif formid == DBInitiate2.GetFormID()
		s_DBInitiate = DBInitiate2.GetName()
		originalName=s_DBInitiate ;"DBInitiate"
	elseif formid == DA01Aranea.GetFormID()
		s_Aranea = DA01Aranea.GetName()
		originalName=s_Aranea ;"Aranea"
		npc.AddToFaction(PotentialMarriageFaction)
	elseif formid == BrelynaMaryon.GetFormID()
		s_Brelyna = BrelynaMaryon.GetName()
		originalName=s_Brelyna ;"Brelyna"
	elseif formid == Eola.GetFormID()
		s_Eola = Eola.GetName()
		originalName=s_Eola ;"Eola"
		npc.AddToFaction(PotentialMarriageFaction)
	elseif formid == dunDarklightIllia.GetFormID()
		s_Illia = dunDarklightIllia.GetName()
		originalName=s_Illia ;"Illia"
		npc.AddToFaction(PotentialMarriageFaction)
	elseif formid == Adelaisa.GetFormID()
		; Upgraded
		s_Adelaisa = Adelaisa.GetName()
		originalName=s_Adelaisa ;"Adelaisa"
	elseif formid == HirelingErikTheSlayer.GetFormID()
		s_Erik = HirelingErikTheSlayer.GetName()
		originalName=s_Erik ;"Erik"
		npc.AddToFaction(PotentialMarriageFaction)
	elseif formid == HousecarlWindhelm.GetFormID()
		s_Calder = HousecarlWindhelm.GetName()
		originalName=s_Calder ;"Calder"
	elseif formid == HousecarlMarkarth.GetFormID()
		s_Argis = HousecarlMarkarth.GetName()
		originalName=s_Argis ;"Argis"
	elseif formid == HirelingStenvar.GetFormID()
		s_Stenvar = HirelingStenvar.GetName()
		originalName=s_Stenvar ;"Stenvar"
	elseif formid == HirelingBelrand.GetFormID()
		s_Belrand = HirelingBelrand.GetName()
		originalName=s_Belrand ;"Belrand"
	elseif formid == HirelingMarcurio.GetFormID()
		s_Marcurio = HirelingMarcurio.GetName()
		originalName=s_Marcurio ;"Marcurio"
	elseif formid == HirelingVorstag.GetFormID()
		s_Vorstag = HirelingVorstag.GetName()
		originalName=s_Vorstag ;"Vorstag"
	elseif formid == Erandur.GetFormID()
		s_Erandur = Erandur.GetName()
		originalName=s_Erandur ;"Erandur"
	elseif formid == Golldir.GetFormID()
		s_Golldir = Golldir.GetName()
		originalName=s_Golldir ;"Golldir"
		self.GetActorRef().AddToFaction(PotentialMarriageFaction)
	elseif formid == Jzargo.GetFormID()
		s_Jzargo = Jzargo.GetName()
		originalName=s_Jzargo ;"Jzargo"
		if (Game.GetPlayer().GetRace() ==  KhajiitRace)
			npc.AddToFaction(PotentialMarriageFaction)
		endif
	elseif formid == Onmund.GetFormID()
		s_Onmund = Onmund.GetName()
		originalName=s_Onmund ;"Onmund"
	elseif formid == Kharjo.GetFormID()
		s_Kharjo = Kharjo.GetName()
		originalName=s_Kharjo ;"Kharjo"
		if (Game.GetPlayer().GetRace() ==  KhajiitRace)
			npc.AddToFaction(PotentialMarriageFaction)
		endif
	elseif formid == Torvar.GetFormID()
		s_Torvar = Torvar.GetName()
		originalName=s_Torvar ;"Torvar"
	elseif formid == Athis.GetFormID()
		s_Athis = Athis.GetName()
		originalName=s_Athis ;"Athis"
	elseif formid == Vilkas.GetFormID()
		s_Vilkas = Vilkas.GetName()
		originalName=s_Vilkas ;"Vilkas"
		self.GetActorRef().AddSpell(WerewolfChange)
	elseif formid == Farkas.GetFormID()
		s_Farkas = Farkas.GetName()
		originalName=s_Farkas ;"Farkas"
		self.GetActorRef().AddSpell(WerewolfChange)
	elseif formid == Ogol.GetFormID()
		s_Ogol = Ogol.GetName()
		originalName=s_Ogol ;"Ogol"
	elseif formid == Lob.GetFormID()
		s_Lob = Lob.GetName()
		originalName=s_Lob ;"Lob"
	elseif formid == Roggi.GetFormID()
		s_Roggi = Roggi.GetName()
		originalName=s_Roggi ;"Roggi"
	elseif formid == Derkeethus.GetFormID()
		s_Derkeethus = Derkeethus.GetName()
		originalName=s_Derkeethus ;"Derkeethus"
	elseif formid == Ghorbash.GetFormID()
		s_Ghorbash = Ghorbash.GetName()
		originalName=s_Ghorbash ;"Ghorbash"
	elseif formid == Benor.GetFormID()
		s_Benor = Benor.GetName()
		originalName=s_Benor ;"Benor"
	elseif formid == Faendal.GetFormID()
		s_Faendal = Faendal.GetName()
		originalName=s_Faendal ;"Faendal"
	elseif formid == Sven.GetFormID()
		s_Sven = Sven.GetName()
		originalName=s_Sven ;"Sven"
	elseif formid == Cosnach.GetFormID()
		s_Cosnach = Cosnach.GetName()
		originalName=s_Cosnach ;"Cosnach"
	elseif formid == Ahtar.GetFormID()
		s_Ahtar = Ahtar.GetName()
		originalName=s_Ahtar ;"Ahtar"
		npc.AddToFaction(PotentialMarriageFaction)
	elseif formid == DBInitiate1.GetFormID()
		s_DBInitiate = DBInitiate1.GetName()
		originalName=s_DBInitiate1 ;"DBInitiate"
	elseif formid == CiceroDawnstar.GetFormID()
		s_Cicero = CiceroDawnstar.GetName()
		originalName=s_Cicero ;"Cicero"
	elseif formid == IdgrodTheYounger.GetFormID()
		s_Ingrod = IdgrodTheYounger.GetName()
		originalName=s_Ingrod ;"Ingrod"
		npc.AddToFaction(PotentialMarriageFaction)
	else
		s_Follower = npc.GetActorBase().GetName()
		originalName=s_Follower ;"Follower"
		TweakDragonBornScript pTweakDragonBornScript = TweakDragonBorn As TweakDragonBornScript
		if (pTweakDragonBornScript && pTweakDragonBornScript.installed)
			if (formid == pTweakDragonBornScript.FreaBase.GetFormID())
				s_Frea = pTweakDragonBornScript.FreaBase.GetName()
				originalName=s_Frea ;"Frea"
			endif
		endif
	endif
	
	originalRace = npc.GetRace()
	combatInProgress = false
	if (0 == npc.GetItemCount(HuntingBow))
		npc.AddItem(HuntingBow)
	endif
	;npc.AddToFaction(pTweakRechargeFaction) ;renn
	;npc.AddToFaction(pTweakEssentialFaction)
    v15Initialize()	
	EventFollowingPlayer()
endFunction

Function ToggleEssential(Bool pEssential)
	Actor npc = self.GetActorRef()
	if (pEssential)
		npc.AddToFaction(pTweakEssentialFaction)
	Else
		npc.RemoveFromFaction(pTweakEssentialFaction)
	endif
	enforceSettings()
EndFunction

Function ToggleRecharge(Bool pRecharge)
	Actor npc = self.GetActorRef()
	if (pRecharge)
		npc.AddToFaction(pTweakRechargeFaction)
	Else
		npc.RemoveFromFaction(pTweakRechargeFaction)
	endif
EndFunction

Function v15Initialize()
	v15Upgrade()
EndFunction

Function v15Upgrade()

	TweakDawnGuardScript pTweakDawnGuardScript = TweakDawnGuard As TweakDawnGuardScript
	if (pTweakDawnGuardScript && pTweakDawnGuardScript.installed)
		int formid = self.GetActorRef().GetActorBase().GetFormID()
		if (formid == pTweakDawnGuardScript.SerenaBase.GetFormID())
			s_Serana = pTweakDawnGuardScript.SerenaBase.GetName()
			originalName=s_Serana ;"Serana"
		endif
	endif

	gems = new SoulGem[6]
	gemWeight = new Int[6]
	gems[0] = SoulGemPettyFilled
	gemWeight[0] = 1
	; Lesser
	gems[1] = SoulGemLesserFilled
	gemWeight[1] = 2
	; Common
	gems[2] = SoulGemCommonFilled
	gemWeight[2] = 4
	; Greater
	gems[3] = SoulGemGreaterFilled
	gemWeight[3] = 8
	; Grand
	gems[4] = SoulGemGrandFilled
	gemWeight[4] = 16
	; Black
	gems[5] = SoulGemBlackFilled
	gemWeight[5] = 16
EndFunction

Function v16Upgrade()
	
	TweakDragonBornScript pTweakDragonBornScript = TweakDragonBorn As TweakDragonBornScript
	if (pTweakDragonBornScript && pTweakDragonBornScript)
		int formid = self.GetActorRef().GetActorBase().GetFormID()
		if (formid == pTweakDragonBornScript.FreaBase.GetFormID())
			s_Frea = pTweakDragonBornScript.FreaBase.GetName()
			originalName=s_Frea ; "Frea"
		endif
	endif

	Actor npc = self.GetActorRef() As Actor
	if (!pTweakFollowerScript.followerPackMuleDisable)
		npc.SetAV("CarryWeight", 300)
		if (300 != (npc.GetBaseAV("CarryWeight") As Int))
			npc.ForceAV("CarryWeight", 300)
		endif
		FixBackPackWeight(1000)
	endif
	combatOverFlag=False	
	if (!pTweakFollowerScript.rechargeWeaponsDisable)
		npc.AddToFaction(pTweakRechargeFaction)
	endif
	if (pTweakFollowerScript.followerEssential)
		npc.AddToFaction(pTweakEssentialFaction)
	endif
EndFunction

; Every time they join the PC.
Function EventFollowingPlayer()

	Actor npc = self.GetActorRef()
	originalEssential = npc.IsEssential()
	originalProtected = npc.GetActorBase().IsProtected()
	originalIgnoreHits = npc.IsIgnoringFriendlyHits()
	originalMorality = npc.GetBaseAV("Morality") As Int
	originalMood = npc.GetBaseAV("Mood") As Int
	originalConfidence = npc.GetBaseAV("Confidence") As Int
	originalAggression = npc.GetBaseAV("Aggression") As Int
	enforceSettings()
	if (hangoutScene.IsPlaying())
		hangoutScene.Stop()
	endif
	if (npc.IsInFaction(TweakHangoutFaction))
		npc.RemoveFromFaction(TweakHangoutFaction)
	endif
endFunction

; Every time they continue following the PC after waiting
Function EventWaitToFollow()
	UnregisterForUpdate()
	enforceSettings()
EndFunction

; When they stop following the PC
Function EventNotFollowingPlayer()

	Actor npc = self.GetActorRef()

	if (npc.IsInFaction(pTweakInStealth) || npc.HasSpell(TweakStealth))
		npc.DispelSpell(TweakStealth)
		Utility.wait(0.25)
		if (npc.HasSpell(TweakStealth))
			npc.RemoveSpell(TweakStealth)
		endif
	endif

	npc.SetNotShowOnStealthMeter(false)

	npc.GetActorBase().SetInvulnerable(false)
	npc.GetActorBase().SetEssential(false)

	if (originalEssential)
		npc.GetActorBase().SetEssential(true)
	elseif (originalProtected)
		npc.GetActorBase().SetProtected(true)
	endif
	npc.IgnoreFriendlyHits(originalIgnoreHits)

	npc.SetAV("Aggression", originalAggression)
	npc.SetAV("Morality", originalMorality)
	npc.SetAV("Mood", originalMood)
	npc.SetAV("Confidence", originalConfidence)

	(self as ReferenceAlias).UnregisterForAnimationEvent(Game.GetPlayer(), "weaponDraw")

endFunction

Function OnCombatBegin()

	combatInProgress=true

	Actor npc = self.GetActorRef()
	npc.GetActorBase().SetInvulnerable(false)

	if (pTweakFollowerScript.FollowerSynergy)
		if !npc.HasKeyword(ActorTypeCreature)
			synergyCount -= 1
		endif
	endif
	
	;if (self.GetActorRef().GetPlayerControls())
	;	; invuln handled by possession system when possessing
	;	return
	;endif

EndFunction

; Called by TweakFollowerScript: RelayCombatEnd
Function OnCombatEnd()
	InBleedOut = false
	combatInProgress = false

	Actor npc = self.GetActorRef()

	if !npc || npc.IsDead()
		return
	endIf

	if (pTweakFollowerScript.FollowerSynergy)
		UpdateSkills()
	endif

	RechargeCheck()
	
	if (1.0 == pTweakLongRecovery.GetValue())
		if (npc.IsInFaction(TweakDownFaction))
			npc.RemoveFromFaction(TweakDownFaction)
			Race currentRace = npc.GetRace()
			npc.SetUnconscious(false)
			Utility.wait(0.25)
			npc.SetRace(pInvisibleRace)
			Utility.wait(0.5)
			npc.SetRace(currentRace)
		endif
	endif
	
	if (!pTweakFollowerScript.followerIgnoresFriendlyFire)
		return
	endif
	self.GetActorRef().GetActorBase().SetInvulnerable(pTweakFollowerScript.followerIgnoresFriendlyFire)	
EndFunction

; Each Tweak looks for its own combat begin state and fires OnCombatBegin
; However only this particular instance registers cstate==0 on the main 
; quest. THis was because of a bug where only the NPC that makes the killing
; blow gets cstate 0. The others do not. So all npcs send their 0 state to 
; the quest so that it can be shared so that things like transforming back 
; to human, disabling invulnerability and taking helmets off do not break. 

Event OnCombatStateChanged(Actor akTarget, int cState)
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf

	if (1 == cState && akTarget)
		if (pTweakFollowerScript.followerIgnoresFriendlyFire)
			if (akTarget.IsInFaction(CurrentFollowerFaction))
				npc.StopCombat()		
				npc.SetRelationshipRank(akTarget, 3)
				akTarget.SetRelationshipRank(npc, 3)
				Utility.wait(0.1)
				attackVisible()
				return
			elseif (akTarget.IsPlayerTeammate())
				npc.StopCombat()		
				npc.SetRelationshipRank(akTarget, 3)
				akTarget.SetRelationshipRank(npc, 3)
				Utility.wait(0.1)
				return
			endif
			; player check handled by DialogueFollower -> Follower Alias -> TweakFollowerAliasScript
			; follower is dismissed if they attempt to attack the player.
		endif
	endif

	
	if (!npc.IsInFaction(CurrentFollowerFaction))
		return
	endif
	
	if (1 == cState)
		InBleedOut = false
		pTweakFollowerScript.CombatStateChanged(cState)
		if (!combatInProgress)
			OnCombatBegin()
		endif
	elseif (0 == cState)
		if !InBleedOut
			pTweakFollowerScript.CombatStateChanged(cState)
		endif
	endif

endEvent

Event OnUpdate()
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	
	if (stealthFlag)
		stealthFlag = False
		OnStealthDetected()
	endif

	if (command != 0)
		int copy = command
		command = 0
		if (copy < 4)
			attackVisible(copy)
		endif
	endif

endEvent

Event OnLoad()
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf

	if (!npc.IsInFaction(CurrentFollowerFaction))
		return
	endif
	if (combatInProgress)
		if (!npc.IsInCombat())
			; something is wrong. Fix it.
			combatInProgress = False
		endif
	endif
	enforceSettings()
endEvent


Event OnAnimationEvent(ObjectReference akSource, string asEventName)

	if !("weapondraw" == asEventName)
		return
	endif
	
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf

	; This shouldn't be needed as we should be unregistering the events
	; when they leave
	if (!npc.IsInFaction(CurrentFollowerFaction))
		return
	endif

	; auto charge weapon support
	RechargeCheck()

	Actor pc = Game.GetPlayer()
	; ignore event if from NPCs own weapon draw...
	if (akSource.GetFormID() != pc.GetFormID())
		return
	endif
	
	; Diagnostic()

	if !pc.IsSneaking()
		if (npc.HasSpell(TweakStealth))
			npc.DispelSpell(TweakStealth)
		endif
	endif

	if (0 != (npc.GetAv("WaitingforPlayer") as Int))
		return
	endif

	if (npc.GetPlayerControls() || npc.GetCurrentPackage() == TweakFollowerPackageHorse)
		return
	EndIf
	
	; Possibly optimize distance check with our own math. Actual distance calculation involves 
	; a square root, but you can simply compare non square root values for faster ops. 
	; Maybe consider using nearPC() method

	; less expensive check but both cases below still need exact values
	;	if (self.GetRef().IsNearPlayer())		
	;		return
	;	endif

	float d = npc.GetDistance(pc)
	if (d > 2000.00)
		if (pTweakFollowerScript.followerCatchup)
			pTweakFollowerScript.GetFollowers()
		endif
	elseif (d < 50)
		pTweakFollowerScript.GetBehindMe(self.GetActorRef())
	endif

endEvent

Event OnEnterBleedout()
	InBleedOut = true

	if (1.0 == pTweakLongRecovery.GetValue())
		Actor npc = self.GetActorRef()
		if !npc || npc.IsDead()
			return
		endIf

		if (!npc.IsInFaction(CurrentFollowerFaction))
			return
		endif
	
		if (combatInProgress)
			if (npc.IsEssential() || npc.GetActorBase().IsProtected())
				; Prevent them from getting up
				npc.SetUnconscious(true)
				Debug.SendAnimationEvent(self.GetRef(),"Ragdoll")
				npc.AddToFaction(TweakDownFaction)
			endif
		endif
	endif
endEvent

Function RechargeCheck()
	Actor npc = self.GetActorRef()
	if (npc.IsInFaction(pTweakRechargeFaction))
		if (npc.GetEquippedWeapon()) ; right hand
			if 0 != npc.GetBaseAV("rightitemcharge") ; its enchanted
				if (npc.GetAV("rightitemcharge") < pTweakRechargeThreshold.GetValue()) ; time to recharge
					RechargeWeapon("rightitemcharge")
				endif
			endif
		endif
	
		if (npc.GetEquippedWeapon(true)) ; left hand
			if 0 != npc.GetBaseAV("leftitemcharge") ; its enchanted
				if (npc.GetAV("leftitemcharge") < pTweakRechargeThreshold.GetValue()) ; time to recharge
					RechargeWeapon("leftitemcharge")
				endif
			endif
		endif
	endif
EndFunction

; Bug Fix 1.3 - Skyrim patch broke persistance of Carrywieght, so 
; this is now enforced every time you click on the follower

Event OnActivate(ObjectReference akActionRef)
	InBleedOut = false
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	if (npc.IsUnconscious())
		npc.SetUnconscious(false)
	endif	
	if (!npc.IsInFaction(CurrentFollowerFaction))
		return
	endif
	
	if (!pTweakFollowerScript.followerPackMuleDisable)
		if (npc.IsInFaction(TweakManagedInventoryFaction))
			npc.SetAV("CarryWeight", 300)
			if (300 != (npc.GetBaseAV("CarryWeight") As Int))
				npc.ForceAV("CarryWeight", 300)
			endif
			FixBackPackWeight(1000)
		else
			npc.SetAV("CarryWeight", 1000)
			if (1000 != (npc.GetBaseAV("CarryWeight") as Int))
				npc.ForceAV("CarryWeight", 1000)
			endif
		endif
	endif
	npc.EvaluatePackage()

endEvent

Function enforceSettings()

	Actor npc = self.GetActorRef()
	npc.SetNotShowOnStealthMeter(true)
	if (npc.IsInFaction(pTweakEssentialFaction))
		npc.GetActorBase().SetEssential(true)
	elseif (originalEssential)
		npc.GetActorBase().SetEssential(true)
	elseif (originalProtected)
		if (npc.IsEssential())
			npc.GetActorBase().SetEssential(false)
		endif
		npc.GetActorBase().SetProtected(true)
	else
		npc.GetActorBase().SetEssential(false)
	endif

	; Report crimes to no one. This also prevents followers from turning on PC when PC attacks NPC's faction members. 
	if (npc.GetCrimeFaction())
		originalCrimeFaction = npc.GetCrimeFaction()
		npc.RemoveFromFaction(originalCrimeFaction)
	endif

	npc.IgnoreFriendlyHits(pTweakFollowerScript.followerIgnoresFriendlyFire)

	if (!npc.IsInCombat())
		npc.GetActorBase().SetInvulnerable(pTweakFollowerScript.followerIgnoresFriendlyFire)
	endif

	if (pTweakFollowerScript.followerNoTrap)
		npc.SetAV("FavorsPerDay", 97473)
	else
		npc.SetAV("FavorsPerDay", 10)
	endif
	if (pTweakFollowerScript.followerHoldback)
		npc.SetAV("Aggression", 0)
	else
		npc.SetAV("Aggression", 1)
	endif
	if (pTweakFollowerScript.followerNoMorals)
		npc.SetAV("Morality", 0) ;0 =  Do anything they are told
	else
		npc.SetAV("Morality", originalMorality)
	endif
	if (pTweakFollowerScript.followerFearless)
		npc.SetAV("Confidence", 4) ;4 = Never run from battle
	else
		npc.SetAV("Confidence", originalConfidence)
	endif

	if (pTweakFollowerScript.followerPackMuleDisable)
		if (npc.GetAV("CarryWeight") > 900)
			npc.SetAV("CarryWeight", 300)
			if (300 != (npc.GetBaseAV("CarryWeight") As Int))
				npc.ForceAV("CarryWeight", 300)
			endif
		EndIf
		if (npc.IsInFaction(TweakManagedInventoryFaction))
			FixBackPackWeight(300)
		EndIf
	elseif (npc.IsInFaction(TweakManagedInventoryFaction))
		if (npc.GetAV("CarryWeight") > 900)
			npc.SetAV("CarryWeight", 300)
			if (300 != (npc.GetBaseAV("CarryWeight") As Int))
				npc.ForceAV("CarryWeight", 300)
			endif
		endif
		FixBackPackWeight(1000)
	else
		npc.SetAV("CarryWeight", 1000)
		if (1000 != (npc.GetBaseAV("CarryWeight") as Int))
			npc.ForceAV("CarryWeight", 1000)
		endif
	endif

	if (pTweakFollowerScript.followerCatchup || npc.IsInFaction(pTweakInStealth))
		Bool succ = (self as ReferenceAlias).RegisterForAnimationEvent(Game.GetPlayer(), "weaponDraw")
		if !succ
			int i = 8
			while (i > 0 && !succ)
				Utility.wait(0.25)
				succ = (self as ReferenceAlias).RegisterForAnimationEvent(Game.GetPlayer(), "weaponDraw")
				i -= 1
			EndWhile
		EndIf
	else
		; Note that possession uses events attached to the actor, 
		; Settings uses events attached to the PC. So there is no
		; conflict. 
		(self as ReferenceAlias).UnregisterForAnimationEvent(Game.GetPlayer(), "weaponDraw")
	endif
	npc.EvaluatePackage()
endFunction

Function hangout()
	self.GetActorRef().AddToFaction(TweakHangoutFaction)
	self.GetActorRef().EvaluatePackage()
endFunction

Function RechargeWeapon(String hand)

	ObjectReference oNpc = self.GetReference()
	if ((0 != oNpc.GetItemCount(DA01SoulGemAzurasStar)) || (0 != oNpc.GetItemCount(DA01SoulGemBlackStar)))
		String npcName = ((self as ReferenceAlias) As TweakSettings).originalName
		Debug.Notification("[" + npcName + "] Recharged Weapon")
		npc.SetAV(hand, 10000)
		return
	endif

	Actor npc = self.GetActorRef()
	
	int num = 0
	int type = 0
	int weighted
	while (num < 12 && type < 6)
		int count = oNpc.GetItemCount(gems[type])
		weighted = (count * gemWeight[type]) As Int
		if (num + weighted < 12)
			oNpc.RemoveItem(gems[type], count, true)
			num = num + weighted
		else
			int needed = 12 - num
			int extra = Math.abs(needed - weighted) As Int
			int leave = Math.floor(extra / gemWeight[type]) As Int
			oNpc.RemoveItem(gems[type], (count - leave), true)
			num = 12
		endif
		type += 1
	endWhile
	String npcName = ((self as ReferenceAlias) As TweakSettings).originalName
	if (12 == num)
		Debug.Notification("[" + npcName + "] Recharged Weapon")
		npc.SetAV(hand, 10000)
	elseif (num > 0)
		int charge = 250 + ((num * 250) As Int)
		Debug.Notification("[" + npcName + "] Recharged Weapon")
		npc.SetAV(hand, charge)
	endif

EndFunction

Function UpdateSkills()

	; There is an entire site on skill advancement and how the difficulty of increasing
	; skills is affected by the current skill level. Futhermore, only certain actions
	; can increase the skill.
			
	; Unfortunately, followers are not the player. They dont actually gain skills or
	; level up on their own. Rather they key off the player. So I have to invent my
	; system to decide when a follower has done enough to aid the player's skill
	; progression.
			
	if (synergyCount < 1)

		; As we level up, it takes more battles
		; Level 1 - 20   : 9 battles
		; Level 20 - 40  : 18 battles
		; Level 40 - 60  : 36 battles
		; Level 60 - 80  : 54 battles
		; Level 80 - 100 : 72 battles
		; Finally we add a random number from 0 to 4 to help avoid clustering

		int level = Game.GetPlayer().GetLevel()
		synergyCount = Utility.RandomInt(0,4)
		if (level < 20)
			synergyCount += 9
		elseif (level < 40)
			synergyCount += 18
		elseif (level < 60)
			synergyCount += 36
		elseif (level < 80)
			synergyCount += 54
		else
			synergyCount += 72
		endif
	elseif (1 == synergyCount)

		Debug.Notification("Synergy Skill Point Awarded")
	
		; Time for Synergy Point
		int combatType = self.GetActorRef().GetAV("FavorsPerDayTimer") As Int

		if (731 == combatType)     ; 731 = Mage
			if (0 == skillrotate)
				Game.IncrementSkill("Destruction")
			elseif (1 == skillrotate)
				Game.IncrementSkill("Conjuration")
			elseif (2 == skillrotate)
				Game.IncrementSkill("Alteration")
			else
				Game.IncrementSkill("Restoration")
			endif
			skillrotate += 1
			if (skillrotate > 3)
				skillrotate = 0
			endif
		elseif (732 == combatType) ; 732 = Spell Sword
			if (0 == skillrotate)
				Game.IncrementSkill("LightArmor")
			elseif (1 == skillrotate)
				Game.IncrementSkill("Destruction")
			elseif (2 == skillrotate)
				Game.IncrementSkill("OneHanded")
			else
				Game.IncrementSkill("Restoration")
			endif
			skillrotate += 1
			if (skillrotate > 3)
				skillrotate = 0
			endif
		elseif (733 == combatType) ; 733 = 1 Handed
			if (0 == skillrotate)
				Game.IncrementSkill("OneHanded")
			elseif (1 == skillrotate)
				Game.IncrementSkill("Block")
			elseif (2 == skillrotate)
				Game.IncrementSkill("LightArmor")
			else
				Game.IncrementSkill("HeavyArmor")
			endif
			skillrotate += 1
			if (skillrotate > 3)
				skillrotate = 0
			endif
		elseif (734 == combatType) ; 734 = 2 handed
			if (0 == skillrotate)
				Game.IncrementSkill("TwoHanded")					
			elseif (1 == skillrotate)
				Game.IncrementSkill("HeavyArmor")					
			else
				Game.IncrementSkill("LightArmor")					
			endif
			skillrotate += 1
			if (skillrotate > 2)
				skillrotate = 0
			endif
		elseif (735 == combatType) ; 735 = Dual
			if (0 == skillrotate)
				Game.IncrementSkill("OneHanded")					
			elseif (1 == skillrotate)
				Game.IncrementSkill("LightArmor")					
			elseif (2 == skillrotate)
				Game.IncrementSkill("HeavyArmor")					
			else
				Game.IncrementSkill("Block")					
			endif
			skillrotate += 1
			if (skillrotate > 3)
				skillrotate = 0
			endif
		elseif (736 == combatType) ; 736 = Bow
			if (0 == skillrotate)
				Game.IncrementSkill("Marksman")					
			elseif (1 == skillrotate)
				Game.IncrementSkill("LightArmor")					
			else
				Game.IncrementSkill("Sneak")					
			endif
			skillrotate += 1
			if (skillrotate > 2)
				skillrotate = 0
			endif
		elseif (737 == combatType) ; 737 = Ranger
			if (0 == skillrotate)
				Game.IncrementSkill("OneHanded")					
			elseif (1 == skillrotate)
				Game.IncrementSkill("LightArmor")					
			elseif (2 == skillrotate)
				Game.IncrementSkill("Marksman")					
			else
				Game.IncrementSkill("HeavyArmor")
			endif
			skillrotate += 1
			if (skillrotate > 3)
				skillrotate = 0
			endif
		else ; Default
			if (0 == skillrotate)
				Game.IncrementSkill("LightArmor")
			elseif (1 == skillrotate)
				Game.IncrementSkill("TwoHanded")					
			elseif (2 == skillrotate)
				Game.IncrementSkill("Marksman")			
			elseif (3 == skillrotate)
				Game.IncrementSkill("Destruction")
			elseif (4 == skillrotate)
				Game.IncrementSkill("HeavyArmor")
			elseif (5 == skillrotate)
				Game.IncrementSkill("OneHanded")					
			elseif (6 == skillrotate)
				Game.IncrementSkill("Restoration")
			elseif (7 == skillrotate)
				Game.IncrementSkill("Block")
			elseif (8 == skillrotate)
				Game.IncrementSkill("Conjuration")
			elseif (9 == skillrotate)
				Game.IncrementSkill("Sneak")
			else
				Game.IncrementSkill("Alteration")
			endif
			skillrotate += 1
			if (skillrotate > 10)
				skillrotate = 0
			endif
		endif
	endif
EndFunction

Function FixBackPackWeight(int amount)
	if (pBackpack)
		Actor bp = pBackpack.GetActorRef()
		if (bp)
			bp.SetAV("CarryWeight", amount)
			if (amount != (bp.GetBaseAV("CarryWeight") as Int))
				bp.ForceAV("CarryWeight", amount)
			endif
		endif
	endif
EndFunction

; Females
ActorBase property Adelaisa auto
ActorBase property AelaTheHuntress auto
ActorBase property dunDarklightIllia auto
ActorBase property HousecarlRiften auto
ActorBase property HirelingJenassa auto
ActorBase property HousecarlWhiterun auto
ActorBase property HousecarlSolitude auto
ActorBase property NjadaStonearm auto
ActorBase property DA01Aranea auto
ActorBase property BrelynaMaryon auto
ActorBase property Eola auto
ActorBase property Annekke auto
ActorBase property Uthgerd auto
ActorBase property Ugor auto
ActorBase property Ria auto
ActorBase property Borgakh auto
ActorBase property Mjoll auto

; males
ActorBase property HirelingErikTheSlayer auto
ActorBase property HousecarlWindhelm auto
ActorBase property HousecarlMarkarth auto
ActorBase property HirelingStenvar auto
ActorBase property HirelingBelrand auto
ActorBase property HirelingMarcurio auto
ActorBase property HirelingVorstag auto
ActorBase property Erandur auto
ActorBase property Golldir auto
ActorBase property Jzargo auto
ActorBase property Onmund auto
ActorBase property Kharjo auto
ActorBase property Torvar auto
ActorBase property Athis auto
ActorBase property Vilkas auto
ActorBase property Farkas auto
ActorBase property Ogol auto
ActorBase property Lob auto
ActorBase property Roggi auto
ActorBase property Derkeethus auto
ActorBase property Ghorbash auto
ActorBase property Benor auto
ActorBase property Faendal auto
ActorBase property Sven auto
ActorBase property Cosnach auto
ActorBase property Ahtar auto
ActorBase property DBInitiate1 auto
ActorBase property DBInitiate2 auto
ActorBase property CiceroDawnstar auto
ActorBase property IdgrodTheYounger auto

; Deprecated 1.6
Bool property combatOverFlag auto

;Deprecated 1.51
Faction property TweakPTWerewolfFaction auto

; deprecated 1.32
Scene Property hangoutScene  Auto  

;------------------------------------------ renn

String	Property	s_Mjoll			Auto
String	Property	s_Aela			Auto
String	Property	s_Borgakh		Auto
String	Property	s_Iona			Auto
String	Property	s_Jenassa		Auto
String	Property	s_Jordis		Auto
String	Property	s_Lydia			Auto
String	Property	s_Njada			Auto
String	Property	s_Ria			Auto
String	Property	s_Ugor			Auto
String	Property	s_Uthgerd		Auto
String	Property	s_Annekke		Auto
String	Property	s_DBInitiate	Auto
String	Property	s_Aranea		Auto
String	Property	s_Brelyna		Auto
String	Property	s_Eola			Auto
String	Property	s_Illia			Auto
String	Property	s_Adelaisa		Auto
String	Property	s_Erik			Auto
String	Property	s_Calder		Auto
String	Property	s_Argis			Auto
String	Property	s_Stenvar		Auto
String	Property	s_Belrand		Auto
String	Property	s_Marcurio		Auto
String	Property	s_Vorstag		Auto
String	Property	s_Erandur		Auto
String	Property	s_Golldir		Auto
String	Property	s_Jzargo		Auto
String	Property	s_Onmund		Auto
String	Property	s_Kharjo		Auto
String	Property	s_Torvar		Auto
String	Property	s_Athis			Auto
String	Property	s_Vilkas		Auto
String	Property	s_Farkas		Auto
String	Property	s_Ogol			Auto
String	Property	s_Lob			Auto
String	Property	s_Roggi			Auto
String	Property	s_Derkeethus	Auto
String	Property	s_Ghorbash		Auto
String	Property	s_Benor			Auto
String	Property	s_Faendal		Auto
String	Property	s_Sven			Auto
String	Property	s_Cosnach		Auto
String	Property	s_Ahtar			Auto
String	Property	s_DBInitiate1	Auto
String	Property	s_Cicero		Auto
String	Property	s_Ingrod		Auto
String	Property	s_Follower		Auto
String	Property	s_Frea			Auto
String	Property	s_Serana		Auto

function ApplyTemplate() ;renn
	Actor n = self.GetActorRef()
	if pTweakFollowerScript.i_LifeAll < 2
		int i = pTweakFollowerScript.i_LifeAll
		if i < 2
			if (originalEssential) || (n.IsInFaction(pTweakEssentialFaction)) || i == 0
				if !(i == 0 && originalProtected)
					n.AddToFaction(pTweakEssentialFaction)
					n.GetActorBase().SetEssential(true)
				endif
			elseif (originalProtected) || i == 1
				if (n.IsEssential())
					n.GetActorBase().SetEssential(false)
				endif
				n.GetActorBase().SetProtected(true)
			else
				n.GetActorBase().SetEssential(false)
			endif
		endif
	endif
	if n.HasKeyword(ActorTypeNPC)
		if pTweakFollowerScript.i_StyleAll < 9
			pTweakFollowerScript.ApplyCombatStyle(n, pTweakFollowerScript.i_StyleAll)
		endif
		if pTweakFollowerScript.b_TweakManagedInventoryFaction
			pTweakFollowerScript.ApplyMSG(n, 23)
			pTweakFollowerScript.StartManagingInventory(n, 0)
		endif
		if pTweakFollowerScript.b_TweakHelmetCombatOnlyFaction
			pTweakFollowerScript.ApplyMSG(n, 21)
			pTweakFollowerScript.ToggleHelmet(n, false)
		endif
		if !pTweakFollowerScript.rechargeWeaponsDisable
			n.AddToFaction(pTweakRechargeFaction)
		endif
	endif
	if pTweakFollowerScript.b_TweakChattyFaction
		n.AddToFaction(pTweakFollowerScript.TweakChattyFaction)
	else
		n.RemoveFromFaction(pTweakFollowerScript.TweakChattyFaction)		
	endif
	if pTweakFollowerScript.b_TweakNoAutoRelax
		n.AddToFaction(pTweakFollowerScript.TweakNoAutoRelax)
	endif
	if pTweakFollowerScript.b_TweakFarFaction
		n.AddToFaction(pTweakFollowerScript.TweakFarFaction)
	endif
endFunction

function ApplyTemplateDismiss(bool b=false) ;renn
	Actor n = self.GetActorRef()
	n.RemoveFromFaction(pTweakRechargeFaction)
	n.RemoveFromFaction(pTweakFollowerScript.TweakChattyFaction)
	n.RemoveFromFaction(pTweakFollowerScript.TweakNoAutoRelax)
	n.RemoveFromFaction(pTweakFollowerScript.TweakFarFaction)
	if b
		n.RemoveFromFaction(pTweakEssentialFaction)
	endif
endFunction