ScriptName TweakDFScript extends DialogueFollowerScript

; Inherited from parent
;ScriptName TweakDialogueFollowerScript extends Quest Conditional
;GlobalVariable Property pPlayerFollowerCount Auto
;GlobalVariable Property pPlayerAnimalCount Auto
;ReferenceAlias Property pFollowerAlias Auto
;ReferenceAlias property pAnimalAlias Auto
;Faction Property pDismissedFollower Auto
;Faction Property pCurrentHireling Auto
;Message Property  FollowerDismissMessage Auto
;Message Property AnimalDismissMessage Auto
;Message Property  FollowerDismissMessageWedding Auto
;Message Property  FollowerDismissMessageCompanions Auto
;Message Property  FollowerDismissMessageCompanionsMale Auto
;Message Property  FollowerDismissMessageCompanionsFemale Auto
;Message Property  FollowerDismissMessageWait Auto
;SetHirelingRehire Property HirelingRehireScript Auto
;Int Property iFollowerDismiss Auto Conditional
; PATCH 1.9: 77615: remove unplayable hunting bow when follower is dismissed
;Weapon Property FollowerHuntingBow Auto

Ammo Property pFollowerIronArrow Auto

; Local
TweakDawnGuardScript Property pTweakDawnGuardScript  Auto
TweakDragonBornScript Property pTweakDragonBornScript Auto
TweakFollowerScript Property pTweakFollowerScript  Auto
DialogueFollowerScript Property DialogueFollower Auto
ObjectReference Property DialogueRef Auto
ReferenceAlias Property pFollowerAlias2 Auto
ReferenceAlias Property pFollowerAlias3 Auto
ReferenceAlias Property pFollowerAlias4 Auto
ReferenceAlias Property pFollowerAlias5 Auto
ReferenceAlias Property pFollowerAlias6 Auto
ReferenceAlias Property pFollowerAlias7 Auto
ReferenceAlias Property pFollowerAlias8 Auto
ReferenceAlias Property pFollowerAlias9 Auto
ReferenceAlias Property pFollowerAlias10 Auto
Faction Property pCurrentFollowerFaction Auto
Faction Property pTweakWaitingFaction Auto
Faction Property pTweakPotentialFollowerFaction Auto
Faction Property pTweakIgnoreFaction Auto
Faction Property pJobJarlFaction Auto

Furniture Property BedrollGround  Auto
Furniture Property BedrollHay01  Auto  
Furniture Property Bedroll01  Auto  

Faction Property WerewolfFaction Auto
Faction Property TweakSandbox Auto
Faction Property TweakSayDismiss Auto
FormList Property TweakBedOptions Auto

Quest Property pDBQuest  Auto  
ActorBase Property CiceroDawnstar auto
ActorBase Property DBInitiate1 auto
ActorBase Property DBInitiate2 auto
Keyword Property ActorTypeNPC  Auto  

Bool Property InDialogue auto
Int Property CommandCount auto
ObjectReference Property previousSlot1 Auto
Bool Property drWasFollower auto
Bool Property drWasTeammate auto
Int Property drWasWaiting auto
Bool Property psWasFollower Auto
Bool Property psWasWaiting Auto
Keyword Property pActorTypeAnimal Auto
Bool Property Running auto
GlobalVariable Property TweakLimitFollowers auto

Event OnInit()
	Running = True
EndEvent

Function SetFollower(ObjectReference FollowerRef)

	if (!Running)
		parent.SetFollower(FollowerRef)
		return
	endif

	if (InDialogue)
		CommandCount += 1
	endif

	; Debug.Notification("Debug SetFollower")

	if (FindAlias(FollowerRef))
		; Debug.Notification("Follower already managed")
		return
	endIf
	
	actor FollowerActor = FollowerRef as Actor
	
	If FollowerActor.GetRelationshipRank(Game.GetPlayer()) < 3 && FollowerActor.GetRelationshipRank(Game.GetPlayer()) >= 0
		FollowerActor.SetRelationshipRank(Game.GetPlayer(), 3)
	EndIf

	if (pTweakDawnGuardScript.installed)
		if (FollowerActor == pTweakDawnGuardScript.Serena)
			pTweakDawnGuardScript.SerenaFollow(FollowerRef)
		endif
	endif

	if (pTweakDragonBornScript.installed)
		if (FollowerActor == pTweakDragonBornScript.Frea)
			pTweakDragonBornScript.FreaFollow()
		endif
	endif
	
	if FollowerActor.IsInFaction(pDismissedFollower)
		; Only do this if they were previously a follower (helps eliminate possibility
		; of them having non-default gear
		pTweakFollowerScript.EventFollowerRecruited(FollowerRef,true)
		FollowerActor.RemoveFromFaction(pDismissedFollower)
	endif
	
	FollowerActor.SetPlayerTeammate()

	ActorBase dbase = FollowerActor.GetActorBase()
	if(pDBQuest)
		DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
		if (dbase == CiceroDawnstar)
			dbScript.CiceroFollower = 1
			dbScript.CiceroState = 2
		elseif (dbase == DBInitiate1)
			dbScript.Initiate1Follower = 1
			dbScript.Initiate1State = 2
		elseif (dbase == DBInitiate2)
			dbScript.Initiate2Follower = 1
			dbScript.Initiate2State = 2
		endif
	endif
	
	if (TweakLimitFollowers.GetValueInt() > 0)
		if (!pFollowerAlias.GetActorRef())
			pFollowerAlias.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias2.GetActorRef())
			pFollowerAlias2.ForceRefTo(FollowerRef)
		else
			Actor npc = pFollowerAlias3.GetActorRef()
			if(pTweakDawnGuardScript.installed && npc && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 2 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias2.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias2.ForceRefTo(FollowerRef)				
			else
				if (npc)
					DialogueRef = pFollowerAlias3.GetActorRef()
					DismissFollower(-1,0)
				endif
				pFollowerAlias3.ForceRefTo(FollowerRef)
			endif
		endif
	else
		if (!pFollowerAlias.GetActorRef())
			pFollowerAlias.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias2.GetActorRef())
			pFollowerAlias2.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias3.GetActorRef())
			pFollowerAlias3.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias4.GetActorRef())
			pFollowerAlias4.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias5.GetActorRef())
			pFollowerAlias5.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias6.GetActorRef())
			pFollowerAlias6.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias7.GetActorRef())
			pFollowerAlias7.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias8.GetActorRef())
			pFollowerAlias8.ForceRefTo(FollowerRef)
		elseif (!pFollowerAlias9.GetActorRef())
			pFollowerAlias9.ForceRefTo(FollowerRef)
		else
			Actor npc = pFollowerAlias10.GetActorRef()
			if(pTweakDawnGuardScript.installed && npc && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 9 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias9.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias9.ForceRefTo(FollowerRef)				
			else
				if (npc)
					DialogueRef = pFollowerAlias10.GetActorRef()
					DismissFollower(-1,0)
				endif
				pFollowerAlias10.ForceRefTo(FollowerRef)
			endif
		endif
	endif

	pTweakFollowerScript.EventFollowerRecruited(FollowerRef, false)
	DialogueRef = None
	
EndFunction

Function FollowerWait()

	if (!Running)
		parent.FollowerWait()
		return
	endif

	if (InDialogue)
		CommandCount += 1
	endif	

	; Debug.Notification("Debug Wait")

	if (DialogueRef)
		ReferenceAlias theAlias = FindAlias(DialogueRef)
		if (theAlias)

			Actor FollowerActor = DialogueRef as Actor
			FollowerActor.AddToFaction(pTweakWaitingFaction)

			ActorBase dbase = FollowerActor.GetActorBase()
			if(pDBQuest)
				if (dbase == CiceroDawnstar)
					DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
					dbScript.CiceroState = 3
				elseif (dbase == DBInitiate1)
					DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
					dbScript.Initiate1State = 3
				elseif (dbase == DBInitiate2)
					DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
					dbScript.Initiate2State = 3
				endif
			endif

			FollowerActor.SetAv("WaitingForPlayer", 1)
			; follower will wait 3 days
			; theAlias.RegisterForUpdateGameTime(72)
			return

		endif
		DialogueRef = None
	endif
	;Debug.Notification("Debug: No Dialogue Ref")	

	;DialogueFollower.FollowerWait()
	parent.FollowerWait()

EndFunction

Function FollowerRelax(ObjectReference follower)

	if (!Running)
		return
	endif

	if (InDialogue)
		CommandCount += 1
	endif

	; Debug.Notification("Debug Stop")

	if (!follower)
		Return
	endif

	ReferenceAlias theAlias = FindAlias(follower)
	if (!theAlias)
		Return
	EndIf

	Actor FollowerActor = follower as Actor
	FollowerActor.AddToFaction(pTweakWaitingFaction)

	ActorBase dbase = FollowerActor.GetActorBase()
	if(pDBQuest)
		if (dbase == CiceroDawnstar)
			DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
			dbScript.CiceroState = 3
		elseif (dbase == DBInitiate1)
			DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
			dbScript.Initiate1State = 3
		elseif (dbase == DBInitiate2)
			DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
			dbScript.Initiate2State = 3
		endif
	endif

	FollowerActor.SetAv("WaitingForPlayer", -1)
	return

EndFunction

Function FollowerFollow()

	if (!Running)
		parent.FollowerFollow()
		return
	endif

	if (InDialogue)
		CommandCount += 1
	endif

	if (DialogueRef)
	
		actor npc = DialogueRef As Actor
		npc.RemoveFromFaction(pTweakWaitingFaction)

		ActorBase dbase = npc.GetActorBase()
		if(pDBQuest)
			DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
			if (dbase == CiceroDawnstar)
				dbScript.CiceroFollower = 1
				dbScript.CiceroState = 2
			elseif (dbase == DBInitiate1)
				dbScript.Initiate1Follower = 1
				dbScript.Initiate1State = 2
			elseif (dbase == DBInitiate2)
				dbScript.Initiate2Follower = 1
				dbScript.Initiate2State = 2
			endif
		endif

		; Debug.Notification("Debug: Setting WaitingForPlayer to 0")
		npc.SetActorValue("WaitingForPlayer", 0)		

		; Disable Sleep AI if previously active
		if (57339 == (npc.GetAv("Infamy") as Int))
			npc.SetAv("infamy",0) ; Disable ForceSleep Package (if prev enabled)
			if (0 != (npc.GetAv("infamy") As Int))
				npc.ForceAv("infamy",0) ; Disable ForceSleep Package (if prev enabled)
			endif
			
			; TODO : test if cleaning up bed after sleep still breaks things
			; npc.EvaluatePackage()
			; ObjectReference bedRoll = Game.FindClosestReferenceOfTypeFromRef(BedRollGround, npc, 100.0)
			; if (bedroll)
			; bedroll.DeleteWhenAble()

			Debug.SendAnimationEvent(npc, "IdleForceDefaultState")
		endif
		pTweakFollowerScript.EventFollowerFollow(DialogueRef)
		DialogueRef = None
		npc.EvaluatePackage()
		return
	endif
	;DialogueFollower.FollowerFollow()
	parent.FollowerFollow()

EndFunction

Function DismissFollower(Int iMessage = 0, Int iSayLine = 1)
	; Debug.Notification("Debug Dismiss", )
	if (!Running)
		parent.DismissFollower(iMessage, iSayLine)
		return
	endif
	if (InDialogue)
		CommandCount += 1
	endif	
	if (pAnimalAlias.GetRef() && !pAnimalAlias.GetActorRef().HasKeyword(ActorTypeNPC))
		pAnimalAlias.clear()
	EndIf
	if (DialogueRef)
		ReferenceAlias theAlias = FindAlias(DialogueRef)
		if (theAlias)
			actor npc = DialogueRef As Actor

			if npc.GetRace().HasKeyword(pActorTypeAnimal)
				npc.AddToFaction(pTweakPotentialFollowerFaction)
			else
				ActorBase dbase = npc.GetActorBase()
				if(pDBQuest)
					DarkBrotherhood dbScript = pDBQuest as DarkBrotherhood
					if (dbase == CiceroDawnstar)
						dbScript.CiceroFollower = 0
						dbScript.CiceroState = 1
					elseif (dbase == DBInitiate1)
						dbScript.Initiate1Follower = 0
						dbScript.Initiate1State = 1
					elseif (dbase == DBInitiate2)
						dbScript.Initiate2Follower = 0
						dbScript.Initiate2State = 1
					endif
				endif
			endif
			if (57339 == (npc.GetAv("Infamy") as Int))
				npc.SetAv("infamy",0) ; Disable ForceSleep Package (if prev enabled)
				if (0 != (npc.GetAv("infamy") As Int))
					npc.ForceAv("infamy",0) ; Disable ForceSleep Package (if prev enabled)
				endif
				ObjectReference bedRoll = Game.FindClosestReferenceOfTypeFromRef(BedRollGround, npc, 100.0)
				if (bedroll)
					bedroll.DeleteWhenAble()
				endif
			endif
			if  (!npc.IsDead())
				If (0 == iMessage)
					FollowerDismissMessage.Show()
				ElseIf (1 == iMessage)
					FollowerDismissMessageWedding.Show()
				ElseIf (2 == iMessage)
					FollowerDismissMessageCompanions.Show()
				ElseIf (3 == iMessage)
					FollowerDismissMessageCompanionsMale.Show()
				ElseIf (4 == iMessage)
					FollowerDismissMessageCompanionsFemale.Show()
				ElseIf (5 == iMessage)
					FollowerDismissMessageWait.Show()
				ElseIf (iMessage > -1)
					FollowerDismissMessage.Show()
				EndIf
				npc.StopCombatAlarm()
				if (pDismissedFollower)
					npc.AddToFaction(pDismissedFollower)
				endif
				; npc.SetPlayerTeammate(false)
				if (pCurrentHireling)
					npc.RemoveFromFaction(pCurrentHireling)
				endif
				npc.RemoveFromFaction(pTweakWaitingFaction)
				npc.SetAV("WaitingForPlayer", 0)
				; PATCH 1.9: 77615: remove unplayable arrows when follower is dismissed
				DialogueRef.RemoveItem(pFollowerIronArrow, 999, true)
				; END Patch 1.9 fix

				if (pTweakDawnGuardScript.installed)
					if (npc == pTweakDawnGuardScript.Serena)
						pTweakDawnGuardScript.SerenaDismiss(DialogueRef)
					endif
				endif

				HirelingRehireScript.DismissHireling(npc.GetActorBase())
				if (1 == iSayLine)
					iFollowerDismiss = 1
					npc.AddToFaction(TweakSayDismiss)
					npc.EvaluatePackage()
					;Wait for follower to say line
					Utility.Wait(2)
					npc.RemoveFromFaction(TweakSayDismiss)
					iFollowerDismiss = 0
				endIf
			endif
			theAlias.Clear()
			pTweakFollowerScript.EventFollowerDismissed(DialogueRef)
			npc.SetPlayerTeammate(false)
			DialogueRef = None
		endif
		return
	endif
	;DialogueFollower.DismissFollower(iMessage, iSayLine)
	parent.DismissFollower(iMessage, iSayLine)	
EndFunction

; Debated about putting this one here or on the Tweak quest, but I liked the idea of
; sleep being like waiting... only while you are asleep. 
Function FollowerSleep(ObjectReference FollowerRef)

	if (InDialogue)
		CommandCount += 1
	endif
	
	Actor FollowerActor = FollowerRef as Actor
	ObjectReference sleepLoc = Game.FindClosestReferenceofAnyTypeInListFromRef(TweakBedOptions, FollowerActor, 500.0)
	if (sleepLoc)
		ObjectReference theBed = sleepLoc.PlaceAtMe(Game.GetForm(0x000B8371))
		Utility.wait(2.00) ; Give it time to spawn
		if (sleepLoc.GetBaseObject() == BedrollHay01 || sleepLoc.GetBaseObject() == Bedroll01)
			theBed.SetPosition(sleepLoc.GetPositionX(), sleepLoc.GetPositionY(), sleepLoc.GetPositionZ() + 5)
		else
			theBed.SetPosition(sleepLoc.GetPositionX(), sleepLoc.GetPositionY(), sleepLoc.GetPositionZ() + 30)
		endif
		theBed.SetAngle(0.0 ,0.0 , (sleepLoc.GetAngleZ() - 180) ) 
		; theBed.moveTo(sleepLoc)
		Utility.wait(2.00) ; Give it time to move
	else
		FollowerActor.PlaceAtMe(Game.GetForm(0x000B8371)) ; Place sleep zone under NPC
	endif

	FollowerActor.SetAv("infamy",57339) ; Disable ForceSleep Package (if prev enabled)
	if (57339 != (FollowerActor.GetAv("infamy") As Int))
		FollowerActor.ForceAv("infamy",57339) ; Disable ForceSleep Package (if prev enabled)
	endif
	FollowerActor.EvaluatePackage()
	DialogueRef = FollowerRef
	FollowerWait()

EndFunction

ReferenceAlias Function FindAlias(ObjectReference follower)
	Actor npc = follower As Actor
	if (!npc)
		return None
	endif
	if (pFollowerAlias.GetActorRef() && pFollowerAlias.GetActorRef() == npc)
		return pFollowerAlias
	elseif (pFollowerAlias2.GetActorRef() && pFollowerAlias2.GetActorRef() == npc)
		return pFollowerAlias2
	elseif (pFollowerAlias3.GetActorRef() && pFollowerAlias3.GetActorRef() == npc)
		return pFollowerAlias3
	elseif (pFollowerAlias4.GetActorRef() && pFollowerAlias4.GetActorRef() == npc)
		return pFollowerAlias4
	elseif (pFollowerAlias5.GetActorRef() && pFollowerAlias5.GetActorRef() == npc)
		return pFollowerAlias5
	elseif (pFollowerAlias6.GetActorRef() && pFollowerAlias6.GetActorRef() == npc)
		return pFollowerAlias6
	elseif (pFollowerAlias7.GetActorRef() && pFollowerAlias7.GetActorRef() == npc)
		return pFollowerAlias7
	elseif (pFollowerAlias8.GetActorRef() && pFollowerAlias8.GetActorRef() == npc)
		return pFollowerAlias8
	elseif (pFollowerAlias9.GetActorRef() && pFollowerAlias9.GetActorRef() == npc)
		return pFollowerAlias9
	elseif (pFollowerAlias10.GetActorRef() && pFollowerAlias10.GetActorRef() == npc)
		return pFollowerAlias10
	endif
	return None
endFunction

; Used locally and by TweakStable of Stable Quest and by TweakFollowerScript of TweakFollower Quest

ReferenceAlias[] Function GetAllFollowers(Bool onlyNotWaiting=False, Bool onlyNotWerewolf = False, Bool raw = False)

	ReferenceAlias[] all = new ReferenceAlias[10]
	all[0] = pFollowerAlias
	all[1] = pFollowerAlias2
	all[2] = pFollowerAlias3
	all[3] = pFollowerAlias4
	all[4] = pFollowerAlias5
	all[5] = pFollowerAlias6
	all[6] = pFollowerAlias7
	all[7] = pFollowerAlias8
	all[8] = pFollowerAlias9
	all[9] = pFollowerAlias10

	if (raw)
		return all
	endif

	ReferenceAlias[] ret = new ReferenceAlias[10]
	int count = 0

	int i = 0
	while (i != all.length)
		if (all[i].GetActorRef() && !all[i].GetActorRef().IsDead())
			if (!onlyNotWaiting || ( 0 == all[i].GetActorRef().GetAV("WaitingForPlayer") As Int))
				if (!onlyNotWerewolf || !all[i].GetActorRef().IsInFaction(WerewolfFaction))
					ret[count] = all[i]
					count += 1
				endif
			endif
		endif
		i = i + 1
	endWhile

	ReferenceAlias[] trim;
	if (count == 10)
		trim = new ReferenceAlias[10]
	elseif (count == 9)
		trim = new ReferenceAlias[9]
	elseif (count == 8)
		trim = new ReferenceAlias[8]
	elseif (count == 7)
		trim = new ReferenceAlias[7]
	elseif (count == 6)
		trim = new ReferenceAlias[6]
	elseif (count == 5)
		trim = new ReferenceAlias[5]
	elseif (count == 4)
		trim = new ReferenceAlias[4]
	elseif (count == 3)
		trim = new ReferenceAlias[3]
	elseif (count == 2)
		trim = new ReferenceAlias[2]
	elseif (count == 1)
		trim = new ReferenceAlias[1]		
	else
		trim = none
	endif

	i = 0
	while (i < count)
		trim[i] = ret[i]
		i += 1
	endwhile

	return trim

endFunction

; Get location in world based on npc. IE: To get a location 150 units directly in front of 
; pc : float[] inFront = TraceCircle(Game.GetPlayer(), 150, 0.0)
; valid values for angleOffset = -180 -> 180
; radius : as a reference, 150 is about the height of most NPCs. 

Float[] Function TraceCircle(Actor npc, Float radius = 500.0, Float angleOffset = 0.0)
    float a = npc.GetAngleZ();
    a = 450 - a
    if (a >= 360)
        a = a - 360
    endif 
    a  = a + angleOffset;
    if (a < 0) 
        a = a + 360
    endif
    if (a > 360)
        a = a - 360
    endif 

    Float xoffset = radius * Math.cos(a)
    Float yoffset = radius * Math.sin(a)

    Float[] ret = new Float[3]
    ret[0] =  (npc.GetPositionX() + xoffset)
    ret[1] =  (npc.GetPositionY() + yoffset)
    ret[2] = npc.GetPositionZ()
    return ret

endFunction

Function SetAnimal(ObjectReference AnimalRef)

	; Debug.Notification("Debug SetAnimal")

	if (!Running)
		parent.SetAnimal(AnimalRef)
		return
	endif

	if (InDialogue)
		CommandCount += 1
	endif

	actor AnimalActor= AnimalRef as Actor
	;don't allow lockpicking
	AnimalActor.SetAV("Lockpicking", 0)
	AnimalActor.SetPlayerTeammate(abCanDoFavor = false)
    SetFollower(AnimalRef)
	;AnimalActor.AllowPCDialogue(True)
	;pPlayerAnimalCount.SetValue(1)
	
EndFunction

Function AnimalWait()

	; Debug.Notification("Debug AnimalWait")

	if (!Running)
		parent.AnimalWait()
		return
	endif
	
	if (InDialogue)
		CommandCount += 1
	endif

	if (DialogueRef)
		FollowerWait()
		return
	endif
	parent.AnimalWait()
EndFunction

Function AnimalFollow()

	; Debug.Notification("Debug AnimalFollow")

	if (!Running)
		parent.AnimalFollow()
		return
	endif

	if (InDialogue)
		CommandCount += 1
	endif

	if (DialogueRef)
		FollowerFollow()
		return
	endif
	parent.AnimalFollow()
EndFunction

Function DismissAnimal()

	; Debug.Notification("Debug DismissAnimal")

	if (!Running)
		parent.DismissAnimal()
		return
	endif

	if (InDialogue)
		CommandCount += 1
	endif

	if (DialogueRef)
		ReferenceAlias theAlias = FindAlias(DialogueRef)
		if (theAlias)
			actor DismissedAnimalActor = DialogueRef As Actor
			DismissedAnimalActor.SetActorValue("Variable04", 0)
			DismissFollower(-1,0)
		endif
		return
	endif
	parent.DismissAnimal()
EndFunction

; Relayed From TweakMonitoringPlayer
Function OnDialogueBegin(ObjectReference FollowerRef)

	if (!Running)
		return
	endif

	Actor npc = FollowerRef	As Actor

	; Checks added for custom follower mods. This prevents AFT from
	; auto-importing them when player asks them to follow.
	
	if npc.IsInFaction(pTweakIgnoreFaction)
		return
	endif

	if npc.IsInFaction(pJobJarlFaction)
		return
	endif
	
	;if (FollowerRef.GetCurrentScene())
	;	return
	;endif
	
	CommandCount = 0
	InDialogue = true
	DialogueRef = FollowerRef
	ObjectReference swap = None

	drWasTeammate = npc.IsPlayerTeammate()
	drWasFollower = npc.IsInFaction(pCurrentFollowerFaction)
	if (drWasFollower)
		; Debug.Notification("Debug: Is Current Follower")

		; If follower is in current follower faction, figure out
		; their reference and swap with pFollowerAlias so we 
		; can detect unexpected changes in OnDialogueEnd

		ReferenceAlias theAlias = FindAlias(FollowerRef)
		if (theAlias && theAlias != pFollowerAlias)
			if (pFollowerAlias && pFollowerAlias.GetReference())
				; Debug.Notification("Debug: Swapping Alias")
				swap = pFollowerAlias.GetReference()
				pFollowerAlias.Clear()
			endif
			theAlias.Clear()
			pFollowerAlias.ForceRefTo(FollowerRef)
			if (swap)
				theAlias.ForceRefTo(swap)
			endif
		endif
;	else
;		Debug.Notification("Debug: Is NOT Current Follower")
	endif
	
	if (pFollowerAlias)
		previousSlot1 = pFollowerAlias.GetReference()
	else
		previousSlot1 = None
	endif
	
	drWasWaiting = npc.GetAV("WaitingForPlayer") As Int
	
	
EndFunction

; Relayed From TweakMonitoringPlayer
Function OnDialogueEnd(ObjectReference FollowerRef)

	if (!Running)
		return
	endif

;	Debug.Notification("Debug: OnDialogueEnd")

	;if (FollowerRef.GetCurrentScene())
	;	return
	;endif

	InDialogue = false
;	Debug.Notification("Command Count = [" + CommandCount + "]")
	if (CommandCount > 0)
		Return
	endif
	
	if (!FollowerRef)
		;Debug.Notification("No followerRef, attempting recovery")
		FollowerRef = DialogueRef
	endIf
	
	if (!FollowerRef)
		;Debug.Notification("No followerRef, bailing")
		return
	endIf

	;Debug.Notification("Follower Ref Valid")
	
	Actor npc = FollowerRef	As Actor
	
	if npc.IsInFaction(pTweakIgnoreFaction)
		return
	endif

	if npc.IsInFaction(pJobJarlFaction)
		return
	endif

	Bool drIsTeammate = npc.IsPlayerTeammate()
	Bool drIsFollower = npc.IsInFaction(pCurrentFollowerFaction)
	Int drIsWaiting = npc.GetAV("WaitingForPlayer") As Int

	if (drWasFollower != drIsFollower)
		
		; So the NPC was added or removed from the CurrentFollowerFaction, but we 
		; never got a command count increment. If a vanilla NPC was added using 
		; the vanilla SetFollower, then pFollowerAlias was likely clobbered. If 
		; the user was removed, then our swap in the OnDialogueBegin event 
		; probably prevented any damage, but AFT was not properly informed of the event. 

		; Both of these scenarios can be handled by rolling back the change and doing it
		; over. That is, restore the pFollowerAlias to its previous value and then call
		; the local methods to handle things properly.
		
		; Debug.Notification("Debug: Follower Joined/Left. Attempting Recovery")
		
		if (!npc.GetRace().HasKeyword(pActorTypeAnimal))
			; Debug.Notification("Non-Animal Detected")
			if (pFollowerAlias && pFollowerAlias.GetActorRef())
				pFollowerAlias.Clear()
			endif
			if (previousSlot1)
				pFollowerAlias.ForceRefTo(previousSlot1)
			endif
			DialogueRef = FollowerRef
			if (drIsFollower)
;				Debug.Notification("Vanilla Follow Detected")
				SetFollower(FollowerRef)
			else
;				Debug.Notification("Vanilla Dismiss Detected")
				DismissFollower(-1,0)
			endif
		else
			; Same soluton for animals, only we are dealing with the animal alias
		
			; Debug.Notification("Animal Detected")
			if (pAnimalAlias && pAnimalAlias.GetReference())
				pAnimalAlias.Clear()
			endif
			DialogueRef = FollowerRef
			if (drIsFollower)
				SetAnimal(FollowerRef)
			else
				DismissAnimal()
			endif
		endif		
		return

	elseif (drWasTeammate !=  drIsTeammate && npc.GetAV("FavorActive") != 0)

		; If we are managing them, there is no reason teammate status should
		; change and not currentFollower Status. So we are most likely we are dealing 
		; with a custom dialogue of a follower that was imported into AFT. For
		; example: Serena... Note that if we call Dismiss on someone who isnt
		; managed, the function will just bail anyway. 

		DialogueRef = FollowerRef
		if (drIsTeammate)
			if (!npc.GetRace().HasKeyword(pActorTypeAnimal))
				SetFollower(FollowerRef)
			else
				SetAnimal(FollowerRef)
			endif
		else
			if (!npc.GetRace().HasKeyword(pActorTypeAnimal))
				DismissFollower(-1,0)
			else
				DismissAnimal()
			endif
		endif
;	else
;		debug.Notification("All conditions failed")
	endif
		
	; We only need to check waiting if they are currently a follower.
	; Furthermore, if they are a follower, that precludes the possibility
	; of the 3rd scenario. 

	if (drIsFollower)
	
;		Debug.Notification("Debug: Follower Detected. Checking wait")

		if (drWasWaiting != drIsWaiting)

;			Debug.Notification("Debug: Follower Wait/Follow. Attempting Recovery")
		
			; So their wait state changed, but we never got a command count increment.
			; We will confirm that the objectRef matches one of the aliases and 
			; send the wait event...

			ReferenceAlias theAlias = FindAlias(DialogueRef)
			if (theAlias)
				DialogueRef = FollowerRef
				if (1 == drIsWaiting)
;					Debug.Notification("Debug: Calling Follower Wait")
					FollowerWait()
				else
;					Debug.Notification("Debug: Calling Follower Follow")
					FollowerFollow()
				endif
			endif
			
;		else
;			Debug.Notification("Debug: No wait change detected")
		endif
		
		return
;	else
;		Debug.Notification("Debug: Not Follower, Skipping wait check")
	endif


	; The final scenario is the idea of a follower that doesn't use the standard follower
	; system but is following the player...

	; We dont actually handle them here. Rather, AFT maintains the TweakImport Quest and
	; TweakSafeImport Faction. If an actor is added to the faction, they will get a 
	; dialogue allowing the user to choose if they want to manage the NPC with AFT.
	; 
	; The actual import is handled by the TweakImportQuest and will generally result in
	; a call to SetFollower() at some point. Custom followers often require custom handling, 
	; which is why we do not provide a general approach here. 
	
EndFunction

Function TrySandBox()

	if (!Running)
		return
	endif

	Actor npc
	if (pFollowerAlias)
		npc = pFollowerAlias.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias.GetActorRef().EvaluatePackage()
		endif
	endif
	if (pFollowerAlias2)
		npc = pFollowerAlias2.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias2.GetActorRef().EvaluatePackage()
		endif
	endif
	if (pFollowerAlias3)
		npc = pFollowerAlias3.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias3.GetActorRef().EvaluatePackage()
		endif	
	endif
	if (pFollowerAlias4)
		npc = pFollowerAlias4.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias4.GetActorRef().EvaluatePackage()
		endif
	endif
	if (pFollowerAlias5)
		npc = pFollowerAlias5.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias5.GetActorRef().EvaluatePackage()
		endif
	endif
	if (pFollowerAlias6)
		npc = pFollowerAlias6.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias6.GetActorRef().EvaluatePackage()
		endif
	endif
	if (pFollowerAlias7)
		npc = pFollowerAlias7.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias7.GetActorRef().EvaluatePackage()
		endif
	endif
	if (pFollowerAlias8)
		npc = pFollowerAlias8.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias8.GetActorRef().EvaluatePackage()
		endif
	endif
	if (pFollowerAlias9)
		npc = pFollowerAlias9.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias9.GetActorRef().EvaluatePackage()
		endif
	endif
	if (pFollowerAlias10)
		npc = pFollowerAlias10.GetActorRef()
		if (npc && !npc.IsInFaction(TweakSandbox))
			pFollowerAlias10.GetActorRef().EvaluatePackage()
		endif
	endif

EndFunction

Function EvaluatePackages()

	Actor npc
	if (pFollowerAlias)
		npc = pFollowerAlias.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
	if (pFollowerAlias2)
		npc = pFollowerAlias2.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
	if (pFollowerAlias3)
		npc = pFollowerAlias3.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif	
	endif
	if (pFollowerAlias4)
		npc = pFollowerAlias4.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
	if (pFollowerAlias5)
		npc = pFollowerAlias5.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
	if (pFollowerAlias6)
		npc = pFollowerAlias6.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
	if (pFollowerAlias7)
		npc = pFollowerAlias7.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
	if (pFollowerAlias8)
		npc = pFollowerAlias8.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
	if (pFollowerAlias9)
		npc = pFollowerAlias9.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
	if (pFollowerAlias10)
		npc = pFollowerAlias10.GetActorRef()
		if (npc)
			npc.EvaluatePackage()
		endif
	endif
EndFunction

Function ResetSandBox()
	if (pFollowerAlias && pFollowerAlias.GetActorRef())
		pFollowerAlias.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias2 && pFollowerAlias2.GetActorRef())
		pFollowerAlias2.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias3 && pFollowerAlias3.GetActorRef())
		pFollowerAlias3.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias4 && pFollowerAlias4.GetActorRef())
		pFollowerAlias4.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias5 && pFollowerAlias5.GetActorRef())
		pFollowerAlias5.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias6 && pFollowerAlias6.GetActorRef())
		pFollowerAlias6.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias7 && pFollowerAlias7.GetActorRef())
		pFollowerAlias7.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias8 && pFollowerAlias8.GetActorRef())
		pFollowerAlias8.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias9 && pFollowerAlias9.GetActorRef())
		pFollowerAlias9.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
	if (pFollowerAlias10 && pFollowerAlias10.GetActorRef())
		pFollowerAlias10.GetActorRef().RemoveFromFaction(TweakSandbox)
	endif
EndFunction

Function SetCapAtThree(bool bCapAtThree)
	if (bCapAtThree)
		TweakLimitFollowers.SetValueInt(1)
		Actor npc = pFollowerAlias4.GetActorRef()
		if (npc)
			DialogueRef = npc
			DismissFollower(-1,0)
			if(pTweakDawnGuardScript.installed && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 2 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias2.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias2.ForceRefTo(npc)
			endif
		EndIf
		npc = pFollowerAlias5.GetActorRef()
		if (npc)
			DialogueRef = npc
			DismissFollower(-1,0)
			if(pTweakDawnGuardScript.installed && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 2 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias2.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias2.ForceRefTo(npc)
			endif
		EndIf
		npc = pFollowerAlias6.GetActorRef()
		if (npc)
			DialogueRef = npc
			DismissFollower(-1,0)
			if(pTweakDawnGuardScript.installed && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 2 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias2.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias2.ForceRefTo(npc)
			endif
		EndIf
		npc = pFollowerAlias7.GetActorRef()
		if (npc)
			DialogueRef = npc
			DismissFollower(-1,0)
			if(pTweakDawnGuardScript.installed && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 2 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias2.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias2.ForceRefTo(npc)
			endif
		EndIf
		npc = pFollowerAlias8.GetActorRef()
		if (npc)
			DialogueRef = npc
			DismissFollower(-1,0)
			if(pTweakDawnGuardScript.installed && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 2 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias2.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias2.ForceRefTo(npc)
			endif
		EndIf
		npc = pFollowerAlias9.GetActorRef()
		if (npc)
			DialogueRef = npc
			DismissFollower(-1,0)
			if(pTweakDawnGuardScript.installed && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 2 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias2.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias2.ForceRefTo(npc)
			endif
		EndIf
		npc = pFollowerAlias10.GetActorRef()
		if (npc)
			DialogueRef = npc
			DismissFollower(-1,0)
			if(pTweakDawnGuardScript.installed && npc == pTweakDawnGuardScript.Serena)
				; Dismiss 2 instead. Never Auto-Dimiss Serena
				DialogueRef = pFollowerAlias2.GetActorRef()
				DismissFollower(-1,0)
				pFollowerAlias2.ForceRefTo(npc)
			endif
		EndIf
	Else
		TweakLimitFollowers.SetValueInt(0)
	endif
EndFunction
