Scriptname TweakFollowerInfoScript extends Quest  
{renn's Tweak ;TweakFollower}

; One Handed Perks
Perk Property Armsman00  Auto
Perk Property DualFlurry30  Auto
Perk Property DualSavagery  Auto
Perk Property FightingStance  Auto
Perk Property HackandSlash30  Auto
Perk Property BoneBreaker30  Auto
Perk Property Bladesman30  Auto
Perk Property CriticalCharge  Auto
Perk Property SavageStrike  Auto
Perk Property ParalyzingStrike  Auto

; Two Handed Perks
Perk Property Barbarian00  Auto
Perk Property ChampionsStance  Auto
Perk Property Limbsplitter30  Auto
Perk Property Skullcrusher30  Auto
Perk Property DeepWounds30  Auto
Perk Property DevastatingBlow  Auto
Perk Property GreatCriticalCharge  Auto
Perk Property Sweep  Auto
Perk Property WarMaster  Auto

; Heavy Armor Perks
Perk Property Juggernaut00  Auto
Perk Property WellFitted  Auto
Perk Property TowerOfStrength  Auto
Perk Property MatchingSetHeavy Auto
Perk Property ReflectBlows  Auto
Perk Property Conditioning  Auto

; Light Armor Perks
Perk Property AgileDefender00  Auto
Perk Property CustomFit  Auto
Perk Property MatchingSet  Auto
Perk Property Unhindered  Auto
Perk Property WindWalker  Auto
Perk Property DeftMovement  Auto

; Block Perks
Perk Property ShieldWall00  Auto
Perk Property PowerBashPerk  Auto
Perk Property DeflectArrows  Auto
Perk Property DeadlyBash  Auto
Perk Property DisarmingBash  Auto
Perk Property ElementalProtection  Auto
Perk Property ShieldCharge  Auto

; Archery Perks
Perk Property Overdraw00  Auto
Perk Property CriticalShot30  Auto
Perk Property PowerShot  Auto
Perk Property QuickShot  Auto
Perk Property BullsEye  Auto

; Sneak Perks
Perk Property Stealth00  Auto
Perk Property MuffledMovement  Auto
Perk Property Lightfoot  Auto
Perk Property SilentRoll  Auto
Perk Property Silence  Auto
Perk Property Backstab  Auto
Perk Property DeadlyAim  Auto
Perk Property AssassinsBlade  Auto

; Alteration
Perk Property AlterationNovice00  Auto
Perk Property AlterationApprentice25  Auto
Perk Property AlterationAdept50  Auto
Perk Property AlterationExpert75  Auto
Perk Property AlterationMaster100  Auto
Perk Property MageArmor30  Auto
Perk Property MagicResistance30  Auto
Perk Property Stability  Auto
Perk Property Atronach  Auto

; Restoration
Perk Property RestorationNovice00  Auto
Perk Property RestorationApprentice25  Auto
Perk Property RestorationAdept50  Auto
Perk Property RestorationExpert75  Auto
Perk Property RestorationMaster100  Auto
Perk Property Recovery30  Auto
Perk Property AvoidDeath  Auto
Perk Property Regeneration  Auto
Perk Property Respite  Auto
Perk Property Necromage  Auto
Perk Property WardAbsorb  Auto

; Destruction
Perk Property DestructionNovice00  Auto
Perk Property DestructionApprentice25  Auto
Perk Property DestructionAdept50  Auto
Perk Property DestructionExpert75  Auto
Perk Property DestructionMaster100  Auto
Perk Property AugmentedShock  Auto
Perk Property AugmentedFrost  Auto
Perk Property AugmentedFlames  Auto
Perk Property Disintegrate  Auto
Perk Property DeepFreeze  Auto
Perk Property IntenseFlames  Auto

; Conjuration
Perk Property ConjurationNovice00  Auto
Perk Property ConjurationApprentice25  Auto
Perk Property ConjurationAdept50  Auto
Perk Property ConjurationExpert75  Auto
Perk Property ConjurationMaster100  Auto
Perk Property Summoner30  Auto
Perk Property Atromancy  Auto
Perk Property ElementalPotency  Auto

; Alchemy
Perk Property Alchemist00  Auto
Perk Property Physician  Auto
Perk Property Poisoner  Auto
Perk Property ConcentratedPoison  Auto
Perk Property SnakeBlood  Auto

; PickPocket
Perk Property LightFingers00  Auto
Perk Property NightThief  Auto
Perk Property ExtraPockets  Auto
Perk Property CutPurse  Auto
Perk Property Misdirection  Auto

; LockPicking
Perk Property NoviceLocks00  Auto
Perk Property ApprenticeLocks25  Auto
Perk Property AdeptLocks50  Auto
Perk Property ExpertLocks75  Auto
Perk Property MasterLocks100  Auto
Perk Property QuickHands  Auto

Race Property ArgonianRace  Auto  
Race Property BretonRace  Auto  
Race Property DarkElfRace  Auto  
Race Property HighElfRace  Auto  
Race Property ImperialRace  Auto  
Race Property KhajiitRace  Auto  
Race Property NordRace  Auto  
Race Property OrcRace  Auto  
Race Property RedguardRace  Auto  
Race Property WoodElfRace  Auto  

Spell property WerewolfChange Auto
Spell property AbVampireSkills Auto
Faction Property TweakUseWerewolfFaction  Auto  
Faction Property TweakUseVampireFaction  Auto  
Faction Property PotentialMarriageFaction  Auto  
Faction property pTweakManageLevelUpFaction auto

Function InfoStats(ObjectReference follower)
	actor NPC = follower as Actor

	String oName = NPC.GetName()
	Race oRace = npc.GetRace()

	ReferenceAlias theAlias = ((Self As Quest) As TweakFollowerScript).FindAlias(follower)
	if (theAlias)
		TweakSettings settings = (theAlias As TweakSettings)
		oName = settings.originalName
		oRace = settings.originalRace
	endif

	String sRace = ""
	if (oRace == NordRace)
		sRace = "Nord"
	elseif (oRace == BretonRace)
		sRace = "Breton"
	elseif (oRace == ImperialRace)
		sRace = "Imperial"
	elseif (oRace == OrcRace)
		sRace = "Orc"
	elseif (oRace == RedguardRace)
		sRace = "Redguard"
	elseif (oRace == WoodElfRace)
		sRace = "WoodElf"
	elseif (oRace == DarkElfRace)
		sRace = "DarkElf"
	elseif (oRace == HighElfRace)
		sRace = "HighElf"
	elseif (oRace == ArgonianRace)
		sRace = "Argonian"
	elseif (oRace == KhajiitRace)
		sRace = "Khajiit"
	endif

	String status = ""
	String footer = ""

	;if oName != "Follower"
		status += "Name[" + oName + "] " + "\n"
	;endif
	if sRace != ""
		status += "Race[" + sRace + "] "
	endif

	int npcLevel = NPC.GetLevel() As Int
	int pcLevel = Game.GetPlayer().GetLevel() As Int

	bool boost = NPC.IsInFaction(pTweakManageLevelUpFaction)
	if !boost
		int cstyle = NPC.GetActorValue("FavorsPerDayTimer") As Int
		if cstyle > 730 && cstyle < 739
			boost = True
		EndIf
	EndIf

	if (boost && npcLevel < pcLevel)
		status += "Level[" + pcLevel + "**]\n"
		footer += "** = Synthetically boosted by AFT"
	else
		status += "Level[" + npcLevel + "]\n"
	endif
	
	status += "H: ["
	status += (NPC.GetAv("health") as Int) + "/" + (NPC.GetBaseAv("health") as Int)

	status += "] S: ["
	status += (NPC.GetAv("stamina") as Int) + "/" + (NPC.GetBaseAv("stamina") as Int)

	status += "] M: ["
	status += (NPC.GetAv("magicka") as Int) + "/" + (NPC.GetBaseAv("magicka") as Int)
	status += "]\n"
	status += "Regen: Health["
	status += Math.Ceiling(((NPC.GetAv("HealRate") as float) *  (NPC.GetBaseAv("health") as float)) / 100) + "/s"

	status += "] Stam["
	status += (NPC.GetAv("StaminaRate") as Int) + "/s"

	status += "] Mag["
	status += (NPC.GetAv("MagickaRate") as Int) + "/s"
	status += "]\n"

	status += "Resist[Fir:"
	status += (NPC.GetActorValue("FireResist") as Int)
	status += " Ele:"
	status += (NPC.GetActorValue("ElectricResist") as Int)
	status += " Ice:"
	status += (NPC.GetActorValue("FrostResist") as Int)
	status += " Mag:"
	status += (NPC.GetActorValue("MagicResist") as Int)
	status += " Poi:"
	status += (NPC.GetActorValue("PoisonResist") as Int)
	status += " ]\n"
	status += "Armor Rating["
	status += (NPC.GetActorValue("DamageResist") as Int)
	status +="]"

	if npc.HasSpell(WerewolfChange)
		status +=" Powers[Werewolf]"
	elseif npc.HasSpell(AbVampireSkills)
		status +=" Powers[Vampire]"
	endif

	status += "\n\n"
	status += "One Handed["
	status += (NPC.GetAv("onehanded") as Int)
	status +="]   Two Handed["
	status += (NPC.GetAv("twohanded") as Int)
	status +="]  Archery["
	status += (NPC.GetAv("Marksman") as Int)
	status +="]\n"

	status +="Heavy Armor["
	status += (NPC.GetAv("HeavyArmor") as Int)
	status +="]  Light Armor["
	status += (NPC.GetAv("LightArmor") as Int)
	status +="]   Block["
	status += (NPC.GetAv("Block") as Int)
	status +="]\n"

	status +="Sneak["
	status += (NPC.GetAv("Sneak") as Int)
	status +="]   PickPocket["
	status += (NPC.GetAv("Pickpocket") as Int)
	status +="]   LockPicking["
	status += (NPC.GetAv("Lockpicking") as Int)
	status +="]\n"

	status +="Smithing["
	status += (NPC.GetAv("Smithing") as Int)
	status +="]      Speech["
	status += (NPC.GetAv("Speechcraft") as Int)
	status +="]     Alchemy["
	status += (NPC.GetAv("Alchemy") as Int)
	status +="]\n"

	status +="Conjuration["
	status += (NPC.GetAv("Conjuration") as Int)
	status +="] Alteration["
	status += (NPC.GetAv("Alteration") as Int)
	status += "] Enchanting["
	status += (NPC.GetAv("Enchanting") as Int)
	status +="]\n"

	status +="Destruction["
	status += (NPC.GetAv("Destruction") as Int)
	status +="] Illusion["
	status += (NPC.GetAv("Illusion") as Int)
	status +="] Restoration["
	status += (NPC.GetAv("Restoration") as Int)
	status +="]\n\n"
	status += footer
	Debug.MessageBox(status)

endFunction

Function InfoPerks(ObjectReference follower)
	
	actor NPC = follower as Actor

	String oName = NPC.GetName()
	ReferenceAlias theAlias = ((Self As Quest) As TweakFollowerScript).FindAlias(follower)
	if (theAlias)
		TweakSettings settings = (theAlias As TweakSettings)
		oName = settings.originalName
	endif
	
	; ================ 1 ==================

	int one = NPC.GetAv("onehanded") as Int
	String status = oName + "\n" + "------------------------ Perks [1/2] ------------------------\n"
	status += "One Handed ["
		if (npc.HasPerk(Armsman00))
			status += Armsman00.GetName() + ", " ;"Armsman, "
		endif
		if (one > 19 && npc.HasPerk(FightingStance))
			status += FightingStance.GetName() + ", " ;"FightingStance, "
		endif
		if (one > 29)
			if (npc.HasPerk(HackandSlash30))
				status += HackandSlash30.GetName() + ", " ;"HackandSlash, "
			endif
			if (npc.HasPerk(BoneBreaker30))
				status += BoneBreaker30.GetName() + ", " ;"BoneBreaker, "
			endif
			if (npc.HasPerk(Bladesman30))
				status += Bladesman30.GetName() + ", " ;"Bladesman, "
			endif
			if (npc.HasPerk(DualFlurry30))
				status += DualFlurry30.GetName() + ", " ;"DualFlurry, "
			endif
		endIf
		if (one > 49)
			if (npc.HasPerk(SavageStrike))
				status += SavageStrike.GetName() + ", " ;"SavageStrike, "
			endif
			if (npc.HasPerk(CriticalCharge))
				status += CriticalCharge.GetName() + ", " ;"CriticalCharge, "
			endif
		endIf
		if (one > 69)
			if (npc.HasPerk(DualSavagery))
				status += DualSavagery.GetName() + ", " ;"DualSavagery, "
			endif
		endIf
		if (one > 99 && npc.HasPerk(ParalyzingStrike))
			status += ParalyzingStrike.GetName() ;"ParalyzingStrike"
		endif
	status += "]\n"

	int two = NPC.GetAv("twohanded") as Int
	status += "Two Handed ["
		if (npc.HasPerk(Barbarian00))
			status += Barbarian00.GetName() + ", " ;"Barbarian, "
		endif
		if (two > 19 && npc.HasPerk(ChampionsStance))
			status += ChampionsStance.GetName() + ", " ;"ChampionsStance, "
		endif
		if (two > 29)
			if (npc.HasPerk(Limbsplitter30))
				status += Limbsplitter30.GetName() + ", " ;"Limbsplitter, "
			endif
			if (npc.HasPerk(Skullcrusher30))
				status += Skullcrusher30.GetName() + ", " ;"Skullcrusher, "
			endif
			if (npc.HasPerk(DeepWounds30))
				status += DeepWounds30.GetName() + ", " ;"DeepWounds, "
			endif
		endif
		if (two > 49)
			if (npc.HasPerk(DevastatingBlow))
				status += DevastatingBlow.GetName() + ", " ;"DevastatingBlow, "
			endif
			if (npc.HasPerk(GreatCriticalCharge))
				status += GreatCriticalCharge.GetName() + ", " ;"GreatCriticalCharge, "
			endif
		endif
		if (two > 69 && npc.HasPerk(Sweep))
			status += Sweep.GetName() + ", " ;"Sweep, "
		endif
		if (two > 99 && npc.HasPerk(WarMaster))
			status += WarMaster.GetName() ;"WarMaster"
		endif
	status += "]\n"

	int larmor = NPC.GetAv("LightArmor") as int
	status += "Light Armor ["
		if (npc.HasPerk(AgileDefender00))
			status += AgileDefender00.GetName() + ", " ;"AgileDefender, "
		endif
		if (larmor > 29 && npc.HasPerk(CustomFit))
			status += CustomFit.GetName() + ", " ;"CustomFit, "
		endif
		if (larmor > 49 && npc.HasPerk(Unhindered))
			status += Unhindered.GetName() + ", " ;"Unhindered, "
		endif
		if (larmor > 59 && npc.HasPerk(WindWalker))
			status += WindWalker.GetName() + ", " ;"WindWalker, "
		endif
		if (larmor > 69 && npc.HasPerk(MatchingSet))
			status += MatchingSet.GetName() + ", " ;"MatchingSet, "
		endif
		if (larmor > 99 && npc.HasPerk(DeftMovement))
			status += DeftMovement.GetName() ;"DeftMovement"
		endif
	status += "]\n"

	int harmor = NPC.GetAv("HeavyArmor") as int
    status += "Heavy Armor ["
		if (npc.HasPerk(Juggernaut00))
			status += Juggernaut00.GetName() + ", " ;"Juggernaut, "
		endif
		if (harmor > 29 && npc.HasPerk(WellFitted))
			status += WellFitted.GetName() + ", " ;"WellFitted, "
		endif
		if (harmor > 49 && npc.HasPerk(TowerOfStrength))
			status += TowerOfStrength.GetName() + ", " ;"TowerOfStrength, "
		endif
		if (harmor > 69)
			if (npc.HasPerk(MatchingSetHeavy))
				status += MatchingSetHeavy.GetName() + ", " ;"MatchingSetHeavy, "
			endIf
			if (npc.HasPerk(Conditioning))
				status += Conditioning.GetName() + ", " ;"Conditioning, "
			endif
		endif
		if (harmor > 99 && npc.HasPerk(ReflectBlows))
			status += ReflectBlows.GetName() ;"ReflectBlows"
		endif
	status += "]\n"

	int bow = NPC.GetAv("Marksman") as int
	status += "Archery ["
		if (npc.HasPerk(Overdraw00))
			status += Overdraw00.GetName() + ", " ;"Overdraw, "
		endif
		if (bow > 29 && npc.HasPerk(CriticalShot30))
			status += CriticalShot30.GetName() + ", " ;"CriticalShot, "
		endif
		if (bow > 49 && npc.HasPerk(PowerShot))
			status += PowerShot.GetName() + ", " ;"PowerShot, "
		endif
		if (bow > 69 && npc.HasPerk(QuickShot))
			status += QuickShot.GetName() + ", " ;"QuickShot, "
		endif
		if (bow > 99 && npc.HasPerk(BullsEye))
			status += BullsEye.GetName() ;"BullsEye"
		endif
	status += "]\n"

	int block = NPC.GetAv("Block") as int
	status += "Block ["
		if (npc.HasPerk(ShieldWall00))
			status += ShieldWall00.GetName() + ", " ;"ShieldWall, "
		endif
		if (block > 29)
			if (npc.HasPerk(PowerBashPerk))
				status += PowerBashPerk.GetName() + ", " ;"PowerBash, "
			endif
			if (npc.HasPerk(DeflectArrows))
				status += DeflectArrows.GetName() + ", " ;"DeflectArrows, "
			endif
		endif
		if (block > 49)
			if (npc.HasPerk(DeadlyBash))
				status += DeadlyBash.GetName() + ", " ;"DeadlyBash, "
			endif
			if (npc.HasPerk(ElementalProtection))
				status += ElementalProtection.GetName() + ", " ;"ElementalProt, "
			endif
		endif
		if (block > 69 && npc.HasPerk(DisarmingBash))
			status += DisarmingBash.GetName() + ", " ;"DisarmingBash, "
		endif
		if (block > 99 && npc.HasPerk(ShieldCharge))
			status += ShieldCharge.GetName() + ", " ;"ShieldCharge"
		endif
	status += "]\n"

	int sneak = NPC.GetAv("Sneak") as int
	status += "Sneak ["
		if (npc.HasPerk(Stealth00))
			status += Stealth00.GetName() + ", " ;"Stealth, "
		endif
		if (sneak > 29)
			if (npc.HasPerk(MuffledMovement))
				status += MuffledMovement.GetName() + ", " ;"MuffledMovement, "
			endif
			if (npc.HasPerk(Backstab))
				status += Backstab.GetName() + ", " ;"Backstab, "
			endif
		endif
		if (sneak > 39)
			if (npc.HasPerk(Lightfoot))
				status += Lightfoot.GetName() + ", " ;"Lightfoot, "
			endif
			if (npc.HasPerk(DeadlyAim))
				status += DeadlyAim.GetName() + ", " ;"DeadlyAim, "
			endif
		endif
		if (sneak > 49)
			if (npc.HasPerk(SilentRoll))
				status += SilentRoll.GetName() + ", " ;"SilentRoll, "
			endif
			if (npc.HasPerk(AssassinsBlade))
				status += AssassinsBlade.GetName() + ", " ;"AssassinsBlade, "
			endif
		endif
		if (sneak > 69 && npc.HasPerk(Silence))
			status += Silence.GetName() ;"Silence"
		endif
	status += "]\n"

	Debug.MessageBox(status)

	; ================ 2 ==================

	status = oName + "\n" + "------------------------ Perks [2/2] ------------------------\n"

	; Alchemy
	int alchemy = NPC.GetAv("Alchemy") as int
	status += "Alchemy ["

		if (npc.HasPerk(Alchemist00))
			status += Alchemist00.GetName() + ", " ;"Alchemist, "
		endif
		
		if (alchemy > 19 && npc.HasPerk(Physician))
			status += Physician.GetName() + ", " ;"Physician, "
		endif
		if (alchemy > 29 && npc.HasPerk(Poisoner))
			status += Poisoner.GetName() + ", " ;"Poisoner, "
		endif
		if (alchemy > 59 && npc.HasPerk(ConcentratedPoison))
			status += ConcentratedPoison.GetName() + ", " ;"ConcentratedPoison, "
		endif
		if (alchemy > 79 && npc.HasPerk(SnakeBlood))
			status += SnakeBlood.GetName() + ", " ;"SnakeBlood, "
		endif

	status += "]\n"

	int pickpocket = NPC.GetAv("Pickpocket") as int
	; PickPocket
	status += "PickPocket ["

		if (npc.HasPerk(LightFingers00))
			status += LightFingers00.GetName() + ", " ;"LightFingers, "
		endif
		if (pickpocket > 29 && npc.HasPerk(NightThief))
			status += NightThief.GetName() + ", " ;"NightThief, "
		endif
		if (pickpocket > 39 && npc.HasPerk(CutPurse))
			status += CutPurse.GetName() + ", " ;"CutPurse, "
		endif
		if (pickpocket > 49 && npc.HasPerk(ExtraPockets))
			status += ExtraPockets.GetName() + ", " ;"ExtraPockets, "
		endif
		if (pickpocket > 69 && npc.HasPerk(Misdirection))
			status += Misdirection.GetName() ;"Misdirection, "
		endif

	status += "]\n"

	int lockpick = NPC.GetAv("Lockpicking") as int
	; LockPicking
	status += "LockPicking ["

		String tlevel = ""
		if (npc.HasPerk(NoviceLocks00))
			tlevel = NoviceLocks00.GetName() ;"Novice"
		endif
		if (lockpick > 24 && npc.HasPerk(ApprenticeLocks25))
			tlevel = ApprenticeLocks25.GetName() ;"Apprentice"
		endif
		if (lockpick > 39 && npc.HasPerk(QuickHands))
			status += QuickHands.GetName() + ", " ;"QuickHands, "
		endif
		if (lockpick > 49 && npc.HasPerk(AdeptLocks50))
			tlevel = AdeptLocks50.GetName() ;"Adept"
		endIf
		if (lockpick > 74 && npc.HasPerk(ExpertLocks75))
			tlevel = ExpertLocks75.GetName() ;"Expert"
		endIf
		if (lockpick > 99 && npc.HasPerk(MasterLocks100))
			tlevel = MasterLocks100.GetName() ;"Master"
		endIf
        status += tlevel

    status += "]\n"

	; Destruction
	int destruction = NPC.GetAv("Destruction") as int
	status += "Destruction ["

		String dlevel = ""
		if (npc.HasPerk(DestructionNovice00))
			dlevel = DestructionNovice00.GetName() ;"Novice"
		endif
		if (destruction > 24 && npc.HasPerk(DestructionApprentice25))
			dlevel = DestructionApprentice25.GetName() ;"Apprentice"
		endIf
		if (destruction > 29)
			if (npc.HasPerk(AugmentedShock))
				status += AugmentedShock.GetName() + ", " ;"AugmentedShock, "
			endif
			if (npc.HasPerk(AugmentedFrost))
				status += AugmentedFrost.GetName() + ", " ;"AugmentedFrost, "
			endif
			if (npc.HasPerk(AugmentedFlames))
				status += AugmentedFlames.GetName() + ", " ;"AugmentedFlames, "
			endif
		endif

		if (destruction > 49)
			if (npc.HasPerk(DestructionAdept50))
				dlevel = DestructionAdept50.GetName() ;"Adept"
			endif
			if (npc.HasPerk(IntenseFlames))
				status += IntenseFlames.GetName() ;"IntenseFlames"
			endif
		endIf
		if (destruction > 59 && npc.HasPerk(DeepFreeze))
			status += DeepFreeze.GetName() + ", " ;"DeepFreeze, "
		endif
		if (destruction > 69 && npc.HasPerk(Disintegrate))
			status += Disintegrate.GetName() + ", " ;"Disintegrate, "
		endif
		if (destruction > 74 && npc.HasPerk(DestructionExpert75))
			dlevel = DestructionExpert75.GetName() ;"Expert"
		endif
		if (destruction > 99 && npc.HasPerk(DestructionMaster100))
			dlevel = DestructionMaster100.GetName() ;"Master"
		endif
		status += dlevel

	status += "]\n"

	int conjuration = NPC.GetAv("Conjuration") as int

	; Conjuration
	status += "Conjuration ["

		String clevel = ""

		if (npc.HasPerk(ConjurationNovice00))
			clevel = ConjurationNovice00.GetName() ;"Novice"
		endif
		if (conjuration > 24 && npc.HasPerk(ConjurationApprentice25))
			clevel = ConjurationApprentice25.GetName() ;"Apprentice"
		endif
		if (conjuration > 29 && npc.HasPerk(Summoner30))
			status += Summoner30.GetName() + ", " ;"Summoner, "
		endif
		if (conjuration > 39 && npc.HasPerk(Atromancy))
			status += Atromancy.GetName() + ", " ;"Atromancy, "
		endif
		if (conjuration > 49 && npc.HasPerk(ConjurationAdept50))
			clevel = ConjurationAdept50.GetName() ;"Adept"
		endif
		if (conjuration > 74 && npc.HasPerk(ConjurationExpert75))
			clevel = ConjurationExpert75.GetName() ;"Expert"
		endif
		if (conjuration > 79 && npc.HasPerk(ElementalPotency))
			status += ElementalPotency.GetName() + ", " ;"ElementalPotency, "
		endif
		if (conjuration > 99 && npc.HasPerk(ConjurationMaster100))
			clevel = ConjurationMaster100.GetName() ;"Master"
		endif
		status += clevel

	status += "]\n"

	int alteration = NPC.GetAv("Alteration") as int
	; Alteration
	status += "Alteration ["
		String alevel = ""
		if (npc.HasPerk(AlterationNovice00))
			alevel = AlterationNovice00.GetName() ;"Novice"
		endIf
		if (alteration > 24 && npc.HasPerk(AlterationApprentice25))
			alevel = AlterationApprentice25.GetName() ;"Apprentice"
		endif
		if (alteration > 29)
			if (npc.HasPerk(MageArmor30))
				status += MageArmor30.GetName() + ", " ;"MageArmor, "
			endif
			if (npc.HasPerk(MagicResistance30))
				status += MagicResistance30.GetName() + ", " ;"MagicResistance, "
			endif
		endif
		if (alteration > 49 && npc.HasPerk(AlterationAdept50))
			alevel = AlterationAdept50.GetName() ;"Adept"
		endif
		if (alteration > 69 && npc.HasPerk(Stability))
			status += Stability.GetName() + ", " ;"Stability, "
		endif
		if (alteration > 74 && npc.HasPerk(AlterationExpert75))
			alevel = AlterationExpert75.GetName() ;"Expert"
		endif
		if (alteration > 99)
			if (npc.HasPerk(AlterationMaster100))
				alevel = AlterationMaster100.GetName() ;"Master"
			endif
			if (npc.HasPerk(Atronach))
				status += Atronach.GetName() + ", " ;"Atronach, "
			endif
		endif
		status += alevel

	status += "]\n"

	int restoration = NPC.GetAv("Restoration") as int
	; Restoration
	status += "Restoration ["
		String rlevel = ""

		if (npc.HasPerk(RestorationNovice00))
			rlevel = RestorationNovice00.GetName() ;"Novice"
		endif
		if (restoration > 19 && npc.HasPerk(Regeneration))
			status += Regeneration.GetName() + ", " ;"Regeneration, "
		endif
		if (restoration > 24 && npc.HasPerk(RestorationApprentice25))
			rlevel = RestorationApprentice25.GetName() ;"Apprentice"
		endif
		if (restoration > 29 && npc.HasPerk(Recovery30))
			status += Recovery30.GetName() + ", " ;"Recovery, "
		endif
		if (restoration > 39 && npc.HasPerk(Respite))
			status += Respite.GetName() + ", " ;"Respite, "
		endif
		if (restoration > 49 && npc.HasPerk(RestorationAdept50))
			rlevel = RestorationAdept50.GetName() ;"Adept"
		endif
		if (restoration > 59 && npc.HasPerk(WardAbsorb))
			status += WardAbsorb.GetName() + ", " ;"WardAbsorb, "
		endif
		if (restoration > 69 && npc.HasPerk(Necromage))
			status += Necromage.GetName() + ", " ;"Necromage, "
		endif
		if (restoration > 74 && npc.HasPerk(RestorationExpert75))
			rlevel = RestorationExpert75.GetName() ;"Expert"
		endif
		if (restoration > 89 && npc.HasPerk(AvoidDeath))
			status += AvoidDeath.GetName() + ", " ;"AvoidDeath, "
		endif
		if (restoration > 99 && npc.HasPerk(RestorationMaster100))		
			rlevel = RestorationMaster100.GetName() ;"Master"
		endif
		status += rlevel

	status += "]\n"
	Debug.MessageBox(status)

endFunction

Function InfoAI(ObjectReference follower)

	Actor npc = follower as Actor
	
	String oName = NPC.GetName()
	ReferenceAlias theAlias = ((Self As Quest) As TweakFollowerScript).FindAlias(follower)
	if (theAlias)
		TweakSettings settings = (theAlias As TweakSettings)
		oName = settings.originalName
	endif

	int iMorals =  npc.GetAV("Morality") As Int
	int iMood = npc.GetAV("Mood") As Int
	int iConfidence = npc.GetAV("Confidence") As Int
	int iAggression = npc.GetAV("aggression") as Int
	int iEnergy = npc.GetAV("aggression") as Int
	int iAssistance = npc.GetAV("aggression") as Int

	String sEnergy = "Error"
	if (iEnergy < 25)
		sEnergy = "Rarely moves around"
	elseif (iEnergy < 50)
		sEnergy = "Moves around occasionally"
	elseif (iEnergy < 75)
		sEnergy = "Moves around often"
	else
		sEnergy = "Never stops moving around"
	endif

	String sMorals = "Error"
	if (0 == iMorals)
		sMorals = "Will steal and kill anyone"
	elseif (1 == iMorals)
		sMorals = "Will steal and kill enemies"
	elseif (2 == iMorals)
		sMorals = "Will steal but won't kill"
	elseif (3 == iMorals)
		sMorals = "Will not commit crimes"
	endif

	String sAggression = "Error"
	if (0 == iAggression)
		sAggression = "Will not initiate combat"
	elseif (1 == iAggression)
		sAggression = "Will attack Enemies on sight"
	elseif (2 == iAggression)
		sAggression = "Will attack Non-Allies on sight"
	elseif (3 == iAggression)
		sAggression = "Will attack anyone on sight"
	endif

	String sConfidence = "Error"
	if (0 == iConfidence)
		sConfidence = "Always runs from combat"
	elseif (1 == iConfidence)
		sConfidence = "Only fights weaker enemies"
	elseif (2 == iConfidence)
		sConfidence = "Runs from stronger enemies"
	elseif (3 == iConfidence)
		sConfidence = "Only runs if severely injured"
	elseif (4 == iConfidence)
		sConfidence = "Fearless, fights to the death"
	endif

	String sAssistance = "Error"
	if (0 == iAssistance)
		sAssistance = "Helps no one"
	elseif (1 == iAssistance)
		sAssistance = "Will only help Allies"
	elseif (2 == iAssistance)
		sAssistance = "Will help Friends and Allies"
	endif

	String sMood = "UNDEFINED"
	if (0 == iMood)
		sMood = "Neutral"
	elseif (1 == iMood)
		sMood = "Angry"
	elseif (2 == iMood)
		sMood = "Fear"
	elseif (3 == iMood)
		sMood = "Happy"
	elseif (4 == iMood)
		sMood = "Sad"
	elseif (5 == iMood)
		sMood = "Surprized"
	elseif (6 == iMood)
		sMood = "Puzzled"
	elseif (7 == iMood)
		sMood = "Disgusted"
	endif

	String status = oName + "\n" + "AI:\n"
	status += "--------------------------------------------------------------\n"
	status += "  Aggression [" + sAggression + "]\n"
	status += "  Confidence [" + sConfidence + "]          \n"
	status += "  Energy [" + sEnergy + "]          \n"
	status += "  Morals [" + sMorals + "]          \n"
	status += "  Mood [" + sMood + "]          \n"
	status += "  Assistance [" + sAssistance + "]          \n"

	if (0 != npc.GetAV("FavorsPerDayTimer"))
		status += "  Combat Style [" 
		if (npc.HasSpell(WerewolfChange) && npc.IsInFaction(TweakUseWerewolfFaction))
			status += "Werewolf]         \n"
		elseif (npc.IsInFaction(TweakUseVampireFaction))
			status += "Vampire Lord]     \n"
		else
			if (731 == npc.GetAV("FavorsPerDayTimer"))
				status += "Mage]              \n"
			elseif  (732 == npc.GetAV("FavorsPerDayTimer"))
				status += "Spell Sword]       \n"
			elseif  (733 == npc.GetAV("FavorsPerDayTimer"))
				status += "Sword and Shield]  \n"
			elseif  (734 == npc.GetAV("FavorsPerDayTimer"))
				status += "Two Handed Weapons]\n"
			elseif  (735 == npc.GetAV("FavorsPerDayTimer"))
				status += "Dual Swords]      \n"
			elseif  (736 == npc.GetAV("FavorsPerDayTimer"))
				status += "Bow and Arrow]     \n"
			elseif  (737 == npc.GetAV("FavorsPerDayTimer"))
				status += "Ranger]     \n"
			elseif  (738 == npc.GetAV("FavorsPerDayTimer"))
				status += "General]     \n"
			endif
		endif
	endif

	Debug.MessageBox(status)

endFunction


Function InfoMisc(ObjectReference follower)

	Actor npc = follower as Actor
	
	String oName = NPC.GetName()
	ReferenceAlias theAlias = ((Self As Quest) As TweakFollowerScript).FindAlias(follower)
	if (theAlias)
		TweakSettings settings = (theAlias As TweakSettings)
		oName = settings.originalName
	endif
	Int Slot = npc.GetAV("FavorActive") As Int
	Int Used = ((Self As Quest) As TweakFollowerScript).UsedSlots()
	Int Remaining = 64 - Used
	
	String status = oName + "\n" + "Misc:\n"
	status += "--------------------------------------------------------------\n"
	status += "  [" + Slot + "] of 64. [" + Remaining + "] Slots Available\n\n"
	status += "  SpeedMult [" + (npc.GetAV("SpeedMult") As Int) + "]                 \n"
	status += "  WeaponSpeedMult [" + (npc.GetAV("WeaponSpeedMult") As Int) + "]   "
	status += "  BowSpeedBonus [" + (npc.GetAV("BowSpeedBonus") As Int) + "]              \n"
	status += "  CarryWeight [" + (npc.GetAV("CarryWeight") As Int) + "]   "
	status += "  CritChance [" + (npc.GetAV("CritChance") As Int) + "]                \n"
;	status += "  NormalWeaponsResist [" + (npc.GetAV("NormalWeaponsResist") As Int) + "]       \n"
	status += "  Marriage Option ["
	if (npc.IsInFaction(PotentialMarriageFaction))
		status += "Yes]            \n\n"
	else
		status += "No]             \n\n"
	endif

	;ReferenceAlias theAlias = ((Self As Quest) As TweakFollowerScript).FindAlias(follower)
	if (theAlias)
		status += "  TweakSpells ["

		TweakMagic magic = (theAlias As TweakMagic)
		comma = ""
		string s_NotSet = "Not Set"
		if (magic.firstSpellName != "" && magic.firstSpellName != s_NotSet)
			status += comma + magic.firstSpellName
			comma = ","
		endif
		if (magic.secondSpellName != "" && magic.secondSpellName != s_NotSet)
			status += comma + magic.firstSpellName
			comma = ","
		endif
		if ("" == comma)
			status += s_NotSet
		endif
		status += "]\n"

		TweakInventoryControl inventory = (theAlias As TweakInventoryControl)
		String comma = ""
		status += "  Inventory ["

 		if (0 != inventory.invControlled)
			status += "Managed"
		else
			status += "Automatic"
		endif
		status += "]\n"

	endif

	Debug.MessageBox(status)

endFunction

;Function InfoGear(ObjectReference follower)
    ; See TweakFollowerQuestScript -> ShowChoiceInfo() command, which redirects to the alias script where the
    ; settings are stored.
;endFunction
