Scriptname TweakInventoryControl  extends ReferenceAlias
{renn's Tweak ;TweakFollower}

;------------------------------------
; Support Properties:
;------------------------------------

GlobalVariable	Property	pTweakStealthActive				Auto ; New 1.6
ReferenceAlias	Property	PlayerRef  						Auto
ReferenceAlias	Property	pFence							Auto
ReferenceAlias	Property	pBackpack						Auto ; New 1.6
Worldspace 		Property 	Tamriel 						Auto
ActorBase 		Property	TweakFence						Auto
ActorBase		Property	TweakBPActorBase				Auto ; New 1.6
FormList		Property	TweakEmptyList					Auto
Formlist 		Property 	TweakInv  						Auto
Formlist 		Property 	TweakInv2 						Auto
FormList 		Property 	TweakInv3 						Auto  ; NEW 1.6
Location 		Property 	WhiterunLocation 				Auto
Location 		Property 	WhiterunJorrvaskrLocation 		Auto
Location 		Property 	WhiterunJorrvaskrBasementLocation Auto
Location 		Property 	SolitudeLocation 				Auto
Location 		Property 	MarkarthLocation 				Auto
Location 		Property 	RiftenLocation 					Auto
Location 		Property 	WindhelmLocation 				Auto
Faction 		Property 	CurrentFollowerFaction 			Auto
Faction 		Property 	WerewolfFaction        			Auto
Faction 		Property	TweakManagedInventoryFaction	Auto ; Outfits managed? True = Standard outfit ALWAYS managed
Faction 		Property	TweakCityInventoryFaction		Auto
Faction 		Property	TweakHomeInventoryFaction		Auto ; NEW 1.6
Faction 		Property	TweakHelmetCombatOnlyFaction	Auto
Faction 		Property	TweakPosedFaction				Auto
Faction			Property	pTweakInStealth					Auto ; New 1.6
Keyword			Property	pWeapTypeGreatsword				Auto ; New 1.63
Keyword			Property	pWeapTypeBattleAxe				Auto ; New 1.63
Keyword			Property	pWeapTypeStaff					Auto ; New 1.63
Keyword			Property	pWeapTypeBow					Auto ; New 1.63
Keyword			Property	pArmorShield					Auto ; New 1.63
Keyword 		Property 	ArmorHelmet 					Auto
Keyword 		Property 	ClothingHead 					Auto
Keyword 		Property 	LocTypeCity 					Auto
Keyword 		Property 	LocTypePlayerHouse 				Auto
Keyword 		Property 	LocTypeClearable 				Auto
Keyword 		Property 	LocTypeDungeon 					Auto
Keyword 		Property 	LocTypeInn 						Auto
Keyword 		Property 	LocTypeHouse 					Auto
Keyword 		Property 	LocTypeStore 					Auto
Keyword 		Property 	LocTypeCastle 					Auto
Keyword 		Property 	LocTypeTemple 					Auto
Keyword 		Property 	ActorTypeNPC 					Auto
Outfit			Property	TweakNoOutfit					Auto
Weapon 			Property	FollowerHuntingBow				Auto
Armor 			Property	TweakBonusBootsMale				Auto ; Male Bonus Outfit
Armor 			Property	TweakBonusCuirassMale			Auto ; Male Bonus Outfit
Armor 			Property	TweakBonusGauntletsMale			Auto ; Male Bonus Outfit
Armor 			Property	TweakCuirass					Auto ; Female Bonus Outfit
Armor 			Property	TweakBoots						Auto ; Female Bonus Outfit
Armor 			Property	TweakGloves						Auto ; Female Bonus Outfit
Form 			Property	myWeapon						Auto ; v1.3 - Weapon Right Hand
Form 			property	myGauntlets						Auto ; v1.3 - Weapon Left Hand 
Form 			property	myRing							Auto ; v1.3 - Shield
Form 			Property 	myHead 							Auto
float			Property	iversion 						Auto
Bool			Property	cityEnabled						Auto
Bool			Property	homeEnabled						Auto ; New 1.6
Bool			Property	tranDup							Auto
Bool			Property	tranSell						Auto
Bool			Property	snapshot						Auto
Bool			Property	combatInProgress				Auto
Bool 			Property	refresh							Auto
Bool 			Property	update							Auto
Bool 			Property	doLoad							Auto ; 1.6 - changed meaning. Now represents clothing lock
Bool 			property 	delaySnapshot 					auto
Bool			property	combatOverFlag					auto ; 1.62 - repurposed to indicate if weapon should refresh on next update
Int				Property	invControlled					Auto Conditional ; 0=no, 1=yes, 2=yes (following)
Int				Property	invCode							Auto
Int				Property	command							Auto
Int				Property	currentOutfitLocation			Auto ; 0 = standard 1 = city 2 = home : New 1.6
Int 			Property 	sellState 						Auto
Int 			Property	invRec							Auto ; 0 = no, 1 = rec standard, 2 = rec city, 3 = rec home
int 			property 	sellCount 						auto ; Repurposed to prevent OnLoadHelper from firing after race change.
int				property	sellValue						auto ; Repurposed to repeatedly check weapon when NPCs loaded and fix weapon hold.

; Attempt at weapon recharge
Form 			Property	lastLeftWeapon					Auto 
Form 			property	lastRightWeapon					Auto  
int 			property 	lastLeftCharge 					Auto 
int				property	lastRightCharge					Auto 

TweakFollowerScript property pTweakFollowerScript auto

;------------------------------------
; Initial Gear Menu
;------------------------------------
; View Inventory
; [ ] Enable Outfit Management
; [ ] Only Allow Helmets during combat
; Unequip All
; Fence Gear 
; Give me All your gear
; Take my duplicate Weap/Arm/Misc
; More ...
;   Equip Bonus Outfit ** Will need special handling when outfit management is disabled
;   Take my duplicate weapons
;   Take my duplicate armor
;   Take my duplicate misc
;   Take my duplicate ingredients
;   Take my duplicate potions
;   Take my duplicate books
;   Take All Duplicate Items
; ------------------------------------------

Function ViewInventory()
	if (0 == invControlled)
		Actor npc = self.GetActorRef()
		if (npc)
			npc.OpenInventory(true)
		Else
			Debug.Notification("AFT: Not Available at this time")
		EndIf
		Utility.wait(0.1)	
	else
		ObjectReference obp = getBackPack()
		if (obp)
			LockClothes()
			tranDup=true ; Ignore Events
			obp.RemoveAllItems(self.GetRef(),true)
			self.GetActorRef().OpenInventory(true);
			Utility.wait(0.1)
			FixGear()
			tranDup=false ; Done with events
			UnLockClothes()
			BumpWeaponAI()
			sellValue = 4
			RegisterForSingleUpdate(2.0)
		else
			Debug.Notification("AFT: Unable to open full inventory at this time")
			self.GetActorRef().OpenInventory(true)
		endif
	endif
endFunction

Function UnequipGear()
	Actor npc = self.GetActorRef()
	npc.UnequipAll()
endFunction

; Fence All Gear        when outfit is NOT managed
; Fence non-outfit gear when outfit is managed
Function SellGear()
	ObjectReference obp = getBackPack()
	if (!obp)
		Debug.Notification("AFT: Unable to sell gear at this time")
		Return
	endif
	ObjectReference	ofence = getFence()
	if (!ofence)
		Debug.Notification("AFT: Unable to create Transfer Container")
		Return
	endif
	Actor npc = self.GetActorRef()
	
	npc.RemoveAllInventoryEventFilters()
	if (0 != invControlled)
		tranSell=true
		LockClothes()
		MoveAllOutfitsToNPC(obp)
		
		; Where should the fence send finished (RelayBegin) Msg?
		(pFence As TweakFenceScript).SetFinishRef(self)

		; Where should the fence send rejected items? (ammo, soul gems, etc...)
		(pFence As TweakFenceScript).SetTargetRef(pBackPack, 0)
		
		obp.RemoveAllItems(ofence, true)
		; See RelayBegin() for conclusion of function
	else
	
		ObjectReference opc = Game.GetPlayer()
		tranSell=true
		; First remember the shield/weapons
		myWeapon	=	npc.GetEquippedWeapon()
		myGauntlets	=	npc.GetEquippedWeapon(true)
		myRing		=	npc.GetEquippedShield()
		if (myWeapon)
			self.GetRef().RemoveItem(myWeapon, 1, true, opc)
		EndIf
		if (myGauntlets)
			self.GetRef().RemoveItem(myGauntlets, 1, true, opc)
		EndIf
		if (myRing)
			self.GetRef().RemoveItem(myRing, 1, true, opc)
		EndIf
			
		; When invControlled is 0, the followers Outfit
		; will be automatically restored after we removeall items.
		; So we set sellState to 1, which tells OnObjectEquipped 
		; to remove equipped items from the backpack.
		
		sellState = 1
		self.GetRef().RemoveAllItems(obp,true)
		Utility.wait(1.0)
		sellState = 0
		
		; Where should the fence send finished (RelayBegin) Msg?
		(pFence As TweakFenceScript).SetFinishRef(self)
		
		; Where should the fence send rejected items? (ammo, soul gems, etc...)
		; This also starts a 5 second timeout. 
		(pFence As TweakFenceScript).SetTargetRef(self, 0)
		
		obp.RemoveAllItems(ofence,true)
		
		; If the follower is nude, we can run into an issue as the ReleyEnd
		; may never get called. 
		
	endif
EndFunction

; Give me All your Gear        when outfit is NOT managed/when outfit is managed
; Give me non-outfit gear      when outfit is managed
Function TakeAllGear(bool ignoreOutfit = false)
	ObjectReference obp = getBackPack()
	if (!obp)
		Debug.Notification("AFT: Unable to take gear at this time")
		Return
	endif
	Actor npc=self.GetActorRef()
	npc.RemoveAllInventoryEventFilters()
	
	if (ignoreOutfit)
		if (0 != invControlled)
			tranSell=true
			MoveUnusedOutfitsToBackPack(self.GetRef(),obp)
			obp.RemoveAllItems(Game.GetPlayer(), false, true)
			MoveUnusedOutfitsToBackPack(obp, self.GetRef())
			tranSell=false
		endif
	else
		if (0 != invControlled)
			tranSell=true
			obp.RemoveAllItems(Game.GetPlayer(), false, true)
			self.GetRef().RemoveAllItems(Game.GetPlayer(), false, true)
			UnequipGear()
			TweakInv.Revert()
			TweakInv2.Revert()
			TweakInv3.Revert()
			myHead=None
			tranSell=false
		else
			; When invControlled is 0, the followers Outfit
			; will be automatically restored after we removeall items.
			; So we set sellState to 2, which tells OnObjectEquipped 
			; to remove equipped items from the player.
		
			sellState = 2
			self.GetRef().RemoveAllItems(Game.GetPlayer(),false)
			Utility.wait(1.2)
			sellState = 0
		EndIf
	endif
endFunction

Function TransferDuplicateGear(int filter = 8)
	Debug.MessageBox("Please be patient while Duplicate Items are removed. Do not select any other gear options until you see \n[Duplicate Removal Complete]")
	ObjectReference oFence = getFence()
	if (oFence)	
		tranDup=true
		TweakPlayerRef pTweakPlayerRef=(PlayerREF As TweakPlayerRef)
		if (!pTweakPlayerRef)
			; Hook up script handler to pc
			PlayerREF.Clear()
			PlayerREF.ForceRefTo(Game.GetPlayer())
			Utility.wait(0.25)
			pTweakPlayerRef=(PlayerREF As TweakPlayerRef)
		EndIf
		if (pTweakPlayerRef)
			pTweakPlayerRef.TakeOutfitSnapshot()
			;Wait for the items to be fully unequipped and processed. This MUST be done
			;Avoids bug where RemoveAllItems does not remove stat increases/etc from PC
			Utility.wait(1.2)
		endif
		(pFence As TweakFenceScript).SetFinishRef(self)
		self.GetActorRef().RemoveAllInventoryEventFilters()
		int cstyle=self.GetActorRef().GetAV("FavorsPerDayTimer") As Int
		if (0 != invControlled)
			cstyle = 0
			ObjectReference obp = getBackPack()
			if (obp)
				(pFence As TweakFenceScript).SetTargetRef(pBackPack, filter, cstyle)
			Else
				(pFence As TweakFenceScript).SetTargetRef(self, filter, cstyle)
			endif
		else
			(pFence As TweakFenceScript).SetTargetRef(self, filter, cstyle)
		endif
		; Moving items to the follower. We do NOT want to transfer ownership to them.
		Game.GetPlayer().RemoveAllItems(pFence.GetRef(),true)
	else
		Debug.Notification("AFT: Unable to create Transfer Container")
	endif
EndFunction

Function EquipBonusOutfit()
	Actor npc=self.GetActorRef()
	self.GetActorRef().UnequipAll()
	Utility.wait(0.25)
	tranDup = true
	; Send Signal to other mods that may be watching
	int oldFame = self.GetActorRef().GetAV("Fame") As Int
	self.GetActorRef().SetAV("Fame",9001)
	if (9001 != (self.GetActorRef().GetAV("Fame") as Int))
		self.GetActorRef().ForceAV("Fame",9001)
	endif
	; Outfit packs monitor inventory events, but only when fame is 9001
	if (1 == self.GetActorRef().GetActorBase().GetSex()) 
		; Handle Female
		self.GetActorRef().EquipItem(TweakCuirass,false,true)
		self.GetActorRef().EquipItem(TweakBoots,false,true)
		self.GetActorRef().EquipItem(TweakGloves,false,true)
	else
		self.GetActorRef().EquipItem(TweakBonusBootsMale,false,true)
		self.GetActorRef().EquipItem(TweakBonusCuirassMale,false,true)
		self.GetActorRef().EquipItem(TweakBonusGauntletsMale,false,true)
	endif
	Utility.wait(1.5)	
	self.GetActorRef().SetAV("Fame",oldFame)
	if (oldfame != (self.GetActorRef().GetAV("Fame") as Int))
		self.GetActorRef().ForceAV("Fame",oldfame)
	endif
	tranDup = false	
endFunction

;------------------------------------
; Fully Enabled Gear Menu
;------------------------------------

; ------------------------------------------
; ** View Backpack       
; ** View Standard Outfit
; ** View City Outfit
; ** View Home Outfit
; Unequip All
; Fence Non-Outfit Gear
; Give Me All Non-Outfit Gear
; Take my duplicate Weap/Arm/Misc
; More ...
;   View Full Inventory
;   Give Me All Gear
;   Take All Duplicate Items
;   Take my duplicate weapons
;   Take my duplicate armor
;   Take my duplicate misc
;   Take my duplicate ingredients
;   Take my duplicate potions
;   Take my duplicate books
;   Take All Duplicate Items
;   Equip Bonus Outfit ** Will need special handling when outfit management is disabled
;   [X] Enable Outfit Management
;   [X] Enable City Outfit
;   [X] Enable Home Outfit
; ------------------------------------------

Function OpenBackPack()
	ObjectReference obp = getBackPack()
	if (obp)
		(obp As Actor).OpenInventory(true);
	else
		Debug.Notification("AFT: Unable to open backpack at this time")
		self.GetActorRef().OpenInventory(true)
	endif
endFunction

Function ViewStandard()
	UnLockClothes() ; Incase it was locked by Scene
	Utility.wait(0.5)
	if (IsStandardOutfitInUse())
		invRec = 1
		self.GetActorRef().OpenInventory(true);
		Utility.wait(0.1)
		invRec = 0
		FixHelmet()
		return
	endif
	ObjectReference obp = getBackPack()
	if (!obp)
		invRec = 1
		Debug.Notification("AFT: Unable to open standard inventory at this time")
		self.GetActorRef().OpenInventory(true)
		Utility.wait(0.1)
		invRec = 0
		FixHelmet()
		return
	endif
	ViewCommon(TweakInv, obp, 1)
endFunction

Function ViewCity()
	UnLockClothes() ; Incase it was locked by Scene
	if (IsCityOutfitInUse())
		invRec = 2
		self.GetActorRef().OpenInventory(true);
		Utility.wait(0.1)
		invRec = 0
		FixHelmet()
		return
	endif
	ObjectReference obp = getBackPack()
	if (!obp)
		invRec = 2
		Debug.Notification("AFT: Unable to open city inventory at this time")
		self.GetActorRef().OpenInventory(true)
		Utility.wait(0.1)
		invRec = 0
		FixHelmet()
		return
	endif
	ViewCommon(TweakInv2, obp, 2)
endFunction

Function ViewHome()
	UnLockClothes() ; Incase it was locked by Scene
	if (IsHomeOutfitInUse())
		invRec = 3
		self.GetActorRef().OpenInventory(true);
		Utility.wait(0.1)
		invRec = 0
		FixHelmet()
		return
	endif
	ObjectReference obp = getBackPack()
	if (!obp)
		invRec = 3
		Debug.Notification("AFT: Unable to open home inventory at this time")
		Utility.wait(0.1)
		self.GetActorRef().OpenInventory(true)
		invRec = 0
		FixHelmet()
		return
	endif
	ViewCommon(TweakInv3, obp, 3)
endFunction

;------------------------------------
; Standard Helper Functions
;------------------------------------

Function ViewCommon(FormList gear, ObjectReference obp, Int recmode)

	tranDup=true ; ignore events
	Actor npc = self.GetActorRef()
	
	SaveWeaponCharges()
	npc.UnEquipAll() ; Ensure game knows weapon has changed
	npc.RemoveAllItems(obp,true)
	Utility.wait(0.1)
	
	; Transfer gear items to NPC
	MoveItems(obp, self.GetRef(), gear)
	tranDup=false ; enable events

	invRec = recmode
	if (gear.GetSize() > 0)
		BumpArmorAI()
		RemoveWeapons()
	endif

	npc.OpenInventory(true);
	Utility.wait(0.1)
	invRec = 0
	Utility.wait(0.1)

	tranDup=true ; Ignore Events
	if (!npc.IsPlayerTeammate())
		LockClothes()
		Utility.wait(0.25)
	endif
	
	FixGear()
	tranDup=false ; Done with events
	if (!npc.IsPlayerTeammate())
		UnLockClothes()
	else
		BumpWeaponAI()
		RestoreWeaponCharges()
		sellValue = 4
		RegisterForSingleUpdate(2.0)
	endif

EndFunction

Function MoveUnusedOutfitsToBackPack(ObjectReference oTarget, ObjectReference oSource=none)
	if (!oSource)
		oSource = self.GetRef()
	endif
	if (IsHomeOutfitInUse())
		MoveItems(oSource, oTarget, TweakInv)
		if (cityEnabled)
			MoveItems(oSource, oTarget, TweakInv2)
		endif
	elseif (IsCityOutfitInUse())
		MoveItems(oSource, oTarget, TweakInv)
		if (homeEnabled)
			MoveItems(oSource, oTarget, TweakInv3)
		endif
	Else
		if (cityEnabled)
			MoveItems(oSource, oTarget, TweakInv2)
		EndIf
		if (homeEnabled)
			MoveItems(oSource, oTarget, TweakInv3)
		endif
	endif
EndFunction

Function MoveAllOutfitsToNPC(ObjectReference obp)
	ObjectReference onpc = self.GetRef()
	MoveItems(obp, onpc, TweakInv)
	if cityEnabled
		MoveItems(obp, onpc, TweakInv2)
	EndIf
	if homeEnabled
		MoveItems(obp, onpc, TweakInv3)
	EndIf
EndFunction

Function MoveItems(ObjectReference oSource, ObjectReference oTarget, Formlist gear)
	Int stuff=gear.GetSize()
	if (stuff > 0)
		Form item
		Int i = 0
		while (i < stuff)
			item=gear.GetAt(i)
			if (item && (item As Form))
				oSource.RemoveItem(item, 9999, true, oTarget)
			endif
			i += 1
		endWhile		
	endif
EndFunction

Function LockClothes(Bool alwaysEquip=false)
	doLoad = true
	if(IsHomeOutfitInUse())
		PreventRemoval(TweakInv3, true,alwaysEquip)
	elseif (IsCityOutfitInUse())
		PreventRemoval(TweakInv2, true,alwaysEquip)
	else
		PreventRemoval(TweakInv, true,alwaysEquip)
	endif
EndFunction

Function UnLockClothes(Bool alwaysEquip=false)
	if (doLoad)
		if(IsHomeOutfitInUse())
			PreventRemoval(TweakInv3, false, alwaysEquip)
		elseif (IsCityOutfitInUse())
			PreventRemoval(TweakInv2, false,alwaysEquip)
		else
			PreventRemoval(TweakInv, false, alwaysEquip)
		endif
	endif
EndFunction

Function PreventRemoval(Formlist gear, Bool pRemoval, Bool alwaysEquip=false)
	Actor npc = self.GetActorRef()
	Int weapons=2
	Int stuff=gear.GetSize()
	if (stuff > 0)
		Form item
		Int i = 0
		if (alwaysEquip)
			int maxWeap = 2
			int maxArmor = 10
			while (i < stuff)
				item=gear.GetAt(i)
				
				; TODO: GetItemCount was added to 1.64 to fix 1.61->1.63 bugs.
				; After 2 more versions or 3 months, should be removed for
				; speed reasons.
				
				if (item As Armor && maxArmor > 0 && npc.GetItemCount(item) > 0)
					npc.EquipItem(item,pRemoval,true)
					maxArmor -= 1
				elseif (item As Weapon && maxWeap > 0 && npc.GetItemCount(item) > 0)
					npc.EquipItem(item,false,true)
					maxWeap -= 1
				endif
				i += 1
			endWhile		
		else
			while (i < stuff)
				item=gear.GetAt(i)
				if npc.IsEquipped(item)
					npc.EquipItem(item,pRemoval,true)
				endif
				i += 1
			endWhile
		endif
	endif
EndFunction

Function FixHelmet()
	Actor npc = self.GetActorRef()
	if (myHead && npc.IsInFaction(TweakHelmetCombatOnlyFaction) && !npc.IsInCombat() && npc.IsEquipped(myHead))
		npc.UnEquipItem(myHead,true,true)
	EndIf
EndFunction

; Events should be disabled (tranDup=true) before this is called
Function FixGear()

	ObjectReference obp = getBackPack()
	Actor npc = self.GetActorRef()
	if (obp)
;		npc.UnequipAll()
;		Utility.wait(0.25)
		npc.RemoveAllItems(obp)
		FormList gear = None
		if(IsHomeOutfitInUse())
			MoveItems(obp, self.GetRef(), TweakInv3)
			gear = TweakInv3		
		elseif (IsCityOutfitInUse())
			MoveItems(obp, self.GetRef(), TweakInv2)
			gear = TweakInv2
		else
			MoveItems(obp, self.GetRef(), TweakInv)
			gear = TweakInv
		endif
		if npc.GetRace().HasKeyword(ActorTypeNPC)
			if (!npc.IsInFaction(pTweakInStealth))			
				if (gear.GetSize() > 0)
					BumpArmorAI()
					if (npc.IsInFaction(TweakHelmetCombatOnlyFaction) && myHead)
						npc.UnequipItem(myHead)
					endif
				endif
			endif
		endif
	else
		Debug.Notification("AFT: Unable to find backpack")
		if npc.GetRace().HasKeyword(ActorTypeNPC)
			BumpArmorAI()
			BumpWeaponAI()			
			if (npc.IsInFaction(TweakHelmetCombatOnlyFaction) && myHead)
				npc.UnequipItem(myHead)
			endif
		endif
	endif
endFunction

Bool Function IsHomeOutfitInUse()
	if !homeEnabled
		return False
	EndIf
	if currentOutfitLocation != 2
		return False
	endif
	return True
EndFunction

Bool Function IsCityOutfitInUse()
	if !cityEnabled
		return False
	EndIf
	if currentOutfitLocation == 0
		return False
	endif
	if (IsHomeOutfitInUse())
		return False
	endif
	return true
EndFunction
		
Bool Function IsStandardOutfitInUse()
	if IsHomeOutfitInUse()
		return False
	EndIf
	if IsCityOutfitInUse()
		return False
	EndIf
	return true
EndFunction

;------------------------------------
; Synthetic (AFT) Events
;------------------------------------

Function initialize()

	; Now that we support Slot Re-Use, init has to be more like reset. 
	delaySnapshot=false
	tranDup=true
	iversion=1.6
	Actor npc = self.GetActorRef()
	npc.RemoveFromFaction(TweakManagedInventoryFaction)
	npc.RemoveFromFaction(TweakHomeInventoryFaction)
	npc.RemoveFromFaction(TweakCityInventoryFaction)
	npc.RemoveFromFaction(TweakHelmetCombatOnlyFaction)
	command=0
	invRec=0
	sellState=0
	customWarningStatus=0
	myGauntlets=None
	myWeapon=None
	myHead=None
	myRing=None
	refresh=false
	tranSell=false
	snapshot=false
	cityEnabled=false
	homeEnabled=false
	invControlled=0
	invCode=0
	lastLeftCharge=0
	lastRightCharge=0
	lastLeftWeapon=None
	lastRightWeapon=None

	TweakInv.Revert()
	TweakInv2.Revert()
	TweakInv3.Revert()
	
	if (pBackpack && pBackpack.GetRef())
		pBackpack.GetRef().RemoveAllItems()
		Utility.wait(0.25)
	endif

	tranDup=false	
	determineInvCode()
		
endFunction

Function EventWaitToFollow()
EndFunction

Function EventFollowingPlayer()
endFunction

; When they stop following the PC
Function EventNotFollowingPlayer()	
endFunction

Function AftReset()
	tranDup=true
	self.GetActorRef().RemoveFromFaction(TweakManagedInventoryFaction)
	self.GetActorRef().RemoveFromFaction(TweakHomeInventoryFaction)
	self.GetActorRef().RemoveFromFaction(TweakCityInventoryFaction)
	self.GetActorRef().RemoveFromFaction(TweakHelmetCombatOnlyFaction)
	command=0
	invRec=0
	sellState=0

	lastLeftCharge=0
	lastRightCharge=0
	lastLeftWeapon=None
	lastRightWeapon=None
	
	customWarningStatus=0
	myGauntlets=None
	myWeapon=None
	myHead=None
	myRing=None
	refresh=false
	tranSell=false
	snapshot=false
	cityEnabled=false
	homeEnabled=false
	delaySnapshot=false

	if (pFence && pFence.GetRef())
		ObjectReference ofence = pFence.GetRef()
		pFence.Clear()
		ofence.Delete()
	endif

	TweakEmptyList.Revert()
	TweakInv.Revert()
	TweakInv2.Revert()
	TweakInv3.Revert()
	
	if (pBackpack && pBackpack.GetRef())
		ObjectReference obp = pBackpack.GetRef()
		obp.RemoveAllItems(self.GetRef(),true)
		Utility.wait(0.25)
		pBackpack.Clear()
		obp.Delete()
	endif

	if (0 != invControlled)
		self.GetActorRef().UnequipAll()
		if (0 != invCode)
			(GetOwningQuest() As TweakOutfitFix).ResetOutfit(self.GetActorRef(), invCode)
		endif		
		invControlled=0
	endif
	if (0 != invCode)
		invCode=0
	endif
	tranDup=false

endFunction

Function OnCombatBegin()
	combatInProgress=true
	Actor npc=self.GetActorRef()
	if (npc.IsInFaction(TweakHelmetCombatOnlyFaction))
		EquipHelmet()
	endif
endFunction

; Called by TweakFollowerScript: RelayCombatEnd
Function OnCombatEnd()
	combatInProgress = False
	Actor npc=self.GetActorRef()
	if !npc
		return
	endif
	if (npc.IsInFaction(TweakHelmetCombatOnlyFaction))
		RemoveHelmet()
	endif
EndFunction

;------------------------------------
; Real Events
;------------------------------------

; See TweakSettings for master combat detection loop.
Event OnCombatStateChanged(Actor akTarget, int cState)
	Actor npc=self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	if (1 != cState)
		return
	endif
	if (akTarget && akTarget.IsPlayerTeammate())
		return
	endif
	if (!npc.IsInFaction(CurrentFollowerFaction))
		return
	endif
	if (!combatInProgress)
		OnCombatBegin()
	endif
endEvent


Event OnLocationChange(Location akOldLoc, Location akNewLoc)
	if (0 == invControlled)
		Return
	EndIf
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	if npc.IsInCombat()
		return
	endif
	Utility.wait(0.15)
	update = true
	RegisterForSingleUpdate(1.6)
endEvent

; OnLoad means the NPC's model is being loaded. This generally happens when
; we entered/leave the Tamriel World Space. For example when entering caves
; or major cities. It also generally happens following Fast Travel 
Event OnLoad()
	if (0 == invControlled)
		Return
	endif
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
    if (npc.IsInFaction(pTweakInStealth))
		return
	endif
	Utility.wait(0.30)
	; sellcount - Prevent OnLoadHelper from firing when werewolf transforms to human
	if (1 == sellCount)
		sellCount = 0
	else
		; delaySnapshot is used by OnLoadHelper to determine if event was due to OnLoad or OnLocationChange.
		; OnLoad always results in a weapon bump, where as OnLocationChange alone does not.
		update = true
		delaySnapshot = true
		RegisterForSingleUpdate(1.45)
	endif
endEvent

Event OnUnload()
	if (0 == invControlled)
		Return
	endif
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf

	if (homeEnabled || cityEnabled)
		if (0 == currentOutfitLocation)
			SaveWeaponCharges()
		endif
	endif
EndEvent

Event OnDeath(Actor akKiller)
	if (0 == invControlled)
		Return
	endif
	DisableOutfitControl()
endEvent

; OnUnLoad means the NPC's model is being unloaded. This generally happens when
; we entered/leave the Tamriel World Space. For example when entering caves
; or major cities. It also generally happens following Fast Travel. It 
; can also mean the player has gotten "too far" from the NPC for the Game
; to bother keeping the NPC's model in memory. This is normally roughly
; the moment you can no longer see the NPC. 

;Event OnUnLoad()
;endEvent

; Called when every object's 3d in the parent cell is loaded and ready.
; This is normally used to detect the PC approaching the NPC in a large
; field. 
;Event OnCellLoad()
;endEvent

; OnObjectUnequipped is used to detect/correct scene nudity that can 
; happen when an NPC with a "nude" outfit is pulled into a scene. 
;
; The second use of OnObjectUnequipped is outfit snapshots. These may occure
; when you first Enable Outfit Management on an NPC, to initialize the associated 
; outfit formlist. 
;
; I forsee using constant monitoring of the OnItemAdded/Removed events to keep the
; formlist up to date post initialization. So these snapshots should be 
; very rare starting in 1.6

Event OnObjectUnequipped(Form akBaseItem, ObjectReference akItemReference)

	if (0 == invControlled)
		Return
	endif
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	if (snapshot && 0 != invRec)
		; Just in case of a bug, we put a 20 item limit
		if (1 == invRec)
			if (TweakInv.GetSize() > 19)
				return
			endif
		elseif (2 == invRec)
			if (TweakInv2.GetSize() > 19)
				return
			endif
		else
			if (TweakInv3.GetSize() > 19)
				return
			endif
		endif
	
		; Watch out for magic effects. If we programatically tell the NPC to equip FrostDamage 
		; (Grimsever), the game will crash when the User goes to the NPC's inventory

		if (akBaseItem As Spell || akBaseItem As Enchantment || akBaseItem As MagicEffect)
			return
		endif
		if (akBaseItem As Hazard || akBaseItem As Shout || akBaseItem As Light)
			return
		endif
	
		if (1 == invRec)
			TweakInv.AddForm(akBaseItem)
		elseif (2 == invRec)
			TweakInv2.AddForm(akBaseItem)
		else
			TweakInv3.AddForm(akBaseItem)
		endIf
		RegisterForSingleUpdate(0.8)
		return
	endif
	if (tranDup || tranSell)
		return
	endif
	if (akBaseItem == myHead)
		Return
	endif

EndEvent

; OnObjectEquipped is used by two areas of AFT
; 
; 1) It is used to detect helmets and enforce the Combat-Only Helmet option.
; 2) It supports the TakeAll/SellAll gear commands when inventory is NOT managed. 
;    by keeping track of native outfit components to be removed from sell/transfer
;    consideration.

Event OnObjectEquipped(Form akBaseItem, ObjectReference akItemReference)
	Actor npc=self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	if (npc.IsInCombat() || snapshot)
		Return
	endif
	if akBaseItem.HasKeyword(ArmorHelmet) || akBaseItem.HasKeyword(ClothingHead)
		; track it
		myHead = akBaseItem
		if ((0 == invRec) && (npc.IsInFaction(TweakHelmetCombatOnlyFaction)))
			npc.UnequipItem(akBaseItem, true, true)
		endif
	endif
	
	if (0 == invControlled)
		if (akBaseItem As Spell || akBaseItem As Enchantment || akBaseItem As MagicEffect)
			return
		endif
		if (akBaseItem As Hazard || akBaseItem As Shout || akBaseItem As Light)
			return
		endif
		if (1 == sellstate)
			; Scenario: During Fence, when 0 == invControlled, we remove all items
			; even though we know it will restore the outfit. Then a flag is set
			; So we know to remove items from the backpack if anything arrives in that window.
			ObjectReference obp = getBackPack()
			obp.RemoveItem(akBaseItem, 1, true)
		elseif (2 == sellstate)
			; Scenario: During TakeAll, when 0 == invControlled, we remove all items
			; even though we know it will restore the outfit. Then a flag is set
			; So we know to remove items from the player if anything arrives in that window.
			Game.GetPlayer().RemoveItem(akBaseItem, 1, true)
		endif
	endif
	
EndEvent

; What happens if they remove an item?
; If InvControl is 0, absolutely nothing. 
; If Inventory is Controlled, we keep the outfit formlist up to date.
; When updating an outfit properly, we set the invRec int to the outfit. 
; So if InvRec is not set (0), then we ignore the event. 
;
; NOTE: I need to do some testing to see if this fires when bulk item removal commands like RemoveAllItems() are used. 
; For some reason, I dont think it does, but to be on the safe side, we check for standard "events are happening" 
; flags like tranDup and TranSell. If someone decides to sell an outfit, those methods should take care of cleanup.
Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	Actor npc=self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	If (0 == invControlled)
		Return
	EndIf
	if (tranDup || tranSell || snapshot)
		return
	endif
	if (akBaseItem == FollowerHuntingBow)
		return
	endif
	if (akDestContainer && akDestContainer == Game.GetPlayer())

		; invRev can be used to change an outfit that is not the one that 
		; belongs to the currentLocation. IE: Edit the home outfit from
		; the city.

		if (0 == invRec)
			if (1 == currentOutfitLocation && cityEnabled)
				RemoveForm(TweakInv2, akBaseItem)
			elseif (2 == currentOutfitLocation && homeEnabled)
				RemoveForm(TweakInv3, akBaseItem)
			else ; 1 == currentOutfitLocation
				RemoveForm(TweakInv, akBaseItem)
			endif
		else
			if (2 == invRec)
				RemoveForm(TweakInv2, akBaseItem)
			elseif (3 == invRec)
				RemoveForm(TweakInv3, akBaseItem)
			else ; 1 == invRec
				RemoveForm(TweakInv, akBaseItem)
			endif
		endif

	endif

endEvent

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	Actor npc=self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	If (0 == invControlled)
		Return
	EndIf
	if (snapshot || tranDup || tranSell)
		return
	endif
	if (akBaseItem == FollowerHuntingBow)
		return
	endif
	if (npc.IsDoingFavor())
		; Move to Backpack
		ObjectReference obp = getBackPack()
		if (obp)
			self.GetRef().RemoveItem(akBaseItem,aiItemCount,true,obp)
		endif
	EndIf
	if (akSourceContainer && akSourceContainer == Game.GetPlayer())

		; invRev can be used to change an outfit that is not the one that 
		; belongs to the currentLocation. IE: Edit the home outfit from
		; the city.

		if (0 == invRec)
			if (1 == currentOutfitLocation && cityEnabled)
				TweakInv2.AddForm(akBaseItem)
			elseif (2 == currentOutfitLocation && homeEnabled)
				TweakInv3.AddForm(akBaseItem)
			else ; 1 == currentOutfitLocation
				TweakInv.AddForm(akBaseItem)	
			endif
		else
			if (2 == invRec)
				TweakInv2.AddForm(akBaseItem)
			elseif (3 == invRec)
				TweakInv3.AddForm(akBaseItem)
			else ; 1 == invRec
				TweakInv.AddForm(akBaseItem)	
			endif
		endif
	endif
	
endEvent

Event OnRaceSwitchComplete()
	
	Actor npc=self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf

	; Prevent OnLoad/OnLoadHelper from firing
	update=false
	sellCount=1
	UnRegisterForUpdate()

    if (npc.IsInFaction(pTweakInStealth))
		return
	endif
	
	; If human form, put their clothes back on...
	if (npc.GetRace().HasKeyword(ActorTypeNPC))
		BumpArmorAI()
		myWeapon	=	npc.GetEquippedWeapon() ; right hand
		myGauntlets	=	npc.GetEquippedShield() ; left hand
		if (!myGauntlets)
			myGauntlets	=	npc.GetEquippedWeapon(true) ; left hand
		endif
		Bool refreshw = false
		if (!myWeapon || !myGauntlets)
			if (myWeapon)
				if myWeapon.HasKeyword(pWeapTypeGreatsword) || myWeapon.HasKeyword(pWeapTypeBattleAxe) || myWeapon.HasKeyword(pWeapTypeBow)
					refreshw = true
				endif
			elseif (myGauntlets)
				if myGauntlets.HasKeyword(pWeapTypeGreatsword) || myGauntlets.HasKeyword(pWeapTypeBattleAxe) || myGauntlets.HasKeyword(pWeapTypeBow)
					refreshw = true
				EndIf
			endif
		endif
		if refreshw
			BumpWeaponAI()
		endif
		sellValue = 4
		RegisterForSingleUpdate(0.25)
	Else
		int lType = npc.GetEquippedItemType(0) ; left  Hand
		int rType = npc.GetEquippedItemType(1) ; right Hand
		if !((lType == 9 || lType == 0) && (rType == 9 || rType == 0))
			myWeapon	=	npc.GetEquippedWeapon() ; right hand
			myGauntlets	=	npc.GetEquippedWeapon(true) ; left hand
			if !myGauntlets
				myRing	=	npc.GetEquippedShield() ; left hand
			endif
			
			if (myRing)
				npc.UnequipItem(myRing)
			EndIf
			if (myWeapon)
				npc.UnequipItem(myWeapon)
			EndIf
			if (myGauntlets)
				npc.UnequipItem(myGauntlets)
			EndIf
			
			lType = npc.GetEquippedItemType(0)
			rType = npc.GetEquippedItemType(1)
			if !((lType == 9 || lType == 0) && (rType == 9 || rType == 0))
				npc.UnequipAll()
			endif
		endif
	endif

endEvent

Event OnUpdate()
	Actor npc=self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	if (sellValue > 0)
		if (npc.GetCurrentScene() != None)
			sellValue = 0
		elseif (!npc.IsInCombat() || delaySnapshot)
			; Delay Snapshot ensures we do it at least Once
			; when changing areas, even if entering combat
		    delaySnapshot = false
			validateWeapon()
		else
			sellValue = 0
		endif
	endif
	if (snapshot)
		snapshot=false
	endif
	if (update)
		update=false
		OnLoadHelper()
	endif
	if (combatOverFlag)
		combatOverFlag = False
		RefreshWeaponHelper()
	endif
endEvent

;------------------------------------
; Event Support
;------------------------------------

Function EquipHelmet()
	Actor npc = self.GetActorRef()
	if (myHead && 0 != npc.GetItemCount(myHead))
		npc.EquipItem(myHead)
	endif
endFunction

Function RemoveHelmet()
	Actor npc = self.GetActorRef()
	if (myHead && npc.IsEquipped(myHead))
		self.GetActorRef().UnequipItem(myHead)
	endif
endFunction

Function determineInvCode()
	String n = ((self as ReferenceAlias) As TweakSettings).originalName	
	invCode = 0
	if n == ((self as ReferenceAlias) As TweakSettings).s_Erik
		invCode=10
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Iona
		invCode=1
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Calder
		invCode=1
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Jordis
		invCode=1
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Lydia
		invCode=1
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Argis
		invCode=1
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Illia
		invCode=2
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Stenvar
		invCode=3
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Jenassa
		invCode=4
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Belrand
		invCode=5
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Marcurio
		invCode=6
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Vorstag
		invCode=7
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Uthgerd
		invCode=8
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Erandur
		invCode=9
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Golldir
		invCode=10
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Aranea
		invCode=11
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Brelyna
		invCode=12
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Jzargo
		invCode=13
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Onmund
		invCode=14
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Kharjo
		invCode=8
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Torvar
		invCode=15
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Njada
		invCode=16
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Ria
		invCode=17
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Athis
		invCode=18
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Aela
		invCode=19
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Vilkas
		invCode=20
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Farkas
		invCode=3
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Ogol
		invCode=21
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Lob
		invCode=22
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Ugor
		invCode=3
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Borgakh
		invCode=23
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Eola
		invCode=24
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Adelaisa
		invCode=25
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Roggi
		invCode=26
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Derkeethus
		invCode=27
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Ghorbash
		invCode=3
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Annekke
		invCode=28
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Benor
		invCode=10
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Faendal
		invCode=29
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Sven
		invCode=30
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Cosnach
		invCode=22
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Mjoll
		invCode=31
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Ahtar
		invCode=32
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_DBInitiate
		invCode=33
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Cicero
		invCode=34
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Serana
		invCode=35
	elseif n == ((self as ReferenceAlias) As TweakSettings).s_Frea
		invCode=36
	else
		Actor npc = self.GetActorRef()
		
		Int meleeMax = (npc.GetAv("OneHanded") as Int)
		if (meleeMax < (npc.GetAv("TwoHanded") as Int))
			meleeMax = (npc.GetAv("TwoHanded") as Int)
		endif
		if (meleeMax < (npc.GetAv("Marksman") as Int))
			meleeMax = (npc.GetAv("Marksman") as Int)
		endif

		if (meleeMax < (npc.GetAv("Destruction") as Int))

			; A Pure mage will focus on all schools of magic. A spell sword
			; will only invest in 1 or 2 magic schools

			int magicTotal = (npc.GetAv("Conjuration") as Int)
			magicTotal += (npc.GetAv("Destruction") as Int)
			magicTotal += (npc.GetAv("Restoration") as Int)
			magicTotal += (npc.GetAv("Alteration") as Int)
			magicTotal += (npc.GetAv("Illusion") as Int)

			int meleeTotal = (npc.GetAv("OneHanded") as Int)
			meleeTotal += (npc.GetAv("TwoHanded") as Int)
			meleeTotal += (npc.GetAv("Block") as Int)
			meleeTotal += (npc.GetAv("HeavyArmor") as Int)
			meleeTotal += (npc.GetAv("LightArmor") as Int)

			if (magicTotal > meleeTotal)
				; robes
				invCode = 6
			else
				; leather
				invCode = 4
			endif
		else	
			if ((npc.GetAv("OneHanded") as Int) < (npc.GetAv("TwoHanded") as Int))
				if ((npc.GetAv("TwoHanded") as Int) < (npc.GetAv("Marksman") as Int))
					invCode = 4
				else
					; steel plate (cleric)
					invCode = 8
				endif
			else
				if ((npc.GetAv("OneHanded") as Int) < (npc.GetAv("Marksman") as Int))
					invCode = 4
				else
					; Duals are normally theives. So the block is normally less than sneak on a dual. 
					if ((npc.GetAv("Block") as Int) < (npc.GetAv("Sneak") as Int))
						invCode = 4
					else
						; House carl
						invCode = 3
					endif
				endif
			endif
		endif
	endif
EndFunction

;------------------------------------
; Upgrade Support
;------------------------------------

Function v13Upgrade()
	if (2 == invControlled)
		if (myCuirass)
			TweakInv.AddForm(myCuirass)
			myCuirass=None
		endif
		if (myBoots)
			TweakInv.AddForm(myBoots)
			myBoots=None
		endif
		if (myGauntlets)
			TweakInv.AddForm(myGauntlets)
			myGauntlets=None
		endif
		if (myHead)
			TweakInv.AddForm(myHead)
			self.GetActorRef().AddToFaction(TweakHasHelmetFaction)
		endif
		if (myNecklace)
			TweakInv.AddForm(myNecklace)
			myNecklace=None
		endif
		if (myRing)
			TweakInv.AddForm(myRing)
			myRing=None
		endif

		Actor npc = self.GetActorRef()
		npc.AddToFaction(TweakManagedInventoryFaction)

		myWeapon=npc.GetEquippedWeapon()
		myGauntlets=npc.GetEquippedWeapon(true)
		myRing=npc.GetEquippedShield()
	endif
	sellState=0
	iversion=1.3
endFunction

Function v15Upgrade()

	String npcName = ((self as ReferenceAlias) As TweakSettings).originalName	

	if (npcName == ((self as ReferenceAlias) As TweakSettings).s_Serana)
		invCode=35
	endif

	cityEnabled=false
	iversion=1.5
endFunction

Function v16Upgrade()

	String npcName = ((self as ReferenceAlias) As TweakSettings).originalName	

	if (npcName == ((self as ReferenceAlias) As TweakSettings).s_Frea)
		invCode=36
	endif

	Actor npc = Self.GetActorRef()
	
	bool reuse = false
	if (0 == invControlled && npc.IsPlayerTeammate())
		myWeapon = None
		myGauntlets = None
		myRing = None
		myHead = None
		SaveWeaponCharges()
		UnLockClothes()
		BumpArmorAI()
		BumpWeaponAI()
		RestoreWeaponCharges()
		EnableOutfitControl(false,false)
	elseif (npcName == ((self as ReferenceAlias) As TweakSettings).s_Frea)
		invControlled = 0
		if cityEnabled
			cityEnabled = False
			TweakInv2.Revert()
		endif
		myWeapon = None
		myGauntlets = None
		myRing = None
		myHead = None
		SaveWeaponCharges()
		UnLockClothes()
		BumpArmorAI()
		BumpWeaponAI()
		RestoreWeaponCharges()
		EnableOutfitControl(false,false)
	else
		if myWeapon
			TweakInv.AddForm(myWeapon)
			myWeapon = None
		endIf
		if myGauntlets
			TweakInv.AddForm(myGauntlets)
			myGauntlets = None
		endIf
		if myRing
			TweakInv.AddForm(myRing)
			myRing = None
		endIf
		if myHead
			TweakInv.AddForm(myHead)
		endif

		UnLockClothes()
		EnableOutfitControl(true,false)	
	endif

	if (pFence)
		ObjectReference ofence = pFence.GetRef()
		Actor nfence = oFence As Actor
		if (nfence)
			nfence.EnableAI(false)
			oFence.DisableNoWait()
		EndIf
	EndIf
	
	homeEnabled=false
	iversion=1.6
	
endFunction

Function EnableOutfitControl(Bool skipSnapshot=false, Bool showmsg=true)
	
	Actor npc = Self.GetActorRef()
	if (0 == invControlled)
		if (npc.IsPlayerTeammate())
			invControlled = 2
		Else
			invControlled = 1
		EndIf
	endif

	npc.AddToFaction(TweakManagedInventoryFaction)
		
	if (IsInHome())
		currentOutfitLocation = 2
	elseif (IsInCity())
		currentOutfitLocation = 1
	else
		currentOutfitLocation = 0
	endif
	
	if (!skipSnapshot)
		InventorySnapshot()
	EndIf

	tranDup=true ; Ignore Events
	FixGear()
	tranDup=false ; Done with events
EndFunction

; mode: 1 = standard, 2 = city, 3 = home
; pwait: deprecated
Function InventorySnapshot(Int mode = 1, Bool pwait = false)
	
	ObjectReference obp = getBackPack()
	if (!obp)
		Debug.MessageBox("Outfit snapshot failed. Unable to create Backpack. Assign Outfit Manually.")
		Utility.wait(0.01)
		return
	endif
	ObjectReference onpc = self.GetRef()
	Actor npc = onpc As Actor	
	Formlist gear = TweakInv
	
	npc.RemoveAllInventoryEventFilters()

	if (2 == mode)
		gear = TweakInv2
	elseif (3 == mode)
		gear = TweakInv3
	endif
	gear.Revert()

	; must consider the possibility that they are not following the 
	; player when activated:

	bool teammateStatus = npc.IsPlayerTeammate()
	if (!teammateStatus)
		npc.SetPlayerTeammate(true)
	endif

	; Set the "Record" flag
	snapshot=True

	; Let variable assignments above take effect
	Utility.wait(0.10)
	
	; Incase they are naked, we need to start the finalizer here:
	RegisterForSingleUpdate(3.0)
	invRec=1

	; Do NOT use unequipall. If the NPC is holding any weapons, events will
	; only fire for the weapons. HOwever RemoveAllItems throws events For
	; everything... 

	; NOTE: keepOwnership false (default) on purpose to prevent follower
	; items from being marked as stolen.
	; NOTE2: This appears to have broken with Skyrim patch 1.9.32
	onpc.RemoveAllItems(obp)

	Utility.wait(0.5)
	int max=8
	while (snapshot && max != 0)
		Utility.wait(0.25)
		max -= 1
	endwhile
	if (snapshot && max == 0)
		Debug.MessageBox("Assign Outfit(s) Manually")
		Utility.wait(0.01)
	endif
	
	invRec=0
	snapshot=false
	npc.SetOutfit(TweakNoOutfit)
	Utility.wait(0.25)

	Int stuff=gear.GetSize()
	if (stuff > 0)
		Form item
		Int i = 0
		tranSell = true ; Ignore Events
		while (i < stuff)
			item = gear.GetAt(i)
			if (item && item As Form)
				int num = obp.GetItemCount(item)
				if (num > 0)
					obp.RemoveItem(item, num, true, onpc)
				Else
					onpc.AddItem(item)
				endif
			endif
			i += 1
		endWhile
		tranSell = false ; Enable Events

		if (npc.IsInFaction(TweakHelmetCombatOnlyFaction) && myHead)
			npc.UnequipItem(myHead)
		endif
	endif
	
	if (!teammateStatus)
		npc.SetPlayerTeammate(false)
	endif
	
endFunction

Function EnableCityOutfit()
	Actor npc = self.GetActorRef()
	cityEnabled = True
	TweakInv2.Revert()
	npc.AddToFaction(TweakCityInventoryFaction)
	Bool fix = false
	if (IsInCity())
		fix = True
	elseif (IsInHome() && !homeEnabled)
		fix = True
	EndIf
	if (fix)
		ObjectReference obp = getBackPack()
		if (obp)
			tranDup=true ; Ignore Events
			self.GetRef().RemoveAllItems(obp,true)
			Utility.wait(0.1)
			tranDup=false ; Done with events
		endif
		Utility.wait(0.25)
		ViewCity()
	endif
	
EndFunction

Function EnableHomeOutfit()
	Actor npc = self.GetActorRef()
	homeEnabled = True
	TweakInv3.Revert()
	npc.AddToFaction(TweakHomeInventoryFaction)
	if (IsInHome())
		ObjectReference obp = getBackPack()
		if (obp)
			tranDup=true ; Ignore Events
			self.GetRef().RemoveAllItems(obp,true)
			Utility.wait(0.1)
			tranDup=false ; Done with events
		endif
		Utility.wait(0.25)
		ViewHome()
	endif	
EndFunction

Function DisableOutfitControl()

	ObjectReference onpc = self.GetRef()
	ObjectReference obp = getBackPack()
	Actor npc = onpc As Actor

	invControlled = 0
	cityEnabled = False
	homeEnabled = False
	TweakInv.Revert()
	TweakInv2.Revert()
	TweakInv3.Revert()
	npc.RemoveFromFaction(TweakManagedInventoryFaction)
	npc.RemoveFromFaction(TweakCityInventoryFaction)
	npc.RemoveFromFaction(TweakHomeInventoryFaction)
	if (0 != invCode)
		; Try not to delete currently worn gear (not bullet proof, but improves odds)
		npc.UnequipAll()
		Utility.wait(0.25)
		(GetOwningQuest() As TweakOutfitFix).ResetOutfit(self.GetActorRef(), invCode)
	endif
	if (obp && onpc)
		obp.RemoveAllItems(onpc, true, true)
	endif
	BumpArmorAI()
	BumpWeaponAI()
endFunction

Function DisableCityOutfit()
	Actor npc = self.GetActorRef()
	cityEnabled = False
	TweakInv2.Revert()
	npc.RemoveFromFaction(TweakCityInventoryFaction)
	Bool fix = false
	if (IsInCity())
		fix = True
	elseif (IsInHome() && !homeEnabled)
		fix = True
	EndIf
	if (fix)
		ObjectReference obp = getBackPack()
		if (obp)
			tranDup=true ; Ignore Events
			obp.RemoveAllItems(self.GetRef(),true)
			Utility.wait(0.1)
			FixGear()
			tranDup=false ; Done with events
			BumpWeaponAI()
			sellValue=4
			RegisterForSingleUpdate(2.0)
		endif
	endif
endFunction

Function DisableHomeOutfit()
	Actor npc = self.GetActorRef()
	homeEnabled = False
	TweakInv3.Revert()
	npc.RemoveFromFaction(TweakHomeInventoryFaction)
	if (IsInHome())
		ObjectReference obp = getBackPack()
		if (obp)
			tranDup=true ; Ignore Events
			obp.RemoveAllItems(self.GetRef(),true)
			Utility.wait(0.1)
			FixGear()
			tranDup=false ; Done with events
			BumpWeaponAI()
		endif
	endif
endFunction

; Idea : OnUnLoad stores weapon when leaving outside and OnLoad restores charge
;        when returning to outside...

Function OnLoadHelper()
	
	; This will not fire in 1.6 unless inventory management is enabled
	
	; Scenarios: Follower following and change areas (OnLoad)
	; - Possibly Swap in correct outfit and bumpAI
	; Scenarios: Follower following but waiting and re-approached (OnCellLoad).
	; - Possibly Swap in correct outfit and bumpAI
	; Scenarios: Approach dismissed NPC (OnCellLoad)
	; Scenarios: Change areas and follower immediatly pulled into cutscene (Mostly Serana)
	; - isInScene overrides

	Actor npc=self.GetActorRef()

	int w = 8
	if !npc.Is3DLoaded()		
		while (w > 0 && !npc.Is3DLoaded())
			Utility.wait(0.25)
			w -= 1
		endwhile
	endif
	
	Bool npcchangedloc = False
	if (!homeEnabled && !cityEnabled)
		if (IsInHome())
			currentOutfitLocation = 2
		elseif (IsInCity())
			currentOutfitLocation = 1
		else
			currentOutfitLocation = 0
		endif
	Else
		if (IsInHome())
			if (!homeEnabled)
				; Coming from the city or ouside into house and home outfit not enabled
				currentOutfitLocation = 2
			elseif (2 != currentOutfitLocation)
				; Extra check incase Transformed from werewolf to human within the house
				npcchangedloc = True
			endif
			currentOutfitLocation = 2
		elseif (IsInCity())
			if  !homeEnabled && 2 == currentOutfitLocation
				; Coming from the house and no home outfit assigned
				; (City outfit assignment implied by earlier condition)
				currentOutfitLocation = 1
			elseif (!cityEnabled && 0 == currentOutfitLocation)
				; Coming from the outside and no city outfit assigned
				currentOutfitLocation = 1
			elseif (1 != currentOutfitLocation)
				; Extra check incase change locations while travelling the city
				npcchangedloc = True
			endif
			currentOutfitLocation = 1
		else
			if (!cityEnabled && 1 == currentOutfitLocation)
				; Coming from City and city outfit not assigned
				currentOutfitLocation = 0
			elseif (0 != currentOutfitLocation)
				npcchangedloc = True
			endif
			currentOutfitLocation = 0
		endif

	endif

	if (npc.GetCurrentScene() != None)
		tranDup=true ; Ignore Events
		BumpArmorAI()
		if (npc.IsInFaction(TweakHelmetCombatOnlyFaction) && myHead)
			npc.UnequipItem(myHead)
		endif
		tranDup=false ; Done with events
		delaySnapshot = false
		Return
	endif	

	if (0 == w || !npc.GetRace().HasKeyword(ActorTypeNPC))
		delaySnapshot = false
		Return
	EndIf
	
	if (npcchangedloc)
		tranDup=true ; Ignore Events
		FixGear() ; Calls BumpArmorAI
		tranDup=false ; Done with events
		if npc.GetRace().HasKeyword(ActorTypeNPC)
			if (npc.IsInFaction(pTweakInStealth))		
				LockClothes(true)
				Utility.wait(0.25)
				UnLockClothes(true)
				Utility.wait(0.25)			
				delaySnapshot = False
			else
				BumpWeaponAI()
				delaySnapshot = True
			endif
		endif
	elseif (!npc.IsPlayerTeammate())

		; The problem with Lock/Unlock Outfit is that it prevents custom 
		; enchantments from working since the functions explicitly tell
		; the NPC to put the items on. However, when an NPC is posed, We
		; dont care as much... We can't use BumpArmorAI/WeaponAI when
		; posed as it will break the pose if the player has a weapon 
		; drawn
		if npc.GetRace().HasKeyword(ActorTypeNPC)
			if (npc.IsInFaction(TweakPosedFaction))
				LockClothes(true)
				Utility.wait(0.25)
				UnLockClothes(true)
				Utility.wait(0.25)
			else
				BumpArmorAI()
			endif
		endif
		delaySnapshot = false
	EndIf
	
	; delaySnapshot is used to determine if we should check the follower weapons and
	; possibly refresh them. Note the word POSSIBLY. refresh is only required if an
	; issue is found with the current outfit. These checks normally must be done
	; from a separate thread to release any pending outfit changes this thread
	; has locked.
	; 
	; When this event is fired by OnLoad, delaySnapshot is always true. When fired by 
	; OnLocationChange, it defaults to false unless an outfit change occures.

	if (delaySnapshot)
		; Think of sellValue like a max tries.
		; delaySnapshot is set to false by event
		sellValue=4
		RegisterForSingleUpdate(0.25)
	endif
	
endFunction


Function validateWeapon()

	; (skyrim) bugs we are trying to avoid:
	; - User with two handed weapon in 1 hand (cant use it)
	; - Invisible weapons
	; - Too many weapons visible

	; Luckily, these bug states can be detected using a combination 
	; of GetEquippedWeapon and GetEquippedItemType as the two methods
	; will disagree with each other when the bug has manifested.
	
	Actor npc = self.GetActorRef()
	int lType = npc.GetEquippedItemType(0) ; left  Hand
	int rType = npc.GetEquippedItemType(1)  ; right Hand
	if 12 == lType ; convert crossbow to bow
	  lType = 7
	endif
	if 12 == rType ; convert crossbow to bow
	  rType = 7
	endif
		
	; if both types are none, then we can bail
	if (0 == (lType + rType))
		Return
	endif
	
	; if both types are spells, we can bail:
	if (9 == lType && 9 == rType)
		Return
	endif
			
	String n = ((self as ReferenceAlias) As TweakSettings).originalName	

	; Bad Weapon Hold Detection:

	; When a two handed weapon is equipped, both types should
	; have the same value. (5,6,7 = two handed weapon types)
	bool badWeapHold = false
	int i = 5
	while (i < 8)
		if (i==lType && i!=rType) || (i==rType && i!=lType)
			badWeapHold = true
			i = 7
		endif
		i += 1
	endWhile

	if badWeapHold
		;COMMENTED OUT; Debug.Notification("[" + n + "] Bad Weapon Hold Detected [" + lType + "] != [" + rType + "]")
		BumpWeaponAI()
		sellValue-=1
		RegisterForSingleUpdate(2.0)

		return
	endif
			
	; Invisible/Invalid Weapon detection:

	; When GetEquippedWeapon() methods all Return
	; None, but the Type reports something, then we either
	; have an invisible or invalid weapon. IE: They may 
	; look like they have a two-handed sword, but when they
	; hit people, it sounds like a punch. Or maybe they have
	; a bow that they cant fire. This means we need to bump 
	; the weapon AI, but more importantly, we need to get 
	; Skyrim to realize there is no weapon equipped. 

	bool invalidWeap = false
			
	Form rightHand	=	npc.GetEquippedWeapon() ; right hand
	if !rightHand
		rightHand	=	npc.GetEquippedSpell(1) ; right hand
	Else
		myWeapon    = rightHand
	endif

	Form leftHand	=	npc.GetEquippedWeapon(true) ; left hand
	if !leftHand
		leftHand	=	npc.GetEquippedShield() ; left hand
		if !leftHand
			leftHand	=	npc.GetEquippedSpell(0) ; left hand
		Else
			myRing  = leftHand
		endif
	Else
		myGauntlets = leftHand
	endif

	if (!rightHand && !leftHand)
		invalidWeap = true
	elseif (!rightHand || !leftHand)
		; Scenario : Dual handed weapons, but only 1 visible
		if (lType > 0 && lType < 5) || (8 == lType)
			if (rType > 0 && rType < 5) || (8 == rType)
				invalidWeap = true
			endif
		endif
	endif

	if invalidWeap
		;COMMENTED OUT;Debug.Notification("[" + n + "] Invisible or Invalid Weapon detected")
		BumpArmorAI()
		BumpWeaponAI()
		sellValue-=1
		RegisterForSingleUpdate(2.0)

		return
	endif
			
	; Weapon Mismatch:

	; Sometimes a follower will equip too many weapons. 
	; You will see a one handed sword and a bow at the
	; same time. This shouldn't happen. Luckily, two
	; handed weapons always go to the right hand, So
	; we can skip the (slow) keyword search if the
	; left hand is already none, as there is no danger

	if (!leftHand)
		;COMMENTED OUT;Debug.Notification("[" + n + "] Weapons Valid")
		sellValue=0
		RestoreWeaponCharges()
		return
	endif

	if rightHand.HasKeyword(pWeapTypeBow)
		;COMMENTED OUT;Debug.Notification("[" + n + "] Weapon Mismatch (Bow)")

		; Normally if you hand a follower a one-handed melee weapon when they
		; have a bow, the game ALWAYS chooses the melee weapon over the bow, 
		; not matter how pitiful the weapon is. However, when a follower only
		; has 1 weapon, they also normally equip it in the right hand (which
		; is where the bow is sitting). So it is easier to unequip the Weapon
		; than to fix the bow.

		
		npc.UnequipItem(leftHand)
		sellValue -= 1
		RegisterForSingleUpdate(2.0)			
		return
	endif
	
	if rightHand.HasKeyword(pWeapTypeGreatsword) || rightHand.HasKeyword(pWeapTypeBattleAxe)
		;COMMENTED OUT;Debug.Notification("[" + n + "] Weapon Mismatch (Sword)")
		BumpWeaponAI()
		sellValue-=1
		RegisterForSingleUpdate(2.0)			

		return
	EndIf

	sellValue = 0
	;COMMENTED OUT;Debug.Notification("[" + n + "] Weapons Valid")
	RestoreWeaponCharges()
	return
	
EndFunction

Function checkFence()
	if (!pFence.GetRef())
		ObjectReference myFence=Game.GetPlayer().PlaceAtMe(TweakFence)
		(myFence As Actor).SetUnconscious(true)
		(myFence As Actor).AllowPCDialogue(false)
		(myFence As Actor).EnableAI(false)
		myFence.DisableNoWait()
		if (myFence)
			Float[] behindMe=pTweakFollowerScript.TraceCircle(Game.GetPlayer(), 100, -180)
			myFence.SetPosition(behindMe[0],behindMe[1], behindMe[2]) 
			myFence.SetAngle(0.0,0.0, (Game.GetPlayer().GetAngleZ())) 
			pFence.ForceRefTo(myFence)
		endif
	endif
endFunction

ObjectReference Function getFence()
	checkFence()
	return pFence.GetRef()
endFunction

ObjectReference Function getBackpack()
	if (!pBackpack.GetRef())
		ObjectReference myBP=Game.GetPlayer().PlaceAtMe(TweakBPActorBase)
		if (myBP)
			(myBP As Actor).SetUnconscious(true)
			(myBP As Actor).AllowPCDialogue(false)
			(myBP As Actor).AllowPCDialogue(false)
			(myBP As Actor).EnableAI(false)
			myBP.DisableNoWait()
			pBackpack.ForceRefTo(myBP)
		endif
	endif
	return pBackpack.GetRef()
endFunction

; Meaning of callback has changed, but we left the name the same for backwards compatibility
; Called when inventory processing has FINISHED
Function RelayBegin(int totalItems)
	if (tranSell)
		Debug.Notification("Fence Complete")
		if (0 != invControlled)
			ObjectReference obp = getBackPack()
			if (obp)
				MoveUnusedOutfitsToBackPack(obp)
				UnLockClothes()
			endif
		Else
			ObjectReference opc = Game.GetPlayer()
			if (myWeapon)
				opc.RemoveItem(myWeapon, 1, true, self.GetRef())
				myWeapon = None
			EndIf
			if (myGauntlets)
				opc.RemoveItem(myGauntlets, 1, true, self.GetRef())
				myGauntlets = None
			EndIf
			if (myRing)
				opc.RemoveItem(myRing, 1, true, self.GetRef())
				myRing = None
			EndIf
		endif		
		tranSell=false
	elseif (tranDup)
		tranDup=false
		if (0 == totalItems)
			Debug.Notification("No Duplicate Items Found.")
		else
			Debug.Notification("Duplicate Removal Complete")
		endIf
		Utility.wait(0.35)
		TweakPlayerRef pTweakPlayerRef = (PlayerREF As TweakPlayerRef)
		pTweakPlayerRef.RestoreOutfitSnapshot()
	endif
endFunction

; Called when Game is loaded
Function RefreshWeapon()
	if (0 != invControlled)
		combatOverFlag = True
		RegisterForSingleUpdate(0.1)
	endif
EndFunction

Function RefreshWeaponHelper()
	Actor npc = self.GetActorRef()
	if !npc || npc.IsDead()
		return
	endIf
	int w = 8
	if !npc.Is3DLoaded()
		while (w > 0 && !npc.Is3DLoaded())
			Utility.wait(0.25)
			w -= 1
		endwhile
	endif
	if (0 == w || !npc.GetRace().HasKeyword(ActorTypeNPC) || npc.GetCurrentScene() != None)
		Return
	EndIf
	sellValue = 4
	RegisterForSingleUpdate(0.25)
EndFunction

; ===================================
; General Utility Methods
; ===================================

Function BumpArmorAI()

	; Remove an equipped item and it forces the ai to kick in to fill in the slot. This is only true if NPC.IsTeammate()
	; and you cant disable teammate status too quickly after you remove the item or it wont correct. 

	Actor npc = self.GetActorRef()
	if npc.IsPlayerTeammate()
		npc.EquipItem(FollowerHuntingBow)
		Utility.wait(0.32)
		npc.RemoveItem(FollowerHuntingBow)
	else
		npc.SetPlayerTeammate(true)
		npc.EquipItem(FollowerHuntingBow)
		Utility.wait(0.32)
		npc.RemoveItem(FollowerHuntingBow)
		Utility.wait(1.0)
		npc.SetPlayerTeammate(false)
	EndIf
	
endFunction

Function BumpWeaponAI()

	Utility.wait(0.32)
	Actor npc = self.GetActorRef()

	; You have to equip, unequip and remove the weapon to get them to equip best weapon
	if npc.IsPlayerTeammate()
		npc.EquipItem(FollowerHuntingBow)
		Utility.wait(0.32) ; at least 0.25 
		npc.UnequipItem(FollowerHuntingBow)
		Utility.wait(0.32) ; at least 0.25
		npc.RemoveItem(FollowerHuntingBow)
	else
		npc.SetPlayerTeammate(true)
		npc.EquipItem(FollowerHuntingBow)
		Utility.wait(0.32) ; at least 0.25 
		npc.UnequipItem(FollowerHuntingBow)
		Utility.wait(0.32) ; at least 0.25
		npc.RemoveItem(FollowerHuntingBow)
		Utility.wait(1.0)
		npc.SetPlayerTeammate(false)
	EndIf
endFunction

Function SaveWeaponCharges()

	Actor npc = self.GetActorRef()
	Form rightHand = npc.GetEquippedWeapon()
	if (lastRightWeapon != rightHand)
		lastRightCharge = 0
	EndIf
	lastRightWeapon = rightHand
	if (lastRightWeapon)
		int rCharge = npc.GetAV("rightitemcharge") As Int
		if (0 != rCharge)
			lastRightCharge = rCharge
		endif
	endif
	
	Form leftHand = npc.GetEquippedWeapon(true)
	if (lastLeftWeapon != leftHand)
		lastLeftCharge = 0
	EndIf
	lastLeftWeapon = leftHand
	if (lastLeftWeapon)
		int lCharge = npc.GetAV("leftitemcharge") As Int
		if (0 != lCharge)
			lastLeftCharge = lCharge
		endif
	endif
	
EndFunction

Function RestoreWeaponCharges()
	Actor npc = self.GetActorRef()
	if 0 != lastRightCharge
		if (lastRightWeapon == npc.GetEquippedWeapon())
			if (lastRightCharge != 0 && 0 == npc.GetAV("rightitemcharge"))
				npc.SetAV("rightitemcharge",lastRightCharge)
			endif
		endif
	endif
	
	if 0 != lastLeftCharge	
		if (lastLeftWeapon == npc.GetEquippedWeapon(true))
			if (lastLeftCharge != 0 && 0 == npc.GetAV("leftitemcharge"))
				npc.SetAV("leftitemcharge",lastLeftCharge)				
			endif
		endif
	endif

EndFunction

Function RemoveWeapons(Bool dblTap = true)
	Actor npc = self.GetActorRef()
	Form rightHand = npc.GetEquippedWeapon()
	if (rightHand)
		npc.UnequipItem(rightHand)
	endif
	Form LeftHand = npc.GetEquippedWeapon(true)
	if (leftHand)
		npc.UnequipItem(leftHand)
	endif	
	; Double Tap...
	if (dblTap && 0 != invControlled)
		FormList gear =  None
		if (0 == invRec)
			if (1 == currentOutfitLocation && cityEnabled)
				gear = TweakInv2
			elseif (2 == currentOutfitLocation && homeEnabled)
				gear = TweakInv3
			else ; 1 == currentOutfitLocation
				gear = TweakInv	
			endif
		else
			if (2 == invRec)
				gear = TweakInv2
			elseif (3 == invRec)
				gear = TweakInv3
			else ; 1 == invRec
				gear = TweakInv	
			endif
		endif
		if (gear)
			int stuff = gear.GetSize() As Int
			int i = 0
			Form item = None
			while (i < stuff)
				item=gear.GetAt(i)
				if (item && (item As Weapon))
					if npc.IsEquipped(item)
						npc.UnEquipItem(item)
					endif
				endif
				i += 1
			endWhile
		endif
	endif
EndFunction

Function RemoveForm(FormList source, Form f)
	int size=source.GetSize()
	if (size > 0)
		TweakEmptyList.Revert()
		int i=0
		bool notFound=true
		Form item
		while (i != size && notFound)
			item = source.GetAt(i)
			if (item != f)
				TweakEmptyList.AddForm(item)
			else
				notFound=false
			endif
			i += 1
		endWhile
		if (!notFound)
			while (i != size)
				TweakEmptyList.AddForm(source.GetAt(i))
				i += 1
			endWhile
			source.Revert()
			size = TweakEmptyList.GetSize()
			if (size > 0)
				i=0
				while (i < size)
					source.AddForm(TweakEmptyList.GetAt(i))
					i += 1
				endWhile
			endif
		endIf
	endIf
endFunction

Bool Function IsInHome()
	ObjectReference onpc=self.GetReference()
	Location loc=onpc.GetCurrentLocation()
	if (!loc)
		return False
	endif
	if (loc.HasKeyword(LocTypePlayerHouse))
		return true
	endif
	if (loc == pTweakFollowerScript.PlayerHouse)
		return true
	endif	
	return False
endFunction

Bool Function IsInCity()
	ObjectReference onpc=self.GetReference()
	Location loc=onpc.GetCurrentLocation()
	if (!loc)
		return False
	endif
	if (WhiterunJorrvaskrLocation == loc)
		return true
	endif
	if (WhiterunJorrvaskrBasementLocation == loc)
		return true
	endif
	if (loc.HasKeyword(LocTypePlayerHouse))
		return true
	endif
	if (loc == pTweakFollowerScript.PlayerHouse)
		return True
	endif
	if (onpc.GetWorldSpace() == Tamriel)
		return false
	endif
	if (loc.HasKeyword(LocTypeCity))
		return true
	endif
	if (!onpc.IsInInterior())
		return false
	endif
	if (loc.HasKeyword(LocTypeClearable))
		return false
	endif
	if (loc.HasKeyword(LocTypeDungeon))
		return false
	endif
	bool inCity=false

	if (WhiterunLocation.IsChild(loc))
		inCity=true
	endif
	if (SolitudeLocation.IsChild(loc))
		inCity=true
	endif
	if (MarkarthLocation.IsChild(loc))
		inCity=true
	endif
	if (RiftenLocation.IsChild(loc))
		inCity=true
	endif
	if (WindhelmLocation.IsChild(loc))
		inCity=true
	endif
	if (inCity)
		if (loc.HasKeyword(LocTypeInn))
			return true
		endif
		if (loc.HasKeyword(LocTypeHouse))
			return true
		endif
		if (loc.HasKeyword(LocTypeStore))
			return true
		endif
		if (loc.HasKeyword(LocTypeCastle))
			; Check cell for DragonsReach?
			return true
		endif
		if (loc.HasKeyword(LocTypeTemple))
			return true
		endif
	endif
	return false
endFunction

; =======================================
; Deprecated
; =======================================

; Deprecated 1.6

Function StartManagingInventory(Bool alreadyNaked = false, Int mode = 2)
endFunction

Function StopManagingInventory(Bool bumpAI=true, int type = 0)
endFunction

Function EquipManaged(Bool alreadyNaked = false, Bool preventRemoval = true)
endFunction

Function RestoreOutfits()
endFunction

;if (akBaseItem As Weapon || akBaseItem As Enchantment || akBaseItem As Ammo )
;if  (akBaseItem As Spell ||  akBaseItem As Light || akBaseItem As Projectile)

Function v11Initialize(Bool removeOutfit=true)
	determineInvCode()
endFunction

Function v13Initialize()
	; This used to be take snapshot, but we only do this when 
	; outfit management is enabled. 
endFunction

Function v15Initialize()
	; determineInvCode updated so that this is no longer needed
endFunction

; Stopped Using as original is locked and unplayable. So we made copy
Armor Property		ArmorThievesGuildVariantBoots      Auto
Armor Property		ArmorThievesGuildVariantCuirass    Auto
Armor Property		ArmorThievesGuildVariantGauntlets  Auto 

Bool property standardEnabled auto
Bool property standardAssigned auto
Bool property cityAssigned auto

Faction Property TweakHasHelmetFaction Auto
Int property customWarningStatus auto

; Deprecated 1.5

Outfit property originalOutfit auto
SoulGem property SoulGemBlackFilled auto
SoulGem property SoulGemGrandFilled auto
SoulGem property SoulGemGreaterFilled auto
SoulGem property SoulGemBlack auto
SoulGem property SoulGemGreater auto
SoulGem property SoulGemGrand auto
Ingredient property Nirnroot auto
Ingredient property NirnrootRed auto
MiscObject property Gold001 auto
MiscObject property Lockpick auto
Message Property TweakFenceConfirm Auto
Actor Property BelethorREF  Auto
Keyword property ArmorBoots auto
Keyword property ArmorCuirass auto
Keyword property ArmorGauntlets auto
Keyword property ArmorClothing auto
Keyword property ClothingBody auto
Keyword property ClothingFeet auto
Keyword property ClothingHands auto
Keyword property ClothingCirclet auto
Keyword property ClothingNecklace auto
Keyword property ClothingRing auto
Keyword property VendorItemWeapon auto
Keyword property VendorItemStaff auto
Keyword property VendorItemArrow auto
int property sellTotal auto
Form property myBoots auto
Form property myCuirass auto
Form property myNecklace auto
Race Property WerewolfBeastRace Auto
