Scriptname TweakMonitorPlayerScript extends Quest  Conditional
{renn's Tweak}

; May need for formations (to ClearOffsetFromPlayer when player stops moving) 
Bool Property PlayerSettled Auto Conditional
Bool Property IsRidingMount Auto Conditional

ReferenceAlias Property pPlayerRef auto
GlobalVariable Property pTweakFollowerCount Auto

GlobalVariable Property pTweakAINotWhenTalking Auto
GlobalVariable Property pTweakAINeedCloseIdle Auto
GlobalVariable Property pTweakAIMustSheathe Auto
GlobalVariable Property pTweakAITimeMode Auto

; All updates to these globals are done from this quest, 
; so there is no need to update the cache value before access.

GlobalVariable Property pTweakPlayerSettled Auto
GlobalVariable Property pTweakMoreInteractive Auto

Float[] Property playerPosX Auto
Float[] Property playerPosY Auto
Float[] Property playerPosZ Auto
Float Property SettledRadiusAdjusted Auto
Float Property UnSettledRadiusAdjusted Auto

Quest Property pTweakThreadMaster Auto
Quest Property pTweakThreadWorker1 Auto
Quest Property pTweakThreadWorker2 Auto
Quest Property pTweakThreadWorker3 Auto
Quest Property pTweakThreadWorker4 Auto
Quest Property pTweakVampireKeyword Auto

Quest Property pTweakPotentialFollower Auto
Quest Property pTweakImportFollower Auto
Quest Property pTweakCheck4Dialogue  Auto
Quest Property pTweakCheck4Idle  Auto
Quest Property pTweakFollower  Auto
Quest Property pTweakFixLydia Auto
Quest Property pTweakTraps Auto
Quest Property pDialogueFollower Auto
Quest Property stables Auto

Scene Property ExectionScene  Auto  

TweakDFScript Property pTweakDFScript Auto

Message Property pTweakFullReset Auto

float	Property Version Auto
Bool	Property Running Auto
Bool	Property IsInDialogue Auto
Bool	Property init Auto
Bool	Property hit Auto
Quest Property pTweakDawnGuard Auto
Quest Property pTweakDragonBorn Auto
Keyword Property ActorTypeNPC Auto

; Do things here you only want to do once.
Event OnInit()
	PlayerSettled = false
	pTweakPlayerSettled.SetValue(0.0)
	Actor player = pPlayerRef.GetActorRef()
	SettledRadiusAdjusted = (599 * 599)
	UnSettledRadiusAdjusted = (299 * 299)
	playerPosX = new float[3]
	playerPosY = new float[3]
	playerPosZ = new float[3]

	playerPosX[0] = 99999 + 1000
	playerPosX[1] = 99999 + 1000
	playerPosX[2] = 99999 + 1000

	playerPosY[0] = 99999 + 1000
	playerPosY[1] = 99999 + 1000
	playerPosY[2] = 99999 + 1000

	playerPosZ[0] = 99999 + 1000
	playerPosZ[1] = 99999 + 1000
	playerPosZ[2] = 99999 + 1000

	IsInDialogue  = False
	Version = 1.0
	init = true
	RegisterForSingleUpdate(4);

endEvent

; Do things here you want to do every time a save game is loaded
Function OnGameLoaded()

	; There is a possibility that other "Start Game Enabled" quests have not yet
	; been started, especially on heavily modded games. So we check here just in case.
	
	if (!pDialogueFollower.IsRunning())
		pDialogueFollower.Start()
		TweakDFScript tTweakDFScript = pDialogueFollower As TweakDFScript
		tTweakDFScript.Running = true
	endif
	
	pTweakDFScript.Running = true	
	if (!pTweakFollower.IsRunning())
		pTweakFollower.Start()
	endif
;	if (!pTweakFixLydia.IsRunning())
;		pTweakFixLydia.Start()
;	endif
	if (!pTweakTraps.IsRunning())
		pTweakTraps.Start()
	endif
	if (!pTweakImportFollower.IsRunning())
		pTweakImportFollower.Start()
	endif
	if (!pTweakPotentialFollower.IsRunning())
		pTweakPotentialFollower.Start()
	endif
	if (!pTweakVampireKeyword.IsRunning())
		pTweakVampireKeyword.Start()
	endif
	if (!pTweakDawnGuard.IsRunning())
		pTweakDawnGuard.Start()
	endif
	if (!pTweakDragonBorn.IsRunning())
		pTweakDragonBorn.Start()
	endif
	if (!pTweakThreadMaster)
		pTweakThreadMaster.Start()
	endif
	if (!pTweakThreadWorker1)
		pTweakThreadWorker1.Start()
	endif
	if (!pTweakThreadWorker2)
		pTweakThreadWorker2.Start()
	endif
	if (!pTweakThreadWorker3)
		pTweakThreadWorker3.Start()
	endif
	if (!pTweakThreadWorker4)
		pTweakThreadWorker4.Start()
	endif

	Running = True
	RegisterForSingleUpdate(3)

	TweakDawnGuardScript pTweakDawnGuardScript = pTweakDawnGuard As TweakDawnGuardScript
	if (pTweakDawnGuardScript)
		pTweakDawnGuardScript.OnGameLoaded()
	endif

	TweakDragonBornScript pTweakDragonBornScript = pTweakDragonBorn As TweakDragonBornScript
	if (pTweakDragonBornScript)
		pTweakDragonBornScript.OnGameLoaded()
	endif
	
	TweakFollowerScript pTweakFollowerScript = pTweakFollower As TweakFollowerScript
	if (pTweakFollowerScript)
		pTweakFollowerScript.OnGameLoaded()
	endif
	
	if !pPlayerRef.GetReference()
		; This would only happen if the quest was started before the (optional) 
		; alias was filled.
		pPlayerRef.forceRefTo(Game.GetPlayer())
	endif
endFunction

; Called From OnUpdate Checks Below
Function OnDialogueBegin(ObjectReference ActorRef)
	; Debug.Notification("Monitor: Entering Dialogue")
	pTweakDFScript.OnDialogueBegin(ActorRef)
EndFunction

; Called From OnUpdate Checks Below
Function OnDialogueEnd(ObjectReference ActorRef = None)
	; Debug.Notification("Monitor: Exiting Dialogue")
	pTweakDFScript.OnDialogueEnd(ActorRef)
EndFunction

Function AftReset()
	Running = False
	UnRegisterForUpdateGameTime()
	UnRegisterForUpdate()
	PlayerSettled = False
	IsInDialogue = False
	IsRidingMount = False

	pTweakTraps.Stop()
	pTweakFixLydia.Stop()
	pTweakFollower.Stop()
	
	; New Stuff (1.5)
	pTweakImportFollower.Stop()
	pTweakPotentialFollower.Stop()
	pTweakVampireKeyword.Stop()

	; New Stuff (1.6)
	pTweakThreadMaster.Stop()
	pTweakThreadWorker1.Stop()
	pTweakThreadWorker2.Stop()
	pTweakThreadWorker3.Stop()
	pTweakThreadWorker4.Stop()
	
	pTweakDFScript.ResetSandBox()
	pTweakDFScript.Running = false

	TweakDawnGuardScript pTweakDawnGuardScript = pTweakDawnGuard As TweakDawnGuardScript
	if (pTweakDawnGuardScript)
		pTweakDawnGuardScript.AftReset()
	endif
	pTweakDawnGuard.Stop()

	TweakDragonBornScript pTweakDragonBornScript = pTweakDragonBorn As TweakDragonBornScript
	if (pTweakDragonBornScript)
		pTweakDragonBornScript.AftReset()
	endif
	pTweakDragonBorn.Stop()
	
	pTweakFullReset.show()
endFunction

Event OnUpdate()

	if (init)
		init = false
		OnGameLoaded()
		return
	endif

	if (hit)
		hit = false
		if (pTweakFollower.IsRunning())
			TweakFollowerScript pTweakFollowerScript = pTweakFollower As TweakFollowerScript
			if (pTweakFollowerScript)
				pTweakFollowerScript.StealthDetected()
			endif
		endif
		RegisterForSingleUpdate(3)
		return
	endif

	Actor theHorse = Game.GetPlayersLastRiddenHorse()
	if (theHorse && theHorse.GetPlayerControls())
	
		if (!IsRidingMount)
			; Debug.Notification("Monitor: PC Mounted Horse")

			IsRidingMount = true
			
			; When mounting, Followers may be in beast form.
			; So we relay the event to TweakFollower so that 
			; it can tell followers to untransform before
			; updating the AI. 
			
			TweakStables dTweakStables = (stables As TweakStables)
			if (dTweakStables)
				dTweakStables.OnMountHorse(theHorse)
			endif
		endif

		if (PlayerSettled == true)

			PlayerSettled = false
			if (0.0 != pTweakPlayerSettled.GetValue())
				Float fNewValue = pTweakPlayerSettled.Mod(-1.0)
				if (0.0 != fNewValue)
					pTweakPlayerSettled.SetValue(0.0)
				endif
			endif
				
			; ResetSandBox clears the using sandbox from all followers
			pTweakDFScript.ResetSandBox()
		endif
		
	else

		if (IsRidingMount)
			; Debug.Notification("Monitor: PC UnMounted Horse")

			IsRidingMount = false

			; When dismounting, we may be in combat. So it is 
			; important to inform followers of the change as
			; quickly as possible. 

			pTweakDFScript.EvaluatePackages()
			TweakStables dTweakStables = (stables As TweakStables)
			if (dTweakStables)
				dTweakStables.OnUnMountHorse(theHorse)
			endif
		endif

		; Dialogue Detection relies on repeatable quest TweakCheck4Dialogue
		if (IsInDialogue)
			IsInDialogue = false
			ReferenceAlias NPCAlias = (pTweakCheck4Dialogue.GetAlias(0) As ReferenceAlias)
			if NPCAlias
				ObjectReference NPCRef = NPCAlias.GetActorRef()
				if NPCRef
					if NPCRef.IsInDialogueWithPlayer()
						IsInDialogue = true
					else
						OnDialogueEnd(NPCRef)
						NPCAlias.clear()
						pTweakCheck4Dialogue.Stop()
					endif
				else
					OnDialogueEnd()
					NPCAlias.clear()
					pTweakCheck4Dialogue.Stop()
				endif
			else
				OnDialogueEnd()
				pTweakCheck4Dialogue.Stop()
			endif
		else
			pTweakCheck4Dialogue.Start()
			ReferenceAlias NPCAlias = (pTweakCheck4Dialogue.GetAlias(0) As ReferenceAlias)
			if (NPCAlias && NPCAlias.GetActorRef())
				OnDialogueBegin(NPCAlias.GetActorRef())
				IsInDialogue = true
			else
				pTweakCheck4Dialogue.Stop()
			endif
		endIf

		if (0 != pTweakFollowerCount.GetValueInt())

			bool trySandBox = false
			bool endSandBox = false
			Actor player = pPlayerRef.GetActorRef()

			if (IsInDialogue && 1 == pTweakAINotWhenTalking.GetValueInt())
				if (PlayerSettled == true)
					if (0.0 != pTweakPlayerSettled.GetValue())
						Float fNewValue = pTweakPlayerSettled.Mod(-1.0)
						if (0.0 != fNewValue)
							pTweakPlayerSettled.SetValue(0.0)
						endif
					endif
					PlayerSettled = false
					endSandBox = true
				endif
			elseif (1 == pTweakAIMustSheathe.GetValueInt() && player.IsWeaponDrawn())
				if (PlayerSettled == true)
					if (0.0 != pTweakPlayerSettled.GetValue())
						Float fNewValue = pTweakPlayerSettled.Mod(-1.0)
						if (0.0 != fNewValue)
							pTweakPlayerSettled.SetValue(0.0)
						endif
					endif
					PlayerSettled = false
					endSandBox = true
				endif
			elseif (ExectionScene.IsPlaying())
				if (PlayerSettled == true)
					if (0.0 != pTweakPlayerSettled.GetValue())
						Float fNewValue = pTweakPlayerSettled.Mod(-1.0)
						if (0.0 != fNewValue)
							pTweakPlayerSettled.SetValue(0.0)
						endif
					endif
					PlayerSettled = false
					endSandBox = true
				endif
			elseif (PlayerSettled)
				trySandBox = true
					
				; We kick into a higher gear once the player is settled
				; so that we can kick out faster
	
				float xFactor = (playerPosX[2] - player.X)
				float yFactor = (playerPosY[2] - player.Y)
				float zFactor = (playerPosZ[2] - player.Z)
				float total = yFactor * yFactor
				total += xFactor * xFactor
				total += zFactor * zFactor

				; Sqrt Root is an expensive function. Avoid it unless we actually need specific distance

				if (total > SettledRadiusAdjusted)
					;Debug.Notification("Monitor: Player Moving")
					if (0.0 != pTweakPlayerSettled.GetValue())
						Float fNewValue = pTweakPlayerSettled.Mod(-1.0)
						if (0.0 != fNewValue)
							pTweakPlayerSettled.SetValue(0.0)
						endif
					endif
					PlayerSettled = false
					endSandBox = true
				endif
			else
				int delay = pTweakAITimeMode.GetValueInt()

				; delay = [0,1,2]. A new offset is recorded and shifted every 3 seconds. 
				; so delay 0 = compare against distance 9 seconds ago (min wait until settle kicks in is 9 seconds)
				; so delay 1 = compare against distance 6 seconds ago (min wait until settle kicks in is 6 seconds)
				; so delay 2 = compare against distance 3 seconds ago (min wait until settle kicks in is 3 seconds)
				
				float xFactor = (playerPosX[delay] - player.X)
				float yFactor = (playerPosY[delay] - player.Y)
				float zFactor = (playerPosZ[delay] - player.Z)
				float total = yFactor * yFactor
				total += xFactor * xFactor
				total += zFactor * zFactor

				; Sqrt Root is an expensive function. Avoid it unless we actually need specific distance

				if (total < UnSettledRadiusAdjusted)
					if (1 == pTweakAINeedCloseIdle.GetValueInt())
						; Only settle if there is an IDLE marker nearby
						pTweakCheck4Idle.Start()
						ReferenceAlias IdleAlias = (pTweakCheck4Idle.GetAlias(0) As ReferenceAlias)
						if (IdleAlias && IdleAlias.GetReference())
							if (1.0 != pTweakPlayerSettled.GetValue())
								Float fNewValue = pTweakPlayerSettled.Mod(1.0)
								if (1.0 != fNewValue)
									pTweakPlayerSettled.SetValue(1.0)
								endif
							endif
							PlayerSettled = true
							trySandBox = true
						endif
						pTweakCheck4Idle.Stop()
					else
						if (1.0 != pTweakPlayerSettled.GetValue())
							Float fNewValue = pTweakPlayerSettled.Mod(1.0)
							if (1.0 != fNewValue)
								pTweakPlayerSettled.SetValue(1.0)
							endif
						endif
						PlayerSettled = true
						trySandBox = true
					endif	
				endif
		
				;if (0 == delay)
				playerPosX[0] = playerPosX[1]
				playerPosY[0] = playerPosY[1]
				playerPosZ[0] = playerPosZ[1]
				;endif
				;if (1 == delay)
				playerPosX[1] = playerPosX[2]
				playerPosY[1] = playerPosY[2]
				playerPosZ[1] = playerPosZ[2]
				;endif
				;if (2 == delay)
				playerPosX[2] = player.X
				playerPosY[2] = player.Y
				playerPosZ[2] = player.Z
				;endif
				
			endif
		
			; only do the EVP if we've actually changed the value
			if (endSandBox)
				; ResetSandBox clears the using sandbox from all followers
				pTweakDFScript.ResetSandBox()
			endif

			if (trySandBox)
				; Try Sandbox calls evaluatePackage on followers not using 
				; their sandbox. If preceded by ResetSandbox, all followers
				; will evaluate their packages. 
				
				; Once player settles, there is a percent chance that any given follower
				; will begin to sandbox every 3 seconds. This prevents everyone from
				; sandboxing simultaneously which looks unusual. Chance is controlled
				; by global variable. pTweakAISettleProbability

				pTweakDFScript.TrySandBox()
			endif
		endif
	endif

	; do it all again
	if (Running)
		RegisterForSingleUpdate(3)
	endif

EndEvent

Function Unsettle()

	; Unsettle the player to buy you 1 min of game time 
	; to do something (typically used with transform into 
	; werewolf/vampire lord)
	
	PlayerSettled = false
	if (0 != pTweakPlayerSettled.GetValue())
		Float fNewValue = pTweakPlayerSettled.Mod(-1.0)
		if (0.0 != fNewValue)
			pTweakPlayerSettled.SetValue(0.0)
		endif
	endIf

	Actor player = pPlayerRef.GetActorRef()	
	int c = 0
	while (c < 3)
		playerPosX[c] = player.X + 1000
		playerPosY[c] = player.Y + 1000
		playerPosZ[c] = player.Z + 1000
		c += 1
	endwhile

	if (0 != pTweakMoreInteractive.GetValueInt())
		pTweakMoreInteractive.SetValueInt(0)
		; 10 min of game time = about 15 seconds real time...
		RegisterForSingleUpdateGameTime(0.15)
	endif
EndFunction

Event OnUpdateGameTime()
	pTweakMoreInteractive.SetValueInt(1)
EndEvent

Function OnChangeLocation(Location akNewLocation)
	if (!Running)
		Return
	endif
	TweakDawnGuardScript pTweakDawnGuardScript = pTweakDawnGuard As TweakDawnGuardScript
	if (pTweakDawnGuardScript && pTweakDawnGuardScript.installed)
		pTweakDawnGuardScript.OnChangeLocation(akNewLocation)
	endif
	TweakDragonBornScript pTweakDragonBornScript = pTweakDragonBorn As TweakDragonBornScript
	if (pTweakDragonBornScript && pTweakDragonBornScript.installed)
		pTweakDragonBornScript.OnChangeLocation(akNewLocation)
	endif

endFunction

Function OnSwitchRaceComplete()
	if (pTweakFollower.IsRunning())
		TweakFollowerScript pTweakFollowerScript = pTweakFollower As TweakFollowerScript
		if (pTweakFollowerScript)
			if (pPlayerRef.GetActorRef().GetRace().HasKeyword(ActorTypeNPC))
				pTweakFollowerScript.PCTransform(true)
			else
				pTweakFollowerScript.PCTransform(false)
			endif
		endif
	endif
EndFunction

Function HandleHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	if (!Running)
		Return
	endif
	if akSource
		if akSource As Ingredient || akSource As Potion
			return
		endif
		if akSource As Spell && !(akSource As Spell).IsHostile()
			return
		endif
	endif
	if akAggressor
		Actor npc = akAggressor As Actor
		if npc && npc.IsPlayerTeammate()
			return
		endif
	endif
	hit = True
	RegisterForSingleUpdate(1.0)	
EndFunction

; Deprecated
Function OnStealthDetected(ObjectReference akAggressor)
EndFunction

Function UpdateCachedGlobals()
EndFunction
